define(['marionette'], function(Marionette) {
  return Marionette.Controller.extend({
    initialize: function(arg) {
      this.app = arg.app;
    },

    /*
    			Call syntax for modal screen:
    
    			id - screens id, screen path without 'views/' prefix and '.js' suffix
    			options - will be passed to view constructor
    			callback - will be invoked after the screen will be loaded
     */
    screen: function(id, options, callback) {
      this.app.modalRegion.reset();
      if (arguments.length === 2 && typeof options === 'function') {
        callback = options;
        options = void 0;
      }
      options = options != null ? options : {};
      options.app = this.app;
      options.id = id;
      return require(['views/' + id], (function(_this) {
        return function(View) {
          _this.modalView = new View(options);
          _this.app.modalRegion.show(_this.modalView);
          if (_this.app.modalRegion.currentView) {
            $('#js-modal-container').removeClass('is-hidden');
            app.vent.trigger('modalDialog:show');
          }
          if (callback != null) {
            return callback();
          }
        };
      })(this));
    },
    close: function() {
      this.app.modalRegion.reset();
      return $('#js-modal-container').addClass('is-hidden');
    },
    hide: function() {
      return $('#js-modal-container').addClass('is-hidden');
    },
    show: function() {
      return $('#js-modal-container').removeClass('is-hidden');
    }
  });
});
