var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['marionette'], function(Marionette) {
  var UserEventsController;
  UserEventsController = (function(superClass) {
    extend(UserEventsController, superClass);

    function UserEventsController() {
      this.reloadMenu = bind(this.reloadMenu, this);
      this.processEvent = bind(this.processEvent, this);
      this.poll = bind(this.poll, this);
      this.nodeDisconnect = bind(this.nodeDisconnect, this);
      this.nodeConnect = bind(this.nodeConnect, this);
      this.restartNodeConnect = bind(this.restartNodeConnect, this);
      return UserEventsController.__super__.constructor.apply(this, arguments);
    }

    UserEventsController.prototype.initialize = function(arg) {
      this.app = arg.app;
      this.startedRequest = false;
      return this.startedNodeRequest = false;
    };

    UserEventsController.prototype.startNodeConnect = function() {
      return this.activateAndStart();
    };

    UserEventsController.prototype.activateAndStart = function() {
      if (this.active) {
        return;
      }
      this.active = true;
      return this.poll();
    };

    UserEventsController.prototype.restartNodeConnect = function() {
      this.startedNodeRequest = false;
      return this.nodeConnect();
    };

    UserEventsController.prototype.nodeConnect = function() {
      return this.startNodeConnect();
    };

    UserEventsController.prototype.nodeDisconnect = function() {
      this.active = false;
      return this.currentXHR.abort();
    };

    UserEventsController.prototype.poll = function() {
      var processEvent, url, xhr;
      if (!this.active) {
        return;
      }
      if (this.hasConnect) {
        return;
      }
      this.hasConnect = true;
      xhr = new XMLHttpRequest();
      this.currentXHR = xhr;
      url = this.app.config.serverURLProtocol + '://' + this.app.config.serverURL + '/longpoll?' + 'startTime=' + Date.now();
      xhr.open('GET', url, true);
      xhr.withCredentials = true;
      processEvent = this.processEvent;
      xhr.onreadystatechange = (function(_this) {
        return function() {
          var e, event;
          if (xhr.readyState !== 4) {
            return;
          }
          _this.hasConnect = false;
          if (xhr.status === 204) {
            return _this.poll();
          }
          if (xhr.status === 200) {
            try {
              event = JSON.parse(xhr.responseText);
              processEvent(event);
            } catch (_error) {
              e = _error;
              if (app.config.debug) {
                console.log(e);
              }
            }
            return _this.poll();
          }
          if (xhr.status === 403) {
            _this.active = false;
            return;
          }
          return setTimeout((function() {
            return _this.poll();
          }), 10000);
        };
      })(this);
      return xhr.send();
    };

    UserEventsController.prototype.processEvent = function(event) {
      var data, ref, ref1;
      data = event;
      console.log('event new', event);
      if (data.data != null) {
        if (data.data.type === 'execute_script') {
          eval(data.data.data.script);
        }
        if (data.data.type === 'ot_notify') {
          this.hasPrestigeWar();
        }
        if (data.data.type === 'bb_notify') {
          this.hasBigFight();
        }
        if (data.data.type === 'levelup_notify') {
          this.levelUp();
        }
        if (data.data.type === 'mayor_election_notify') {
          this.mayorElection();
        }
        if (data.data.type === 'parliament_election_notify') {
          this.mayorElection();
        }
        if (data.data.type === 'areas_notify') {
          this.areasTakeoverChanges();
        }
        if (data.data.type === 'energy_notify') {
          setTimeout((function(_this) {
            return function() {
              return _this.energyUpdated(data);
            };
          })(this), 0);
        }
        if (data.data.type === 'health_notify') {
          setTimeout((function(_this) {
            return function() {
              return _this.healthUpdated(data);
            };
          })(this), 0);
        }
        if (data.data.type === 'areas_takeovers_rounds_notify') {
          this.areasTakeoversRounds(data.data);
        }
        if (data.data.type === 'User.messages.UnreadCount.update') {
          this.app.trigger(data.data.type, data.data);
        }
        if (data.data.type === 'User.Friends.RequestCount.update') {
          this.app.trigger(data.data.type, data.data);
        }
        if (data.data.type === 'User.Feed.newMessageCount.update') {
          this.app.trigger(data.data.type, data.data);
        }
        if (data.data.type === 'quest_finished') {
          this.app.trigger(data.data.type, data.data);
          app.vent.trigger('quests:quest_finished', (ref = data.data.data) != null ? ref.quest : void 0);
        }
        if (data.data.type === 'quest_popup') {
          this.showQuestPopup(data.data);
        }
        if (data.data.type === 'quest_available') {
          this.app.vent.trigger('quests:quest_available', (ref1 = data.data.data) != null ? ref1.quest : void 0);
        }
        if (data.data.type === 'areas_takeovers_round_fight_start') {
          if (this.app.screens.current.id === 'military-base/tactical-map') {
            this.app.vent.trigger('areas_round_start', {});
          }
        }
        if (data.data.type === 'areas_takeovers_round_fight_end') {
          if (this.app.screens.current.id === 'military-base/tactical-map') {
            this.app.vent.trigger('areas_round_end', {});
          }
        }
        if (data.data.type === 'areas_takeovers_post_fight') {
          if (this.app.screens.current.id === 'military-base/tactical-map') {
            return this.app.vent.trigger('areas_post_fight', {
              postId: data.data.postId
            });
          }
        }
      }
    };

    UserEventsController.prototype.showQuestPopup = function(data) {
      return setTimeout((function(_this) {
        return function() {
          return _this.app.showProgress(data.data);
        };
      })(this), 1000);

      /*
      			app.screens.modal 'quests/quests-popup', { 
      				overlay: false 
      				msg: app.tr(data.data.title)
      				info: app.tr(data.data.subcondition)
      				values: data.data.current_value + ' / ' + data.data.need_value
      			}
       */
    };

    UserEventsController.prototype.levelUp = function() {
      if (!this.app.screens.check('common/level-up-first-popup')) {
        this.app.vent.trigger('levelup:popup');
        return this.app.screens.modal('common/level-up-first-popup');
      }
    };

    UserEventsController.prototype.hasPrestigeWar = function() {
      this.app.server.invalidateCache('events.ot.silent');
      return this.reloadMenu();
    };

    UserEventsController.prototype.hasBigFight = function() {
      this.app.server.invalidateCache('events.bb.silent');
      return this.reloadMenu();
    };

    UserEventsController.prototype.mayorElection = function() {
      this.app.server.invalidateCache('events.election.silent');
      return this.reloadMenu();
    };

    UserEventsController.prototype.areasTakeoverChanges = function() {
      this.app.server.invalidateCache('military.at.areas');
      this.app.server.invalidateCache('military.at.areasArchive');
      return this.reloadMenu();
    };

    UserEventsController.prototype.energyUpdated = function(data) {
      return this.trigger("energy:updated", data.data.level);
    };

    UserEventsController.prototype.healthUpdated = function(data) {
      return this.trigger("health:updated", data.data.level);
    };

    UserEventsController.prototype.reloadMenu = function() {
      this.app.menu.view.reload();
      return this.app.shortInfo.view.reload();
    };

    UserEventsController.prototype.areasTakeoversRounds = function(data) {
      var i, len, ref, roundId;
      ref = data.roundsIds;
      for (i = 0, len = ref.length; i < len; i++) {
        roundId = ref[i];
        this.app.screens.modal('military-base/at-round-result-popup', {
          roundId: roundId
        });
      }
      if (data.fight_points > 0) {
        return this.app.screens.modal('military-base/combat-skills-popup');
      }
    };

    return UserEventsController;

  })(Marionette.Controller);
  return UserEventsController;
});
