var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['underscore', 'backbone'], function(_, Backbone) {
  var Translation, Translations;
  Translation = (function(superClass) {
    extend(Translation, superClass);

    Translation.prototype._cacheLocales = null;

    Translation.prototype.defaults = function() {
      return {
        id: null,
        locale: null,
        variable: null,
        translation: null
      };
    };

    function Translation(options) {
      Translation.__super__.constructor.call(this, options);
    }

    return Translation;

  })(Backbone.Model);
  Translations = (function(superClass) {
    extend(Translations, superClass);

    function Translations() {
      return Translations.__super__.constructor.apply(this, arguments);
    }

    Translations.prototype.model = Translation;

    Translations.prototype.localeToLn = {
      'rus': 'ru',
      'eng': 'en',
      'pol': 'pl'
    };

    Translations.prototype.initialize = function(models, options) {
      var recentLocale;
      this.app = options.app;
      recentLocale = localStorage.getItem('recent_locale');
      if (recentLocale) {
        this.locale = this.recentLocale;
      }
      this.on("reset", this.createCache);
      return this.on("add", this.createCache);
    };

    Translations.prototype.fetch = function(options) {
      var collection, locale;
      collection = this;
      locale = this.locale != null ? this.locale : 'eng';
      return this.loadFromLocal(collection, locale, options);
    };

    Translations.prototype.loadFromLocal = function(collection, locale, options) {
      return $.ajax('scripts/translations/' + locale + '.js', {
        success: function(data) {
          var translationsData, translationsLastUpdate;
          translationsLastUpdate = data['translationsLastUpdate'];
          translationsData = data['translations'];
          collection.reset(translationsData);
          return collection.MergeFromServer(collection, locale, translationsLastUpdate, options);
        },
        error: function(jqXHR, textStatus, errorThrown) {
          collection.reset();
          return collection.MergeFromServer(collection, locale, 0, options);
        },
        dataType: 'json'
      });
    };

    Translations.prototype.MergeFromServer = function(collection, locale, translationsLastUpdate, options) {
      var url;
      url = app.config.serverURLProtocol + '://' + app.config.serverURL + '/translations/get/' + locale + '.json';
      return $.ajax(url, {
        type: 'POST',
        data: {
          'translationsLastUpdate': translationsLastUpdate
        },
        success: function(data) {
          collection.add(data, {
            merge: true
          });
          if (options != null ? options.success : void 0) {
            return options.success(collection, data, options);
          }
        },
        error: function(xhr, textStatus, errorThrown) {
          if (options != null ? options.error : void 0) {
            return options.error();
          }
        }
      });
    };

    Translations.prototype.url = function() {
      return this.app.config.serverURLProtocol + '://' + this.app.config.serverURL + (this.locale != null ? "/translations/get/" + this.locale + ".json" : "/translations/get.json");
    };

    Translations.prototype.setLocale = function(locale) {
      this._cacheLocales = null;
      this.locale = locale;
      this._cacheLocales = null;
      return localStorage.setItem('recent_locale', locale);
    };

    Translations.prototype.getLocale = function() {
      return this.locale;
    };

    Translations.prototype.getLn = function() {
      if (this.localeToLn[this.locale] != null) {
        return this.localeToLn[this.locale];
      } else {
        return this.localeToLn['eng'];
      }
    };

    Translations.prototype.setLocaleAndFetch = function(locale, callback) {
      this.setLocale(locale);
      return this.fetch({
        success: (function(_this) {
          return function(collection, response, options) {
            if (callback != null) {
              return callback();
            }
          };
        })(this),
        error: (function(_this) {
          return function(collection, response, options) {
            if (callback != null) {
              return callback();
            }
          };
        })(this)
      });
    };

    Translations.prototype.tr = function(variable, locale) {
      var ref;
      if (locale == null) {
        locale = null;
      }
      if ((ref = this._cacheLocales) != null ? ref[variable] : void 0) {
        return this._cacheLocales[variable];
      } else {
        return variable;
      }
    };

    Translations.prototype.createCache = function() {
      this._cacheLocales = {};
      return this.each((function(_this) {
        return function(model, index) {
          return _this._cacheLocales[model.get('variable')] = model.get('translation');
        };
      })(this));
    };

    return Translations;

  })(Backbone.Collection);
  return Translations;
});
