'use strict';
require.config({
  paths: {
    'modernizr': '../bower_components/modernizr/modernizr',
    'velocity': '../bower_components/velocity/velocity',
    'bounce': '../bower_components/bounce.js/bounce.min',
    'velocity-ui': '../bower_components/velocity/velocity.ui',
    'sortable': '../bower_components/Sortable/Sortable',
    'text': '../bower_components/requirejs-text/text',
    'json': '../bower_components/requirejs-plugins/src/json',
    'jquery': '../bower_components/jquery/dist/jquery',
    'underscore': '../bower_components/underscore/underscore',
    'backbone': '../bower_components/backbone/backbone',
    'backbone.babysitter': '../bower_components/backbone.babysitter/lib/backbone.babysitter',
    'backbone.queryparams': '../bower_components/backbone-query-parameters/backbone.queryparams',
    'backbone.queryparams-1.1-shim': '../bower_components/backbone-query-parameters/backbone.queryparams-1.1-shim',
    'backbone.wreqr': '../bower_components/backbone.wreqr/lib/backbone.wreqr',
    'marionette': '../bower_components/marionette/lib/core/backbone.marionette',
    'moment': '../bower_components/moment/min/moment-with-locales',
    'jquery.countdown': '../bower_components/jquery.countdown/dist/jquery.countdown',
    'fastclick': '../bower_components/fastclick/lib/fastclick',
    'clusterize': '../bower_components/clusterize/clusterize',
    'ga': '../analytics',
    'chat': './chat/chat',
    'chosen': '../bower_components/chosen/chosen.jquery.min',
    'md5': '../bower_components/md5/build/md5.min'
  },
  shim: {
    underscore: {
      exports: '_'
    },
    modernizr: {
      exports: 'Modernizr'
    },
    backbone: {
      deps: ['jquery', 'underscore'],
      exports: 'Backbone'
    },
    'backbone.paginator': {
      deps: ['backbone', 'underscore']
    },
    'backbone.babysitter': {
      deps: ['backbone', 'underscore']
    },
    'backbone.wreqr': {
      deps: ['backbone', 'underscore']
    },
    marionette: {
      deps: ['backbone'],
      exports: 'Marionette'
    },
    'jquery.countdown': {
      deps: ['jquery']
    },
    'velocity': {
      deps: ['jquery']
    },
    'velocity-ui': {
      deps: ['velocity']
    },
    app: {
      deps: ['ga']
    },
    "ga": {
      exports: "ga"
    },
    "chat": {
      exports: "chat"
    }
  }
});

require(['app', 'options', 'version'], function(app, options, version) {
  var onDeviceReady;
  options.version = version;
  onDeviceReady = function() {
    return app.start(options);
  };
  if (window.isCordova === true) {
    return document.addEventListener("deviceready", onDeviceReady, false);
  } else {
    return onDeviceReady();
  }
});
