define(['services/social/fb', 'services/social/vk', 'services/social/google'], function(FBProvider, VKProvider, GoogleProvider) {
  var Social;
  Social = (function() {
    Social.prototype._configs = {};

    function Social(configs, serverUrl, serverProtocol) {
      var config, type;
      this._configs = {};
      for (type in configs) {
        config = configs[type];
        config.serverUrl = serverUrl;
        config.serverProtocol = serverProtocol;
        this._configs[type] = config;
      }
      this._providers = {
        fb: FBProvider,
        vk: VKProvider,
        google: GoogleProvider
      };
    }

    Social.prototype.getProvider = function(name) {
      if (this._providers[name] != null) {
        return new this._providers[name](name, this._configs[name]);
      }
    };

    return Social;

  })();
  return Social;
});
