var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['underscore', 'views/item-view', 'text!templates/auto_login.tmpl'], function(_, ItemView, template) {
  var AutoLoginView;
  AutoLoginView = (function(superClass) {
    extend(AutoLoginView, superClass);

    function AutoLoginView() {
      this.auth_token = bind(this.auth_token, this);
      this.auth = bind(this.auth, this);
      return AutoLoginView.__super__.constructor.apply(this, arguments);
    }

    AutoLoginView.prototype.className = 'sign-in-layout';

    AutoLoginView.prototype.template = template;

    AutoLoginView.prototype.initialize = function(options) {
      AutoLoginView.__super__.initialize.call(this, options);
      return this.autoLogin();
    };

    AutoLoginView.prototype.autoLogin = function() {
      var login, password, ref;
      if (localStorage.auth != null) {
        ref = JSON.parse(localStorage.auth), login = ref.login, password = ref.password;
        return this.auth(login, password);
      } else if (localStorage.auth_token != null) {
        return this.auth_token();
      } else {
        if (this.options.user_id != null) {
          return this.app.screens.main('login', {
            user_id: this.options.user_id
          });
        } else {
          return this.app.screens.main('login');
        }
      }
    };

    AutoLoginView.prototype._startTutorial = function(data) {
      return ((data.trigger_tutorial != null) && data.trigger_tutorial) || ((data.in_tutorial != null) && data.in_tutorial);
    };

    AutoLoginView.prototype.auth = function(login, password) {
      return this.app.server.auth({
        login: login,
        password: password,
        success: (function(_this) {
          return function(data) {
            var tutorialCb;
            _this.app.menu.init();
            _this.app.shortInfo.init();
            _this.app.pushNotifications.init();
            _this.app.setUserId(data.userId);
            _this.app.setUserRegistrationSource(data.registration_source != null ? data.registration_source : "");
            _this.app.vent.trigger('auth:login', {
              user_id: data.userId
            });
            _this.app.ga('set', 'dimension', '2', data.level.toString());
            _this.app.ga('set', 'dimension', '3', data.cityName);
            tutorialCb = function() {
              var androidTutorOn, browserTutorOn, iosTutorOn, mobileTutorOn, platform;
              if (_this._startTutorial(data) || app.tutorial.hasUnfinishedSteps()) {
                platform = app.detectPlatform();
                iosTutorOn = data.ios_tutor != null ? data.ios_tutor : false;
                androidTutorOn = data.android_tutor != null ? data.android_tutor : true;
                mobileTutorOn = data.mobile_tutor != null ? data.mobile_tutor : true;
                browserTutorOn = data.browser_tutor != null ? data.browser_tutor : true;
                if (platform === 'ios' && iosTutorOn && mobileTutorOn) {
                  return _this.app.tutorial.start();
                } else if (platform === 'android' && androidTutorOn && mobileTutorOn) {
                  return _this.app.tutorial.start();
                } else if (platform === 'browser' && browserTutorOn) {
                  return _this.app.tutorial.start();
                }
              }
            };
            if ((data.registration_bonus != null) && data.registration_bonus) {
              app.vent.listenToOnce(app.screens, 'view:ready:quests', function() {
                return app.screens.modal('common/registration-bonus', {
                  backCallback: tutorialCb
                });
              });
            } else {
              app.vent.listenToOnce(app.screens, 'view:ready:quests', tutorialCb);
            }
            if (data.quick_reg_lock) {
              return _this.app.server.trigger('app:quick_reg_lock');
            } else {
              if (_this.options.user_id != null) {
                _this.app.screens.main('users/profile', {
                  userId: _this.options.user_id
                });
              } else {
                _this.app.screens.main('quests');
              }
            }
            return app.chat.start();
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            var ref, ref1;
            if (data.isConnectionError) {
              _this.app.screens.modal('common/info-popup', {
                msg: _this.app.tr("Failed to connect to server"),
                btnText: _this.app.tr("Try again"),
                callback: function() {
                  return _this.autoLogin();
                }
              });
              return;
            }
            if (((ref = data.setFlash) != null ? ref[0].msg : void 0) === "INCORRECT_CLIENT_VERSION") {
              app.screens.main('app_incorrect_version');
              return;
            }
            delete localStorage.auth;
            delete localStorage.auth_token;
            localStorage.removeItem("auth");
            localStorage.removeItem("auth_token");
            _this.app.screens.modal('common/info-popup', {
              msg: ((ref1 = data.setFlash) != null ? ref1[0].msg : void 0) || _this.app.tr("Incorrect login or password")
            });
            return _this.app.screens.main('login');
          };
        })(this)
      });
    };

    AutoLoginView.prototype.auth_token = function() {
      return this.app.server.auth_token({
        auth_token: localStorage.auth_token,
        success: (function(_this) {
          return function(data) {
            var tutorialCb;
            _this.app.setUserId(data.userId);
            tutorialCb = function() {
              var androidTutorOn, browserTutorOn, iosTutorOn, mobileTutorOn, platform;
              if (_this._startTutorial(data) || app.tutorial.hasUnfinishedSteps()) {
                platform = app.detectPlatform();
                iosTutorOn = data.ios_tutor != null ? data.ios_tutor : false;
                androidTutorOn = data.android_tutor != null ? data.android_tutor : true;
                mobileTutorOn = data.mobile_tutor != null ? data.mobile_tutor : true;
                browserTutorOn = data.browser_tutor != null ? data.browser_tutor : true;
                if (platform === 'ios' && iosTutorOn && mobileTutorOn) {
                  return _this.app.tutorial.start();
                } else if (platform === 'android' && androidTutorOn && mobileTutorOn) {
                  return _this.app.tutorial.start();
                } else if (platform === 'browser' && browserTutorOn) {
                  return _this.app.tutorial.start();
                }
              }
            };
            if ((data.registration_bonus != null) && data.registration_bonus) {
              app.vent.listenToOnce(app.screens, 'view:ready:quests', function() {
                return app.screens.modal('common/registration-bonus', {
                  backCallback: tutorialCb
                });
              });
            } else {
              app.vent.listenToOnce(app.screens, 'view:ready:quests', tutorialCb);
            }
            _this.app.screens.main('quests');
            _this.app.menu.init();
            _this.app.shortInfo.init();
            _this.app.pushNotifications.init();
            _this.app.vent.trigger('auth:login', {
              user_id: data.userId
            });
            return _this.app.chat.start();
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            var ref;
            localStorage.removeItem('auth_token');
            _this.app.screens.modal('common/info-popup', {
              msg: ((ref = data.setFlash) != null ? ref[0].msg : void 0) || _this.app.tr("Session expired")
            });
            return _this.app.screens.main('login');
          };
        })(this)
      });
    };

    return AutoLoginView;

  })(ItemView);
  return AutoLoginView;
});
