var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['underscore', 'app', 'views/item-view', 'text!templates/blueprints/create-finish.tmpl'], function(_, app, ItemView, template) {
  var BlueprintsCreateView;
  BlueprintsCreateView = (function(superClass) {
    extend(BlueprintsCreateView, superClass);

    function BlueprintsCreateView() {
      return BlueprintsCreateView.__super__.constructor.apply(this, arguments);
    }

    BlueprintsCreateView.prototype.template = template;

    BlueprintsCreateView.prototype.className = 'no-bg-image';

    BlueprintsCreateView.prototype.events = {
      'click .js-create': 'onCreateBtnClick',
      'click .js-reset': 'onResetBtnClick',
      'click .js-select-logo': 'onLogoBtnClick',
      'click .js-blueprint-group-toggle': 'onGroupClick'
    };

    BlueprintsCreateView.prototype.initialize = function(options) {
      BlueprintsCreateView.__super__.initialize.call(this, options);
      return this._reset();
    };

    BlueprintsCreateView.prototype.onDestroy = function() {
      return this._reset();
    };

    BlueprintsCreateView.prototype._reset = function() {
      return this._logo = null;
    };

    BlueprintsCreateView.prototype.validateUserValues = function() {
      var descriptionEl, errors, regExp, titleEl;
      errors = [];
      regExp = new RegExp('[^A-z0-9\\_\\.\\s]+');
      titleEl = this.el.querySelector('#js-item-title');
      if (!titleEl || titleEl.value.trim().length < 1) {
        errors.push(app.tr('Item title is empty'));
      }
      if (regExp.test(titleEl.value)) {
        errors.push(app.tr('Item title must contain only latin characters, space and dot'));
      }
      descriptionEl = this.el.querySelector('#js-item-description');
      if (!descriptionEl || descriptionEl.value.trim().length < 1) {
        errors.push(app.tr('Item Description is empty'));
      }
      if (regExp.test(descriptionEl.value)) {
        errors.push(app.tr('Item description must contain only latin characters, space and dot'));
      }
      if (!this._logo || !this._logo.id) {
        errors.push(app.tr('Logo is empty'));
      }
      return errors;
    };

    BlueprintsCreateView.prototype.displayErrors = function(errors) {
      if (errors.length > 0) {
        return app.screens.modal('common/info-popup', {
          msg: errors[0]
        });
      }
    };

    BlueprintsCreateView.prototype.onLogoBtnClick = function(event) {
      return app.screens.dialog('blueprints/select-logo', {
        group: this.options.userValues.type.toLowerCase(),
        callback: (function(_this) {
          return function(logo) {
            _this._logo = logo;
            return _this.render();
          };
        })(this)
      });
    };

    BlueprintsCreateView.prototype.onResetBtnClick = function() {
      return app.screens.main('blueprints/create');
    };

    BlueprintsCreateView.prototype.onCreateBtnClick = function() {
      var blueprint, errors;
      errors = this.validateUserValues();
      if (errors.length) {
        this.displayErrors(errors);
        return;
      }
      blueprint = _.clone(this.options.userValues);
      blueprint.title = this.el.querySelector('#js-item-title').value;
      blueprint.description = this.el.querySelector('#js-item-description').value;
      blueprint.logo_id = this._logo.id;
      blueprint.logo_code = this._logo.code || null;
      return app.server.blueprints.create({
        blueprint: JSON.stringify(blueprint),
        success: function(data) {
          return app.screens.modal('common/success-popup', {
            msg: app.tr('Blueprint created'),
            callback: function() {
              return app.screens.main('profile');
            }
          });
        },
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr('Server error')
          });
        }
      });
    };

    BlueprintsCreateView.prototype.onGroupClick = function(event) {};

    BlueprintsCreateView.prototype.serializeData = function() {
      var data, itemProperties, prop, ref, value;
      data = BlueprintsCreateView.__super__.serializeData.call(this);
      itemProperties = {};
      ref = this.options.computedValues.properties;
      for (prop in ref) {
        value = ref[prop];
        itemProperties[this.options.properties[prop]] = value;
      }
      data.logo = this._logo;
      data.itemProperties = itemProperties;
      data.computedValues = this.options.computedValues;
      return data;
    };

    return BlueprintsCreateView;

  })(ItemView);
  return BlueprintsCreateView;
});
