var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['underscore', 'app', 'views/common/list-view', 'text!templates/blueprints/logotypes/user-list.tmpl', 'text!templates/blueprints/blocks/common-logo-list.tmpl'], function(_, app, CommonListView, template, listTemplate) {
  var UserLogoView;
  UserLogoView = (function(superClass) {
    extend(UserLogoView, superClass);

    function UserLogoView() {
      return UserLogoView.__super__.constructor.apply(this, arguments);
    }

    UserLogoView.prototype.template = template;

    UserLogoView.prototype.listTemplate = _.template(listTemplate);

    UserLogoView.prototype.className = 'no-bg-image';

    UserLogoView.prototype.events = {
      'click .js-select-group': 'onGroupSelectBtnClick',
      'click #js-main-list-load-more': 'onLoadMore'
    };

    UserLogoView.prototype._groups = {
      '-': app.tr('All'),
      'expendables': app.tr('Expendables'),
      'equipment': app.tr('Equipment'),
      'arms': app.tr('Arms'),
      'furniture': app.tr('Furniture')
    };

    UserLogoView.prototype.initialize = function(options) {
      UserLogoView.__super__.initialize.call(this, options);
      this.options.showStatus = true;
      this.options.showCode = true;
      this._group = this.options.group && this._groups[this.options.group] ? this.options.group : null;
      if (this._group) {
        this.options.group = this._groups[this.options.group];
      }
      this._elements = [];
      app.hideLoader();
      this._initialized = false;
      return this.on('dom:refresh', (function(_this) {
        return function() {
          if (!_this._initialized) {
            _this._initialized = true;
            return _this._reloadMainList({
              page: 1,
              group: _this._group
            });
          }
        };
      })(this));
    };

    UserLogoView.prototype.onGroupSelectBtnClick = function(event) {
      var group;
      group = event.currentTarget.dataset.group;
      group = name.trim();
      return app.screens.modal('common/simple-select-dialog', {
        values: this._groups,
        selected: group,
        callback: (function(_this) {
          return function(group) {
            _this._group = group;
            event.currentTarget.innerText = _this._groups[group];
            event.currentTarget.dataset.group = group;
            return _this._reloadMainList({
              group: group,
              page: 1
            });
          };
        })(this)
      });
    };

    UserLogoView.prototype.onLoadMore = function(event) {
      var page;
      page = Number(event.currentTarget.getAttribute('data-page'));
      return this._appendPageToMainList({
        group: this._group,
        page: page
      });
    };

    UserLogoView.prototype._reloadMainList = function(options) {
      var container, self;
      container = this.el.querySelector('#js-main-list-content');
      self = this;
      self.lockUI();
      self._showListLoader(container);
      return $.when(self._clearAllLists(), self._loadElements(options)).then(function(ign, data) {
        self._elements = data.elements;
        self.unlockUI();
        self._hideListLoader(container);
        return self._renderList(container, data.elements, data.page, data.hasNext);
      });
    };

    UserLogoView.prototype._appendPageToMainList = function(options) {
      var container, self;
      container = this.el.querySelector('#js-main-list-content');
      self = this;
      self.lockUI();
      self._showListLoader(container);
      return self._loadElements(options).then(function(data) {
        self._elements = self._elements.concat(data.elements);
        self.unlockUI();
        self._hideListLoader(container);
        return self._renderList(container, data.elements, data.page, data.hasNext);
      });
    };

    UserLogoView.prototype._loadElements = function(options) {
      var deferred, self;
      deferred = $.Deferred();
      options = options || {};
      self = this;
      app.server.blueprints.logo.user_list({
        group: options.group || null,
        page: options.page || 1,
        success: function(data) {
          var resultData;
          resultData = {
            elements: data.list || []
          };
          resultData.page = options.page || 1;
          resultData.hasNext = data.has_next || false;
          return deferred.resolve(resultData);
        },
        error: function() {
          return deferred.resolve({
            elements: [],
            page: 1,
            hasNext: false
          });
        }
      });
      return deferred;
    };

    return UserLogoView;

  })(CommonListView);
  return UserLogoView;
});
