var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['underscore', 'app', 'views/common/list-view', 'text!templates/blueprints/select-logo.tmpl', 'text!templates/blueprints/blocks/select-logo-list.tmpl'], function(_, app, CommonListView, template, listTemplate) {
  var SelectLogoView;
  SelectLogoView = (function(superClass) {
    extend(SelectLogoView, superClass);

    function SelectLogoView() {
      return SelectLogoView.__super__.constructor.apply(this, arguments);
    }

    SelectLogoView.prototype.template = template;

    SelectLogoView.prototype.listTemplate = _.template(listTemplate);

    SelectLogoView.prototype.className = 'no-bg-image';

    SelectLogoView.prototype.events = {
      'click .js-buy-logo': 'onLogoBtnClick',
      'click #js-main-list-load-more': 'onLoadMore',
      'change .js-logo-code': 'onLogoCodeChange'
    };

    SelectLogoView.prototype._groups = {
      '-': app.tr('All'),
      'expendables': app.tr('Expendables'),
      'equipment': app.tr('Equipment'),
      'arms': app.tr('Arms'),
      'furniture': app.tr('Furniture')
    };

    SelectLogoView.prototype.initialize = function(options) {
      SelectLogoView.__super__.initialize.call(this, options);
      this._group = this.options.group && this._groups[this.options.group] ? this.options.group : null;
      if (this._group) {
        this.options.group = this._groups[this.options.group];
      }
      this._elements = [];
      return this.on('ready', (function(_this) {
        return function() {
          return _this._reloadMainList({
            page: 1,
            group: _this._group
          });
        };
      })(this));
    };

    SelectLogoView.prototype.onLogoBtnClick = function(event) {
      var callback, element, i, id, len, ref, result;
      id = Number(event.currentTarget.dataset.id);
      result = null;
      ref = this._elements;
      for (i = 0, len = ref.length; i < len; i++) {
        element = ref[i];
        if (element.id === id) {
          result = element;
          break;
        }
      }
      if (event.currentTarget.dataset.code) {
        result.code = event.currentTarget.dataset.code;
      }
      if (this.options.callback) {
        callback = this.options.callback;
        return app.screens.back(function() {
          return callback(result);
        });
      } else {
        return app.screens.back();
      }
    };

    SelectLogoView.prototype.onLogoCodeChange = function(event) {
      var buttonEl, code, codeEl, id;
      id = Number(event.currentTarget.dataset.id);
      code = event.currentTarget.value;
      codeEl = this.el.querySelector('#js-logo-code-' + id);
      buttonEl = this.el.querySelector('#js-logo-buy-' + id);
      return app.server.blueprints.logo.check_code({
        logoId: id,
        code: code,
        success: function(data) {
          app.hideLoader();
          if (data && data.status) {
            codeEl.classList.toggle('is-hidden');
            buttonEl.classList.remove('is-hidden');
            return buttonEl.firstElementChild.dataset.code = code;
          } else {
            return app.screens.modal('common/info-popup', {
              msg: app.tr('Invalid logotype code')
            });
          }
        },
        error: function(data) {
          app.hideLoader();
          return app.screens.modal('common/info-popup', {
            msg: app.tr('Invalid logotype code')
          });
        }
      });
    };

    SelectLogoView.prototype.onLoadMore = function(event) {
      var page;
      page = Number(event.currentTarget.getAttribute('data-page'));
      return this._appendPageToMainList({
        group: this._group,
        page: page
      });
    };

    SelectLogoView.prototype._reloadMainList = function(options) {
      var container, self;
      container = this.el.querySelector('#js-main-list-content');
      self = this;
      self.lockUI();
      self._showListLoader(container);
      return $.when(self._clearAllLists(), self._loadElements(options)).then(function(ign, data) {
        self._elements = data.elements;
        self.unlockUI();
        self._hideListLoader(container);
        return self._renderList(container, data.elements, data.page, data.hasNext);
      });
    };

    SelectLogoView.prototype._appendPageToMainList = function(options) {
      var container, self;
      container = this.el.querySelector('#js-main-list-content');
      self = this;
      self.lockUI();
      self._showListLoader(container);
      return self._loadElements(options).then(function(data) {
        self._elements = self._elements.concat(data.elements);
        self.unlockUI();
        self._hideListLoader(container);
        return self._renderList(container, data.elements, data.page, data.hasNext);
      });
    };

    SelectLogoView.prototype._loadElements = function(options) {
      var deferred, self;
      deferred = $.Deferred();
      options = options || {};
      self = this;
      app.server.blueprints.logo.list({
        group: options.group || null,
        page: options.page || 1,
        success: function(data) {
          var resultData;
          resultData = {
            elements: data.list || []
          };
          resultData.page = options.page || 1;
          resultData.hasNext = data.has_next || false;
          return deferred.resolve(resultData);
        },
        error: function() {
          return deferred.resolve({
            elements: [],
            page: 1,
            hasNext: false
          });
        }
      });
      return deferred;
    };

    return SelectLogoView;

  })(CommonListView);
  return SelectLogoView;
});
