var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/business/common.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  var BusinessCommonView;
  BusinessCommonView = (function(superClass) {
    extend(BusinessCommonView, superClass);

    function BusinessCommonView() {
      this.showReports = bind(this.showReports, this);
      this.initialize = bind(this.initialize, this);
      return BusinessCommonView.__super__.constructor.apply(this, arguments);
    }

    BusinessCommonView.prototype.template = template;

    BusinessCommonView.prototype.data = {
      companyInfo: {
        pointer: 'business.companyInfo',
        companyId: function() {
          return this.options.companyId;
        }
      },
      info: 'user.info.short',
      effects: {
        pointer: 'business.company.effects',
        companyId: function() {
          return this.options.companyId;
        }
      },
      'business': 'business.corporationList'
    };

    BusinessCommonView.prototype.events = {
      'click .js-goto-employees': 'gotoEmployees',
      'click .js-goto-storage': 'gotoStorage',
      'click .js-add-funds': 'addFunds',
      'click .js-take-funds': 'takeFunds',
      'click .js-begin-work': 'beginWork',
      'click .js-settings': 'settings',
      'click .js-change-prod': 'changeProd',
      'click .c-btn-group__button': 'changeEnergy',
      'click .js-toggle-effects': 'showEffects',
      'click .js-reports-archive': 'showReports',
      'click .js-generate-report': 'generateReport',
      'click .js-reports-switcher': 'reportsToggle',
      'click .js-back': 'jsBack'
    };

    BusinessCommonView.prototype.needReload = false;

    BusinessCommonView.prototype.changeEnergy = function(event) {
      var activeStateClass, btn, buttons, disabledStateClass, el, i, len;
      btn = event.currentTarget;
      buttons = btn.parentNode.querySelectorAll('.c-btn-group__button');
      activeStateClass = 'c-btn-group__button--active';
      disabledStateClass = 'c-btn-group__button--disabled';
      if (!$(btn).hasClass(disabledStateClass)) {
        for (i = 0, len = buttons.length; i < len; i++) {
          el = buttons[i];
          if (el.classList) {
            el.classList.remove(activeStateClass);
          } else {
            el.activeStateClass = el.activeStateClass.replace(new RegExp('(^|\\b)' + activeStateClass.split(' ').join('|') + '(\\b|$)', 'gi'), ' ');
          }
        }
        if (btn.classList) {
          return btn.classList.add(activeStateClass);
        } else {
          return btn.activeStateClass += ' ' + activeStateClass;
        }
      }
    };

    BusinessCommonView.prototype.initialize = function(options1) {
      this.options = options1;
      this.listenTo(app.userEvents, "energy:updated", this.updateEnergyField);
      this.listenTo(app.userEvents, "popup:closed", this.setMaxButton);
      if ((this.options.activeEnergy != null) === false) {
        this.options.activeEnergy = 50;
      }
      this.setMaxButton();
      return BusinessCommonView.__super__.initialize.call(this, this.options);
    };

    BusinessCommonView.prototype.reportsToggle = function() {
      return $('.js-reports-buttons').toggle().removeClass('u-hide');
    };

    BusinessCommonView.prototype.jsBack = function() {
      return app.screens.back(null, {
        needReload: false
      }, 'refresh:company', +this._data.options.companyId);
    };


    /*
    			This method triggers then energy is updated
     */

    BusinessCommonView.prototype.updateEnergyField = function(newEnergy) {
      this.invalidateCacheAndReload();
      return this.buttonsEnergyState();
    };

    BusinessCommonView.prototype.setMaxButton = function() {
      var btn, btnEnergyValue, buttons, i, len, maxValue, results, valuesArr;
      buttons = this.el.querySelectorAll('.c-btn-group--energy .c-btn-group__button');
      valuesArr = this.buttonsEnergyState();
      maxValue = Math.max.apply(this, valuesArr);
      results = [];
      for (i = 0, len = buttons.length; i < len; i++) {
        btn = buttons[i];
        btnEnergyValue = parseInt(btn.querySelector('.js-energy-value').innerHTML);
        if (btnEnergyValue === maxValue) {
          $(btn).addClass('c-btn-group__button--active');
          results.push(this.options.activeEnergy = maxValue);
        } else {
          results.push($(btn).removeClass('c-btn-group__button--active'));
        }
      }
      return results;
    };


    /*
    			Set state for energy buttons depends on energy value
     */

    BusinessCommonView.prototype.buttonsEnergyState = function() {
      var btn, btnEnergyValue, buttons, experienceEl, i, len, redZone, ref, valuesArr;
      if (((ref = this._data) != null ? ref.info : void 0) != null) {
        buttons = this.el.querySelectorAll('.c-btn-group--energy .c-btn-group__button');
        redZone = parseInt(this._data.info.user.User.energy);
        experienceEl = this.el.querySelector('.js-experience-value');
        valuesArr = [0];
        this.maxValue = 0;
        for (i = 0, len = buttons.length; i < len; i++) {
          btn = buttons[i];
          btnEnergyValue = parseInt(btn.querySelector('.js-energy-value').innerHTML);
          if (btnEnergyValue > redZone) {
            $(btn).addClass('c-btn-group__button--disabled');
          } else {
            $(btn).removeClass('c-btn-group__button--disabled');
            valuesArr.push(btnEnergyValue);
            if (btnEnergyValue > this.maxValue) {
              this.maxValue = btnEnergyValue;
            }
          }
        }
        return valuesArr;
      }
    };

    BusinessCommonView.prototype.balanceStatusState = function() {
      if (this._data.companyInfo != null) {
        if (this._data.companyInfo.company.current_production.production_status_title === 'Нет средств') {
          this.$('.js-currency-wrap').removeClass('u-bgc--grey-3');
          this.$('.js-currency-wrap').addClass('bgc-red-3');
          this.$('.js-currency-wrap').addClass('c-black');
          this.$('.js-currency-wrap i').removeClass('o-icon--vdollar');
          this.$('.js-currency-wrap i').addClass('o-icon--vdollar-black');
          return this.$('.js-status-text').removeClass('u-hide');
        }
      }
    };

    BusinessCommonView.prototype.addFunds = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      app.screens.dialog('business/add-funds', {
        companyId: companyId
      });
      return this.needReload = true;
    };

    BusinessCommonView.prototype.takeFunds = function(event) {
      var companyId, withdrawTax;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      withdrawTax = event.currentTarget.getAttribute('data-withdraw-tax');
      app.screens.dialog('business/withdraw', {
        companyId: companyId,
        withdrawTax: withdrawTax
      });
      return this.needReload = true;
    };

    BusinessCommonView.prototype.gotoEmployees = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.tab('business/employees', {
        companyId: companyId
      });
    };

    BusinessCommonView.prototype.gotoStorage = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.tab('business/storage', {
        companyId: companyId
      });
    };

    BusinessCommonView.prototype.beginWork = function(event) {
      var companyId, energy, loader;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      energy = parseInt(this.$el.find('.c-btn-group__button--active .js-energy-value').text());
      if ((this.maxValue != null) && this.maxValue < energy) {
        energy = this.maxValue;
        this.setMaxButton();
      }
      this.options.activeEnergy = energy;
      if (isNaN(energy)) {
        app.screens.modal('common/info-popup', {
          msg: app.tr("Not enough energy")
        });
        return;
      }
      loader = this.setLoaderOnElement('.js-begin-work', app.tr('Work'));
      return app.server.work.beginWork({
        companyId: companyId,
        energy: energy,
        success: (function(_this) {
          return function(data) {
            var options;
            options = {
              data: data,
              repeat: {
                method: _this.beginWork,
                context: _this,
                event: event
              }
            };
            _this.listenToOnce(app.vent, 'short-info:dataLoaded', function() {
              loader.remove();
              return app.screens.modal('job/job-done', options);
            });
            return _this.needReload = true;
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            loader.remove();
            _this.unlockUI();
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          };
        })(this)
      });
    };

    BusinessCommonView.prototype.settings = function(event) {
      var companyId, menu;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      menu = new Backbone.Collection([
        {
          id: 1,
          title: app.tr('Rename company')
        }, {
          id: 2,
          title: app.tr('Transfer company to corporation')
        }
      ]);
      return app.screens.dialog('common/select-dialog-cb', {
        collection: menu,
        callback: (function(_this) {
          return function(itemId) {
            if (itemId === "1") {
              app.screens.dialog('business/rename-company', {
                companyId: companyId
              });
              return _this.needReload = true;
            } else {
              app.screens.dialog('business/transfer-company', {
                companyId: companyId
              });
              return _this.needReload = true;
            }
          };
        })(this)
      });
    };

    BusinessCommonView.prototype.changeProd = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      app.screens.dialog('business/change-production', {
        companyId: companyId
      });
      return this.needReload = true;
    };

    BusinessCommonView.prototype.onDomRefresh = function() {
      this.buttonsEnergyState();
      this.balanceStatusState();
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        if (el.dataset.precision) {
          return el.innerHTML = formatCurrency(el.innerHTML, void 0, el.dataset.precision);
        } else {
          return el.innerHTML = formatCurrency(el.innerHTML);
        }
      });
    };

    BusinessCommonView.prototype.showEffects = function(event) {
      return $('.js-effects').toggle().removeClass('u-hide');
    };

    BusinessCommonView.prototype.showReports = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/company-reports/archive', {
        companyId: companyId,
        companyName: this._data.companyInfo.company.name
      });
    };

    BusinessCommonView.prototype.generateReport = function(event) {
      var companyId, msg, reportType;
      companyId = event.currentTarget.getAttribute('data-company-id');
      reportType = event.currentTarget.getAttribute('data-report-type');
      msg = app.tr('Are you sure you generate report?');
      return app.screens.modal('common/confirmation-popup', {
        msg: msg,
        callback: (function(_this) {
          return function() {
            _this.lockUI();
            return app.server.business.generateReport({
              companyId: companyId,
              reportType: reportType,
              success: function(data) {
                return app.screens.modal('business/company-reports/report', {
                  report: data.report
                });
              }
            });
          };
        })(this)
      });
    };

    return BusinessCommonView;

  })(ItemView);
  return BusinessCommonView;
});
