define(['app', 'views/item-view', 'underscore', 'text!templates/business/corporation-dividends.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      corporationDividends: {
        pointer: 'business.corporationDividends',
        corporationId: function() {
          return this.options.corporationId;
        },
        limit: function() {
          return this.options.limit || 0;
        }
      }
    },
    events: {
      'click .js-goto-management': 'gotoManagement',
      'click .js-goto-corporation-storage': 'gotoCorporationStorage',
      'click .js-goto-shareholders': 'gotoShareholders'
    },
    preprocessData: function(data) {
      var dividends, i, len, ref;
      if (data != null) {
        ref = data.corporationDividends.dividends_info;
        for (i = 0, len = ref.length; i < len; i++) {
          dividends = ref[i];
          dividends.CorporationSolution.solution.vd_amount_reserved = this.numberFormat(dividends.CorporationSolution.solution.vd_amount_reserved);
        }
      }
      return data;
    },
    gotoManagement: function(event) {
      var corporationId;
      this.lockUI();
      corporationId = this.options.corporationId;
      return app.screens.tab('business/management', {
        corporationId: corporationId
      });
    },
    gotoCorporationStorage: function(event) {
      var corporationId;
      this.lockUI();
      corporationId = this.options.corporationId;
      return app.screens.tab('business/corp-storage', {
        corporationId: corporationId
      });
    },
    gotoShareholders: function(event) {
      var corporationId;
      this.lockUI();
      corporationId = this.options.corporationId;
      return app.screens.tab('business/shareholders', {
        corporationId: corporationId
      });
    }
  });
});
