var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/business/employees.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  var EmployeesView;
  EmployeesView = (function(superClass) {
    extend(EmployeesView, superClass);

    function EmployeesView() {
      this.showReports = bind(this.showReports, this);
      return EmployeesView.__super__.constructor.apply(this, arguments);
    }

    EmployeesView.prototype.template = template;

    EmployeesView.prototype.data = {
      сompanyWorkersInfo: {
        pointer: 'business.сompanyWorkersInfo',
        companyId: function() {
          return this.options.companyId;
        }
      },
      effects: {
        pointer: 'business.company.effects',
        companyId: function() {
          return this.options.companyId;
        }
      },
      companyInfo: {
        pointer: 'business.companyInfo',
        companyId: function() {
          return this.options.companyId;
        }
      }
    };

    EmployeesView.prototype.events = {
      'click .js-goto-employees-list': 'gotoEmployeesList',
      'click .js-goto-foreign-workers': 'gotoForeignWorkers',
      'click .js-goto-recruitment': 'gotoRecruitment',
      'click .js-goto-storage': 'gotoStorage',
      'click .js-goto-common': 'gotoCommon',
      'click .js-up-level': 'upLevel',
      'click .js-goto-change-manager': 'gotoChangeManager',
      'click .js-settings': 'settings',
      'click .js-effects': 'showEffects',
      'click .js-toggle-effects': 'showEffects',
      'click .js-reports-archive': 'showReports',
      'click .js-generate-report': 'generateReport',
      'click .js-back': 'jsBack'
    };


    /*
    			Center cloud
     */

    EmployeesView.prototype.centerCloud = function() {};

    EmployeesView.prototype.jsBack = function() {
      console.log('Назвад в компании игрока');
      return app.screens.back(null, {
        needReload: false
      }, 'refresh:company', +this._data.options.companyId);
    };

    EmployeesView.prototype.onDomRefresh = function() {
      this.centerCloud();
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    };

    EmployeesView.prototype.settings = function(event) {
      var companyId, menu;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      menu = new Backbone.Collection([
        {
          id: 1,
          title: app.tr('Rename company')
        }, {
          id: 2,
          title: app.tr('Transfer company to corporation')
        }
      ]);
      return app.screens.dialog('common/select-dialog-cb', {
        collection: menu,
        callback: (function(_this) {
          return function(itemId) {
            if (itemId === "1") {
              return app.screens.dialog('business/rename-company', {
                companyId: companyId
              });
            } else {
              return app.screens.dialog('business/transfer-company', {
                companyId: companyId
              });
            }
          };
        })(this)
      });
    };

    EmployeesView.prototype.gotoCommon = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.tab('business/common', {
        companyId: companyId
      });
    };

    EmployeesView.prototype.gotoStorage = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.tab('business/storage', {
        companyId: companyId
      });
    };

    EmployeesView.prototype.gotoEmployeesList = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/employees-list', {
        companyId: companyId
      });
    };

    EmployeesView.prototype.gotoForeignWorkers = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/hiring-migrants', {
        companyId: companyId
      });
    };

    EmployeesView.prototype.gotoRecruitment = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/recruitment', {
        companyId: companyId
      });
    };

    EmployeesView.prototype.gotoChangeManager = function(event) {
      var companyId, managerId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      managerId = event.currentTarget.getAttribute('data-manager-id');
      return app.screens.tab('business/change-manager', {
        companyId: companyId,
        managerId: managerId
      });
    };

    EmployeesView.prototype.upLevel = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.modal('common/confirmation-popup', {
        msg: app.tr('Do you want to upgrade the workers limit?'),
        callback: (function(_this) {
          return function(count) {
            return app.server.business.upLevel({
              companyId: companyId,
              success: function(data) {
                return app.screens.modal('common/success-popup', {
                  msg: data.setFlash[0].msg || app.tr("Settings saved")
                });
              },
              error: function(data) {
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this)
      });
    };

    EmployeesView.prototype.showEffects = function(event) {
      var companyId;
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('maria/city-effects', {
        companyId: companyId
      });
    };

    EmployeesView.prototype.showEffects = function(event) {
      return $('.js-effects').toggle(400).removeClass('u-hide');
    };

    EmployeesView.prototype.showReports = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/company-reports/archive', {
        companyId: companyId,
        companyName: this._data.companyInfo.company.name
      });
    };

    EmployeesView.prototype.generateReport = function(event) {
      var companyId, msg, reportType;
      companyId = event.currentTarget.getAttribute('data-company-id');
      reportType = event.currentTarget.getAttribute('data-report-type');
      msg = app.tr('Are you sure you generate report?');
      return app.screens.modal('common/confirmation-popup', {
        msg: msg,
        callback: (function(_this) {
          return function() {
            _this.lockUI();
            return app.server.business.generateReport({
              companyId: companyId,
              reportType: reportType,
              success: function(data) {
                return app.screens.modal('business/company-reports/report', {
                  report: data.report
                });
              }
            });
          };
        })(this)
      });
    };

    EmployeesView.prototype.onRender = function() {
      this.toggleView('.js-reports-switcher', '.js-reports-buttons');
      return EmployeesView.__super__.onRender.call(this);
    };

    return EmployeesView;

  })(ItemView);
  return EmployeesView;
});
