var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/business/hiring-migrants.tmpl'], function(app, ItemView, _, template) {
  var HiringMigrantsView;
  HiringMigrantsView = (function(superClass) {
    extend(HiringMigrantsView, superClass);

    function HiringMigrantsView() {
      return HiringMigrantsView.__super__.constructor.apply(this, arguments);
    }

    HiringMigrantsView.prototype.template = template;

    HiringMigrantsView.prototype.data = {
      companyForeignWorkers: {
        pointer: 'business.companyForeignWorkers',
        companyId: function() {
          return this.options.companyId;
        }
      }
    };

    HiringMigrantsView.prototype.events = {
      'click .js-hire-worker': 'hireForeignWorker'
    };

    HiringMigrantsView.prototype.hireForeignWorker = function(event) {
      var companyId, loader, salary;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      salary = event.currentTarget.getAttribute('data-worker-salary');
      loader = this.setLoaderOnElement(event.currentTarget, app.tr('Hire'));
      return app.server.business.hireForeignWorkers({
        workerId: event.currentTarget.getAttribute('data-worker-id'),
        companyId: companyId,
        quantity: 1,
        success: (function(_this) {
          return function(data) {
            if (app.gaEnabled) {
              app.ga('send', 'event', 'business', 'hire_npc', 'company ' + companyId, parseInt(salary));
            }
            loader.remove();
            return _this.unlockUI();
          };
        })(this),
        error: function(data) {
          loader.remove();
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    };


    /*
    			Center cloud
     */

    HiringMigrantsView.prototype.centerCloud = function() {};

    HiringMigrantsView.prototype.onDomRefresh = function() {
      return this.centerCloud();
    };

    return HiringMigrantsView;

  })(ItemView);
  return HiringMigrantsView;
});
