define(['app', 'views/item-view', 'underscore', 'text!templates/business/initiative-dividends.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    events: {
      'click .js-apply': 'saveProposal',
      'click .o-switcher': 'changeCurrency'
    },
    changeCurrency: function(event) {
      return $(event.currentTarget).toggleClass('o-switcher--active');
    },
    saveProposal: function(event) {
      var amount, corporationId, currency;
      this.lockUI();
      corporationId = this.options.corporationId;
      amount = this.$el.find('.js-amount').val();
      currency = this.$el.find('.o-switcher').hasClass('o-switcher--active') ? 'vg' : 'vd';
      if (amount === "") {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("You haven't input anything")
        });
      } else {
        return app.server.business.proposeDividents({
          amount: amount,
          currency: currency,
          corporationId: corporationId,
          success: function(data) {
            return app.screens.modal('common/success-popup', {
              msg: data.setFlash[0].msg || app.tr("Action was successful")
            }, app.screens.back());
          },
          error: function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          }
        });
      }
    }
  });
});
