define(['app', 'views/item-view', 'underscore', 'text!templates/business/initiative-liquidation.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      corporationInfo: {
        pointer: 'business.corporationInfo',
        limit: 9999,
        corporationId: function() {
          return this.options.corporationId;
        }
      }
    },
    events: {
      'click .js-select': 'selectItem',
      'click .js-apply': 'saveProposal'
    },
    preprocessData: function(data) {
      var i, item, len, ref;
      ref = data.corporationInfo.companies;
      for (i = 0, len = ref.length; i < len; i++) {
        item = ref[i];
        item.title = item.name;
      }
      this.companiesCollection = new Backbone.Collection(data.corporationInfo.companies);
      return data;
    },
    selectItem: function(event) {
      this.lockUI();
      return app.screens.dialog('common/select-dialog', {
        collection: this.companiesCollection,
        callback: (function(_this) {
          return function(itemId) {
            event.currentTarget.setAttribute('data-id', itemId);
            return _this.$('.js-select .js-item-name').html(_this.companiesCollection.get(itemId).get("title"));
          };
        })(this)
      });
    },
    saveProposal: function(event) {
      var companyId, corporationId;
      this.lockUI();
      corporationId = this.options.corporationId;
      companyId = this.$el.find('.js-select').attr('data-id');
      if (companyId === "0") {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("You haven't input anything")
        });
      } else {
        return app.server.business.proposeCorpCompanyClose({
          corporationId: corporationId,
          companyId: companyId,
          success: function(data) {
            return app.screens.modal('common/success-popup', {
              msg: data.setFlash[0].msg || app.tr("Action was successful")
            }, app.screens.back());
          },
          error: function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          }
        });
      }
    }
  });
});
