define(['app', 'views/item-view', 'underscore', 'text!templates/business/initiative-rename.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      renamePrice: {
        pointer: 'business.getCorpRenamePrice'
      }
    },
    events: {
      'click .js-apply': 'saveProposal'
    },
    saveProposal: function(event) {
      var corporationId, name_en, name_ru;
      this.lockUI();
      corporationId = this.options.corporationId;
      name_ru = this.$el.find('.name_ru').val();
      name_en = this.$el.find('.name_en').val();
      if (name_ru === "" || name_en === "") {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("All fields are required")
        });
      } else {
        return app.server.business.proposeCorpRename({
          corporationId: corporationId,
          name_ru: name_ru,
          name_en: name_en,
          success: function(data) {
            return app.screens.modal('common/success-popup', {
              msg: data.setFlash[0].msg || app.tr("Action was successful")
            }, app.screens.back());
          },
          error: function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          }
        });
      }
    }
  });
});
