define(['app', 'views/item-view', 'underscore', 'text!templates/business/move-item-popup.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    required: ['itemTypeId', 'number', 'callback'],
    data: {
      item: {
        pointer: 'business.itemInfo',
        itemTypeId: function() {
          return this.options.itemTypeId;
        }
      }
    },
    events: {
      'click .js-confirm': 'confirm'
    },
    confirm: function() {
      var numberHelper, quantity;
      this.lockUI();
      quantity = this.$('.js-items-number').val();
      numberHelper = this.templateHelpers().numberHelper;
      if (numberHelper.isInteger(parseFloat(quantity))) {
        return this.options.callback(quantity);
      } else {
        this.unlockUI();
        return $('.js-int-error').removeClass('u-hide');
      }
    }
  });
});
