define(['app', 'views/item-view', 'underscore', 'text!templates/business/rename-company.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    events: {
      'click .js-apply': 'saveName'
    },
    saveName: function(event) {
      var companyId, name;
      this.lockUI();
      name = this.$el.find('.name').val();
      companyId = this.options.companyId;
      if (name === "") {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("Specify the company's name")
        });
      } else {
        return app.server.business.editCompanyName({
          companyId: companyId,
          name: name,
          success: function(data) {
            return app.screens.modal('common/success-popup', {
              msg: data.setFlash[0].msg || app.tr("Company has been renamed")
            }, app.screens.back());
          },
          error: function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          }
        });
      }
    }
  });
});
