var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/business/transfer-company.tmpl', 'text!templates/business/blocks/corporation-element.tmpl', 'views/common/lazy-loading-view'], function(app, ItemView, _, template, listTemplate, CommonLazyView) {
  var BusinessCommonView;
  return BusinessCommonView = (function(superClass) {
    extend(BusinessCommonView, superClass);

    function BusinessCommonView() {
      this._loadData = bind(this._loadData, this);
      return BusinessCommonView.__super__.constructor.apply(this, arguments);
    }

    BusinessCommonView.prototype.template = template;

    BusinessCommonView.prototype.listTemplate = _.template(listTemplate);

    BusinessCommonView.prototype.pointer = 'business';

    BusinessCommonView.prototype.data = {
      business: {
        pointer: 'business.corporationList',
        page: 1
      }
    };

    BusinessCommonView.prototype.required = ['companyId'];

    BusinessCommonView.prototype.events = {
      'click .js-select': 'transfer'
    };

    BusinessCommonView.prototype.loadData = function(showLoader) {
      if (showLoader == null) {
        showLoader = true;
      }
      this.data.business.page = 1;
      return BusinessCommonView.__super__.loadData.call(this, showLoader);
    };

    BusinessCommonView.prototype.transfer = function(event) {
      var corporationId;
      this.lockUI();
      corporationId = event.currentTarget.getAttribute('data-corporation-id');
      return app.screens.modal('common/confirmation-popup', {
        msg: app.tr('Do you want to transfer company?'),
        callback: (function(_this) {
          return function(count) {
            return app.server.business.company.transfer({
              companyId: _this.options.companyId,
              corporationId: corporationId,
              success: function(data) {
                return app.screens.modal('common/success-popup', {
                  msg: data.setFlash[0].msg || app.tr("Well done")
                }, app.screens.main('business'));
              },
              error: function(data) {
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this)
      });
    };

    BusinessCommonView.prototype._loadData = function(page) {
      var deferred, self;
      deferred = $.Deferred();
      self = this;
      app.server.business.corporationList({
        page: page || 1,
        success: (function(_this) {
          return function(data) {
            var ref, ref1, ref2, ref3, resultData;
            resultData = data;
            resultData.page = page;
            resultData.hasNext = ((ref = data.paging) != null ? (ref1 = ref.Corporation) != null ? ref1.nextPage : void 0 : void 0) || false;
            self.hasNext = ((ref2 = data.paging) != null ? (ref3 = ref2.Corporation) != null ? ref3.nextPage : void 0 : void 0) || false;
            _this.data.business.page++;
            return deferred.resolve(resultData);
          };
        })(this),
        error: function() {
          return deferred.resolve({
            corporations: [],
            page: 1,
            hasNext: false
          });
        }
      });
      return deferred;
    };

    return BusinessCommonView;

  })(CommonLazyView);
});
