var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/common/action-popup.tmpl'], function(app, ItemView, _, template) {
  var ActionPopup;
  ActionPopup = (function(superClass) {
    extend(ActionPopup, superClass);

    function ActionPopup() {
      return ActionPopup.__super__.constructor.apply(this, arguments);
    }

    ActionPopup.prototype.template = template;

    ActionPopup.prototype.required = ['msg'];

    ActionPopup.prototype.events = {
      'click .js-close': 'confirm',
      'click .js-action': 'doAct'
    };

    ActionPopup.prototype.onBeforeRender = function() {
      if (this.options) {
        if (!this.options.imgUrl) {
          return this.options.imgUrl = (function() {
            switch (this.options.go.to) {
              case "inventory/energy-popup":
                return "images/icons/action/energy.png";
              case "shop":
                return "images/icons/action/energy.png";
              case "hospital":
                return "images/icons/action/health.png";
              case "shop/vgold":
                return "images/icons/action/money.png";
              case "trade-center/currencies":
                return "images/icons/action/money.png";
            }
          }).call(this);
        }
      }
    };

    ActionPopup.prototype.confirm = function() {
      this.lockUI();
      if (this.options.callback) {
        this.options.callback();
      }
      if (this.options.needReload === false) {
        return this.app.screens.back(null, {
          needReload: false
        });
      } else {
        return this.jsBack();
      }
    };

    ActionPopup.prototype.doAct = function() {
      this.jsBack();
      this.lockUI();
      if (this.options.callback) {
        this.options.callback();
      }
      if (this.options.go) {
        return app.screens[this.options.screenType || 'dialog'](this.options.go.to, this.options.go.data);
      }
    };

    return ActionPopup;

  })(ItemView);
  return ActionPopup;
});
