var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'underscore', 'views/components/lazy-loading', 'views/common/list-view'], function(app, _, LazyLoading, CommonListView) {
  var LazyLoadingCommonView;
  LazyLoadingCommonView = (function(superClass) {
    extend(LazyLoadingCommonView, superClass);

    function LazyLoadingCommonView() {
      this._appendPageToMainList = bind(this._appendPageToMainList, this);
      this.onDataLoaded = bind(this.onDataLoaded, this);
      return LazyLoadingCommonView.__super__.constructor.apply(this, arguments);
    }

    LazyLoadingCommonView.prototype.activeRequest = false;

    LazyLoadingCommonView.prototype.onDataLoaded = function(data, selector) {
      var container;
      this.hasNext = true;
      LazyLoadingCommonView.__super__.onDataLoaded.call(this, data);
      selector = selector || '#js-main-list-content';
      container = this.el.querySelector(selector);
      this._renderList(container, data[this.pointer], data.page, data.hasNext);
      this.tabletLayout();
      this.canvasInnerLayout();
      this.data[this.pointer].page++;
      return LazyLoading((function(_this) {
        return function() {
          return _this._appendPageToMainList(_this.data[_this.pointer].page, selector);
        };
      })(this));
    };

    LazyLoadingCommonView.prototype._appendPageToMainList = function(page, selector) {
      var container, self;
      if (this.hasNext === false || this.activeRequest) {
        return;
      }
      this.activeRequest = true;
      selector = selector || '#js-main-list-content';
      container = this.el.querySelector(selector);
      self = this;
      self.lockUI();
      self._showListLoader(container);
      return self._loadData(page).then(function(data) {
        self.unlockUI();
        self._hideListLoader(container);
        self._renderList(container, data, data.page, data.hasNext);
        return self.activeRequest = false;
      });
    };

    return LazyLoadingCommonView;

  })(CommonListView);
  return LazyLoadingCommonView;
});
