define(['app', 'views/item-view', 'underscore', 'text!templates/common/level-up-addition-bonuses.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      bonuses: 'user.levelUp'
    },
    events: {
      'click .js-select-bonus': 'selectBonus'
    },
    selectBonus: function(event) {
      var bonusId;
      this.lockUI();
      bonusId = parseInt(event.currentTarget.getAttribute('data-bonus-id'));
      app.server.user.levelUp.getAdditionBonuses({
        bonusId: bonusId,
        success: function(data) {
          return _.forEach(data.setFlash, function(msg) {
            return app.screens.modal('common/success-popup', {
              msg: msg.msg
            });
          });
        }
      });
      return app.screens.back();
    },
    onDomRefresh: function() {
      return this.$el.find('.c-popup').css('max-height', $(window).innerHeight() - 60);
    }
  });
});
