var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/common/level-up-first-popup.tmpl'], function(app, ItemView, _, template) {
  var LevelUpFirstPopup;
  LevelUpFirstPopup = (function(superClass) {
    extend(LevelUpFirstPopup, superClass);

    function LevelUpFirstPopup() {
      return LevelUpFirstPopup.__super__.constructor.apply(this, arguments);
    }

    LevelUpFirstPopup.prototype.template = template;

    LevelUpFirstPopup.prototype.data = {
      bonuses: 'user.levelUp'
    };

    LevelUpFirstPopup.prototype.events = {
      'click .js-apply': 'selectAdditionBonuses',
      'click .js-bonus-info': 'showBonusInfo',
      'click .js-opened-info': 'showOpenedInfo'
    };

    LevelUpFirstPopup.prototype.adjustTokens = {
      levelUp: {
        2: 'h9ng92',
        3: 'ylw5vt',
        4: 'n2t2dz',
        5: '44tddr',
        10: 'yk2bfi',
        20: 'sltkrz'
      }
    };

    LevelUpFirstPopup.prototype.adjustLvls = [2, 3, 4, 5, 10, 20];

    LevelUpFirstPopup.prototype.preprocessData = function(data) {
      var adjustEvent, key, ref;
      if ((ref = data.bonuses) != null ? ref.level : void 0) {
        if (data.bonuses.level > 9 && localStorage.getItem('tutorial_skipped') === '1') {
          localStorage.removeItem('tutorial_skipped');
          app.menu.reload();
        }
        if (app.gaEnabled) {
          app.ga('send', 'event', 'progress', 'levelup', '' + data.bonuses.level);
        }
        if (app.adjustEnabled && this.adjustLvls.indexOf(data.bonuses.level)) {
          key = this.adjustTokens.levelUp[data.bonuses.level];
          adjustEvent = new app.adjust.AdjustEvent(key);
          adjustEvent.addPartnerParameter('event_key', key);
          app.adjust.Adjust.trackEvent(adjustEvent);
        }
        if (data.bonuses.level === 10) {
          localStorage.removeItem("tutorial_skipped");
        }
      }
      return data;
    };

    LevelUpFirstPopup.prototype.selectAdditionBonuses = function(event) {
      this.lockUI();
      if (this._data.bonuses.quick_reg_lock) {
        this.app.server.trigger('app:quick_reg_lock');
        return;
      }
      app.screens.back();
      if (Object.keys(this._data.bonuses.additionBonuses).length > 0) {
        return app.screens.modal('common/level-up-addition-bonuses');
      }
    };

    LevelUpFirstPopup.prototype.showOpenedInfo = function(event) {
      var openedId;
      this.lockUI();
      openedId = parseInt(event.currentTarget.getAttribute('data-opened-id'));
      return app.screens.modal('bonus/opened-info', {
        bonusId: openedId
      });
    };

    LevelUpFirstPopup.prototype.showBonusInfo = function(event) {
      var bonusId;
      this.lockUI();
      bonusId = parseInt(event.currentTarget.getAttribute('data-bonus-id'));
      return app.screens.modal('bonus/bonus-info', {
        bonusId: bonusId
      });
    };

    LevelUpFirstPopup.prototype.onDomRefresh = function() {
      return this.$el.find('.c-popup__height').css('max-height', $('.js-current-screen').height() - 300);
    };

    return LevelUpFirstPopup;

  })(ItemView);
  return LevelUpFirstPopup;
});
