var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['jquery', 'app', 'views/item-view', 'velocity-ui'], function($, app, ItemView) {
  var CommonListView;
  CommonListView = (function(superClass) {
    extend(CommonListView, superClass);

    function CommonListView() {
      this._clearAllLists = bind(this._clearAllLists, this);
      return CommonListView.__super__.constructor.apply(this, arguments);
    }

    CommonListView.prototype._showListLoader = function(listContainer) {
      var el;
      el = listContainer.parentNode.querySelector('.js-list-loader');
      return el.classList.remove('is-hidden');
    };

    CommonListView.prototype._hideListLoader = function(listContainer) {
      var el;
      el = listContainer.parentNode.querySelector('.js-list-loader');
      return el.classList.add('is-hidden');
    };

    CommonListView.prototype._renderList = function(listContainer, elements, page, hasNext) {
      var data, fragment, loadMore, newElementsContainer;
      if (!listContainer) {
        return;
      }
      page = page || 1;
      hasNext = hasNext || false;
      data = this.serializeData();
      data.elements = elements;
      data.page = page;
      data.hasNext = hasNext;
      loadMore = listContainer.parentNode.querySelector('.js-list-load-more');
      fragment = document.createElement('DIV');
      fragment.innerHTML = Marionette.Renderer.render(this.listTemplate, data);
      listContainer.appendChild(fragment.firstElementChild);
      newElementsContainer = this.el.querySelector('#js-list-page-' + (page || 1));
      return this._animateElements(newElementsContainer).then(function() {
        if (data.hasNext && loadMore) {
          loadMore.classList.remove('is-hidden');
          return loadMore.setAttribute('data-page', data.page + 1);
        } else if (loadMore) {
          return loadMore.classList.add('is-hidden');
        }
      });
    };

    CommonListView.prototype._animateElements = function(container) {
      var deferred, elements, error;
      deferred = $.Deferred();
      if (container) {
        elements = container.querySelectorAll('.js-list-element');
        if (elements && elements.length > 0) {
          try {
            $.Velocity(elements, "transition.slideUpIn", {
              stagger: 70,
              drag: true,
              duration: 400
            }).then(function() {
              return deferred.resolve();
            });
          } catch (_error) {
            error = _error;
            deferred.resolve();
          }
        } else {
          deferred.resolve();
        }
      } else {
        deferred.resolve();
      }
      return deferred;
    };

    CommonListView.prototype._clearElements = function(container) {
      var deferred, elements, error, loadMore;
      deferred = $.Deferred();
      if (container) {
        loadMore = container.parentNode.querySelector('.js-list-load-more');
        loadMore && loadMore.classList.add('is-hidden');
        elements = container.querySelectorAll('.js-list-element');
        if (elements && elements.length > 0) {
          try {
            $.Velocity(elements, "transition.slideUpOut", {
              drag: true,
              duration: 200
            }).then(function() {
              container.innerHTML = '';
              return deferred.resolve();
            });
          } catch (_error) {
            error = _error;
            container.innerHTML = '';
            deferred.resolve();
          }
        } else {
          container.innerHTML = '';
          deferred.resolve();
        }
      } else {
        deferred.resolve();
      }
      return deferred;
    };

    CommonListView.prototype._clearAllLists = function() {
      var container, deferreds, i, len, listContainers;
      deferreds = [];
      listContainers = this.el.querySelectorAll('.js-list-content');
      if (listContainers.length) {
        for (i = 0, len = listContainers.length; i < len; i++) {
          container = listContainers[i];
          deferreds.push(this._clearElements(container));
        }
      }
      return $.when.apply($, deferreds);
    };

    return CommonListView;

  })(ItemView);
  return CommonListView;
});
