var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/common/simple-select-dialog.tmpl', 'velocity-ui'], function(app, ItemView, _, template) {
  var SelectDialogView;
  SelectDialogView = (function(superClass) {
    extend(SelectDialogView, superClass);

    function SelectDialogView() {
      this.setContentHeight = bind(this.setContentHeight, this);
      return SelectDialogView.__super__.constructor.apply(this, arguments);
    }

    SelectDialogView.prototype.template = template;

    SelectDialogView.prototype.className = 'js-select-dialog-screen';

    SelectDialogView.prototype.required = ['values', 'callback'];

    SelectDialogView.prototype.events = {
      'click .js-custom-select': 'onElementClick',
      'click .js-select-popup-outer': 'onOuterAreaClick'
    };

    SelectDialogView.prototype.onElementClick = function(event) {
      event.stopPropagation();
      this.lockUI();
      this.options.callback(event.currentTarget.getAttribute('data-id'));
      return app.screens.back(null, {
        needReload: false
      });
    };

    SelectDialogView.prototype.onOuterAreaClick = function(event) {
      event.stopPropagation();
      this.lockUI();
      return app.screens.back(null, {
        needReload: false
      });
    };

    SelectDialogView.prototype.onDomRefresh = function() {
      var container, content, el, elHeight, height, maxHeight, maxWidth, padding, promise, totalHeight, width, windowHeight, windowWidth;
      elHeight = 60;
      totalHeight = elHeight * Object.keys(this.options.values).length;
      windowHeight = window.innerHeight;
      windowWidth = window.innerWidth;
      padding = 20;
      container = this.el.querySelector('.js-select-popup');
      maxWidth = 500;
      if (windowWidth < maxWidth) {
        maxWidth = windowWidth;
      }
      width = maxWidth - 2 * padding;
      container.style.width = width + 'px';
      container.parentNode.style.paddingLeft = Math.round((windowWidth - width) / 2) + 'px';
      maxHeight = windowHeight > 500 ? Math.round(windowHeight * 0.6) : windowHeight - elHeight;
      if (maxHeight % elHeight !== 0) {
        maxHeight = Math.floor(maxHeight / elHeight) * elHeight + elHeight;
      }
      height = totalHeight > maxHeight ? maxHeight : totalHeight;
      container.style.height = height + 'px';
      container.parentNode.style.paddingTop = Math.round((windowHeight - height) / 2) + 'px';
      content = this.el.querySelector('.js-select-popup-elements');
      promise = $.Velocity(content, "fadeIn", {
        duration: 100
      });
      if (promise) {
        return promise.then((function(_this) {
          return function() {
            var el;
            if (_this.options.selected) {
              el = _this.el.querySelector('#js-select-item-' + _this.options.selected);
              if (el) {
                return app.scrollElToCenter(content, el);
              }
            }
          };
        })(this));
      } else {
        if (this.options.selected) {
          el = this.el.querySelector('#js-select-item-' + this.options.selected);
          if (el) {
            return app.scrollElToCenter(content, el);
          }
        }
      }
    };

    SelectDialogView.prototype.setContentHeight = function() {
      var content, currentScreen, popup;
      currentScreen = this.el.parentNode;
      if (currentScreen && currentScreen.classList.contains('js-current-screen')) {
        popup = this.el.querySelector('.js-select-popup');
        content = this.el.querySelector('.js-select-popup-elements');
        if (content) {
          return content.style.height = popup.offsetHeight + 'px';
        }
      }
    };

    return SelectDialogView;

  })(ItemView);
  return SelectDialogView;
});
