define([], function() {
  var EnergySlider;
  return EnergySlider = (function() {
    function EnergySlider(arg) {
      var onMouseDown, onMouseMove, onMouseUp, position, ref;
      this.element = arg.element, this.onChange = arg.onChange, this.values = arg.values, this.value = arg.value, this.redZone = arg.redZone;
      this.values = (ref = this.values) != null ? ref : [10, 50, 100];
      this.values.sort(function(a, b) {
        return a - b;
      });
      this.valueIndex = this.values.indexOf(this.value);
      this.bar = this.element.querySelector('.js-energy-slider-bar');
      this.handle = this.element.querySelector('.js-energy-slider-handle');
      position = this.getPositionFromValue(this.value) + '%';
      this.bar.style.width = position;
      this.handle.style.left = position;
      onMouseDown = (function(_this) {
        return function(event) {
          event.preventDefault();
          _this.originalClientX = event.clientX || event.touches[0].pageX;
          _this.originalPosition = _this.getPositionFromIndex(_this.valueIndex);
          $(_this.element).addClass('js-moving');
          document.addEventListener('mousemove', onMouseMove, false);
          document.addEventListener('mouseup', onMouseUp, false);
          if (window.navigator.pointerEnabled != null) {
            document.addEventListener('pointermove', onMouseMove, false);
            return document.addEventListener('pointerup', onMouseUp, false);
          } else if (window.navigator.msPointerEnabled != null) {
            document.addEventListener('MSPointerMove', onMouseMove, false);
            return document.addEventListener('MSPointerUp', onMouseUp, false);
          } else {
            document.addEventListener('touchmove', onMouseMove, false);
            document.addEventListener('touchend', onMouseUp, false);
            return document.addEventListener('touchcancel', onMouseUp, false);
          }
        };
      })(this);
      onMouseMove = (function(_this) {
        return function(event) {
          event.preventDefault();
          position = _this.getPositionFromClientX(event.clientX || event.touches[0].pageX);
          if (position > 100) {
            position = 100;
          } else if (position < 0) {
            position = 0;
          }
          _this.bar.style.width = position + '%';
          _this.handle.style.left = position + '%';
          if (_this.onChange != null) {
            return setTimeout((function() {
              _this.valueIndex = _this.getIndexFromPosition(position);
              _this.value = _this.values[_this.valueIndex];
              return _this.onChange(_this.value);
            }), 0);
          }
        };
      })(this);
      onMouseUp = (function(_this) {
        return function(event) {
          event.preventDefault();
          $(_this.element).removeClass('js-moving');
          document.removeEventListener('mousemove', onMouseMove, false);
          document.removeEventListener('mouseup', onMouseUp, false);
          if (window.navigator.pointerEnabled != null) {
            document.removeEventListener('pointermove', onMouseMove, false);
            document.removeEventListener('pointerup', onMouseUp, false);
          } else if (window.navigator.msPointerEnabled != null) {
            document.removeEventListener('MSPointerMove', onMouseMove, false);
            document.removeEventListener('MSPointerUp', onMouseUp, false);
          } else {
            document.removeEventListener('touchmove', onMouseMove, false);
            document.removeEventListener('touchend', onMouseUp, false);
            document.removeEventListener('touchcancel', onMouseUp, false);
          }
          position = _this.getPositionFromClientX(event.clientX || event.touches[0].pageX);
          if (position > 100) {
            position = 100;
          } else if (position < 0) {
            position = 0;
          }
          _this.valueIndex = _this.getIndexFromPosition(position);
          _this.value = _this.values[_this.valueIndex];
          position = _this.getPositionFromIndex(_this.valueIndex);
          _this.bar.style.width = position + '%';
          return _this.handle.style.left = position + '%';
        };
      })(this);
      this.handle.addEventListener('mousedown', onMouseDown, false);
      if (window.navigator.pointerEnabled != null) {
        this.handle.addEventListener('pointerdown', onMouseDown, false);
      } else if (window.navigator.msPointerEnabled != null) {
        this.handle.addEventListener('MSPointerDown', onMouseDown, false);
      } else {
        this.handle.addEventListener('touchstart', onMouseDown, false);
      }
    }

    EnergySlider.prototype.getPositionFromClientX = function(clientX) {
      return (clientX - this.originalClientX) / this.element.offsetWidth * 100 + this.originalPosition;
    };

    EnergySlider.prototype.getPositionFromIndex = function(index) {
      return index / (this.values.length - 1) * 100;
    };

    EnergySlider.prototype.getPositionFromValue = function(value) {
      var i, index, len, ref, val;
      ref = this.values;
      for (index = i = 0, len = ref.length; i < len; index = ++i) {
        val = ref[index];
        if (value === val) {
          return index / (this.values.length - 1) * 100;
        }
      }
    };

    EnergySlider.prototype.getIndexFromPosition = function(position) {
      return Math.floor(position / (100 / (this.values.length - 1)) + 0.5);
    };

    return EnergySlider;

  })();
});
