
/*
	TabsScroller

	Functionality description
	=============
	When user scrolled the tabs app.tabsScroll flag set to true, and this prevents swipe which opened menu
	Usage example
	=============

	Container:
	<div class="c-tabs"></div>
	$('.c-tabs').tabsScroller()
 */
define(['modernizr'], function(Modernizr) {
  var TabsScroller;
  return TabsScroller = (function() {
    function TabsScroller(el, options) {
      this.options = _.extend({}, this.defaults, options);
      this.el = el;
      this.$el = $(this.el);
      this.init();
    }


    /**
    		 * Function checks if touch events are supported by modernizr detection and initialize proper events
    		 * @param {obj} data - orbitary data can be passed here to extend method functionality
     */

    TabsScroller.prototype.init = function(data) {
      var cancel, end, move, start;
      move = 'mousemove';
      if (window.navigator.pointerEnabled != null) {
        start = 'pointerdown';
        move = 'pointermove';
        end = 'pointerup';
        cancel = 'pointerout';
      }
      if (window.navigator.msPointerEnabled != null) {
        move = 'MSPointerMove';
      }
      if (Modernizr.touch && (this.el != null)) {
        move = 'touchmove';
      }
      return this.el.addEventListener(move, ((function(_this) {
        return function(event) {
          return _this.touchMove(event);
        };
      })(this)), false);
    };


    /**
    		 * touchMove
    		 * @param {event}
     */

    TabsScroller.prototype.touchMove = function(event) {
      return app.tabsScroll = true;
    };

    return TabsScroller;

  })();
});
