define(['app', 'views/business/change-manager'], function(app, ChangeManagerView) {
  return ChangeManagerView.extend({
    title: app.tr('Select a Shareholder'),
    _loadManagers: function(name, page) {
      var deferred, self;
      deferred = $.Deferred();
      self = this;
      app.server.business.corporative_company.searchManager({
        companyId: self.options.companyId,
        name: name,
        page: page || 1,
        success: function(data) {
          var resultData;
          resultData = {
            users: data.users || []
          };
          resultData.page = page;
          resultData.hasNext = data.has_next || false;
          return deferred.resolve(resultData);
        },
        error: function() {
          return deferred.resolve({
            users: [],
            page: 1,
            hasNext: false
          });
        }
      });
      return deferred;
    },
    setManager: function(event) {
      var companyId, managerId;
      event.stopPropagation();
      this.lockUI();
      companyId = this.options.companyId;
      managerId = event.currentTarget.getAttribute('data-id');
      return app.screens.modal('common/confirmation-popup', {
        msg: app.tr('Are you sure you want assign a new manager?'),
        callback: (function(_this) {
          return function(count) {
            return app.server.business.corporative_company.setManager({
              companyId: companyId,
              managerId: managerId,
              success: function(data) {
                return app.screens.modal('common/success-popup', {
                  msg: data.setFlash[0].msg || app.tr("Appointed new manager")
                }, app.screens.back());
              },
              error: function(data) {
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this)
      });
    }
  });
});
