var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/events/ot.tmpl', 'views/components/currency', 'views/components/strings-helper', 'jquery.countdown'], function(app, ItemView, _, template, formatCurrency, Strings) {
  var OtView;
  OtView = (function(superClass) {
    extend(OtView, superClass);

    function OtView() {
      return OtView.__super__.constructor.apply(this, arguments);
    }

    OtView.prototype.template = _.template(template);

    OtView.prototype.name = 'events/ot';

    OtView.prototype.className = 'events ot';

    OtView.prototype.data = {
      ot: {
        pointer: 'events.ot'
      }
    };

    OtView.prototype.events = {
      'click .btn-score': 'clickKick'
    };

    OtView.prototype._kickInProcess = false;

    OtView.prototype._prevKickCurrency = null;

    OtView.prototype.initialize = function(options) {
      OtView.__super__.initialize.call(this, options);
      this._kickInProcess = false;
      return this._prevKickCurrency = null;
    };

    OtView.prototype.clickKick = function(event) {
      var currentKickCurrency, currentKickPrice, msg;
      if (this._kickInProcess) {
        return;
      }
      currentKickCurrency = this._getKickCurrency();
      currentKickPrice = this._getKickPrice();
      if (this._prevKickCurrency && this._prevKickCurrency !== currentKickCurrency) {
        this._prevKickCurrency = currentKickCurrency;
        msg = Strings.replace({
          ':icon:': currentKickCurrency,
          ':amount:': currentKickPrice
        }, app.tr("Next kick for :amount: :icon:. Continue?"));
        return app.screens.modal('common/confirmation-popup', {
          msg: msg,
          callback: (function(_this) {
            return function() {
              return _this._kick(event);
            };
          })(this)
        });
      } else {
        this._prevKickCurrency = currentKickCurrency;
        return this._kick(event);
      }
    };

    OtView.prototype._kick = function(event) {
      var loader, name, teamId;
      this.lockUI();
      this._kickInProcess = true;
      name = $(event.currentTarget).closest('.js-variant').find('.city-name').text();
      teamId = event.currentTarget.getAttribute('data-team-id');
      loader = this.setLoaderOnElement('.btn-score', '');
      return app.server.events.ot.kick({
        teamId: teamId,
        success: (function(_this) {
          return function(data) {
            var options;
            _this._kickInProcess = false;
            if (data != null ? data.next_kick_cost : void 0) {
              _this._nextKickCost = data.next_kick_cost;
            }
            options = {
              data: data,
              name: name,
              repeat: {
                method: _this.clickKick,
                context: _this,
                event: event
              }
            };
            if (app.gaEnabled) {
              app.ga('send', 'event', 'ot', 'prestige', '' + data.infos.city_id, parseInt(data.kick_report.total_user_damage));
            }
            return _this.listenToOnce(app.vent, 'short-info:dataLoaded', function() {
              loader.remove();
              return app.screens.modal('events/ot-popup', options);
            });
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            loader.remove();
            _this.unlockUI();
            _this._kickInProcess = false;
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg
            });
          };
        })(this)
      });
    };

    OtView.prototype._getKickCurrency = function() {
      var ref, ref1, ref2;
      if (this._nextKickCost != null) {
        return this._nextKickCost.currency;
      } else if (((ref = this._data.ot) != null ? (ref1 = ref.PrestigeWar) != null ? (ref2 = ref1.prestige_war_kick_cost) != null ? ref2.currency : void 0 : void 0 : void 0) != null) {
        return this._data.ot.PrestigeWar.prestige_war_kick_cost.currency;
      } else {
        return null;
      }
    };

    OtView.prototype._getKickPrice = function() {
      var ref, ref1, ref2;
      if (this._nextKickCost != null) {
        return this._nextKickCost.cost;
      } else if (((ref = this._data.ot) != null ? (ref1 = ref.PrestigeWar) != null ? (ref2 = ref1.prestige_war_kick_cost) != null ? ref2.cost : void 0 : void 0 : void 0) != null) {
        return this._data.ot.PrestigeWar.prestige_war_kick_cost.cost;
      } else {
        return 0;
      }
    };

    OtView.prototype.onDataLoadError = function() {
      return this.app.screens.modal('events/low-level-popup', {
        msg: app.tr("You have insufficient level")
      });
    };


    /*
    			Center cloud
     */

    OtView.prototype.centerCloud = function() {};

    OtView.prototype.onDomRefresh = function() {
      var date, ref, showedTime, time;
      this.centerCloud();
      [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
      if (((ref = this._data) != null ? ref.ot : void 0) != null) {
        time = (new Date()).getTime();
        if (this._data.ot.PrestigeWar.is_announce) {
          showedTime = this._data.ot.PrestigeWar.time_to_start;
        } else {
          showedTime = this._data.ot.PrestigeWar.time_to_end;
        }
        date = new Date(time + showedTime * 1000);
        return $('div#ot-countdown').countdown(date, function(event) {
          return $(this).text(event.strftime('%D %H:%M:%S'));
        });
      } else {
        return $('div#ot-countdown').text('');
      }
    };

    return OtView;

  })(ItemView);
  return OtView;
});
