var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'marionette', 'views/item-view', 'underscore', 'views/components/strings-helper'], function(app, Marionette, ItemView, _, Strings) {
  var FriendsBaseView;
  FriendsBaseView = (function(superClass) {
    extend(FriendsBaseView, superClass);

    function FriendsBaseView() {
      return FriendsBaseView.__super__.constructor.apply(this, arguments);
    }

    FriendsBaseView.prototype._name = null;

    FriendsBaseView.prototype.initialize = function() {
      var self;
      FriendsBaseView.__super__.initialize.apply(this, arguments);
      self = this;
      self.listTemplate = _.template(self.listTemplate);
      return self.on('render', function() {
        return self._renderList();
      });
    };

    FriendsBaseView.prototype.onNameChange = function(event) {
      var name;
      name = event.currentTarget.value;
      name = Strings.filterUsername(name);
      event.currentTarget.value = name;
      if (name.length > 2 || !name) {
        this._name = name;
        return this._renderList();
      }
    };

    FriendsBaseView.prototype._filterList = function(list) {
      var filteredList, friend, i, len;
      if (this._name && this._name.length > 2) {
        filteredList = [];
        for (i = 0, len = list.length; i < len; i++) {
          friend = list[i];
          if (Strings.matchName(friend.User.username, this._name, 1)) {
            filteredList.push(friend);
          }
        }
        return filteredList;
      } else {
        return list;
      }
    };

    FriendsBaseView.prototype._groupList = function(list) {
      var group, groups, i, item, j, k, len, len1, len2, ref, ref1;
      if (!this._groups) {
        return {
          "default": list
        };
      }
      groups = {};
      ref = this._groups;
      for (i = 0, len = ref.length; i < len; i++) {
        group = ref[i];
        groups[group.name] = [];
      }
      if (!list || !list.length) {
        return groups;
      }
      for (j = 0, len1 = list.length; j < len1; j++) {
        item = list[j];
        ref1 = this._groups;
        for (k = 0, len2 = ref1.length; k < len2; k++) {
          group = ref1[k];
          if (group.fn(item)) {
            groups[group.name].push(item);
          }
        }
      }
      return groups;
    };

    FriendsBaseView.prototype._renderList = function() {
      var data, listContainer;
      listContainer = this.el.querySelector('#list-container');
      if (!listContainer) {
        return;
      }
      data = this.mixinTemplateHelpers(this.serializeData({}));
      return listContainer.innerHTML = Marionette.Renderer.render(this.listTemplate, data);
    };

    return FriendsBaseView;

  })(ItemView);
  return FriendsBaseView;
});
