var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/guide/guide.tmpl', 'text!templates/guide/translations/ru.tmpl', 'text!templates/guide/translations/en.tmpl'], function(app, ItemView, _, template, trRu, trEn) {
  var GuideView;
  GuideView = (function(superClass) {
    extend(GuideView, superClass);

    function GuideView() {
      this._renderGuide = bind(this._renderGuide, this);
      this.onRender = bind(this.onRender, this);
      return GuideView.__super__.constructor.apply(this, arguments);
    }

    GuideView.prototype.template = template;

    GuideView.prototype.translations = {
      ru: trRu,
      en: trEn
    };

    GuideView.prototype.events = {
      'click .js-goto-url-wiki': 'openWikiUrl'
    };

    GuideView.prototype.openWikiUrl = function() {
      var url;
      url = app.config.wikiURL;
      url = url + (url.indexOf('?') === -1 ? '?' : '&') + 'setlang=' + app.translations.getLn();
      return window.open(url, '_system');
    };

    GuideView.prototype.onRender = function(data) {
      var lang;
      lang = app.translations.localeToLn[app.translations.locale];
      if (!this.translations[lang]) {
        lang = 'en';
      }
      return this._renderGuide(_.template(this.translations[lang]));
    };

    GuideView.prototype._renderGuide = function(tmpl) {
      var fragment;
      fragment = document.createElement('div');
      fragment.innerHTML = Marionette.Renderer.render(tmpl);
      return this.el.querySelector('#guide-container').innerHTML = fragment.innerHTML;
    };

    return GuideView;

  })(ItemView);
  return GuideView;
});
