define(['app', 'views/item-view', 'underscore', 'text!templates/inventory/choose-city.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    required: ['callback'],
    data: {
      'cities': 'cities'
    },
    events: {
      'click .js-choose-city': 'chooseCity'
    },
    chooseCity: function(event) {
      var cityId, cityName;
      this.lockUI();
      cityId = event.currentTarget.getAttribute('data-city-id');
      cityName = this._data.cities.cities[cityId];
      this.options.callback({
        cityId: cityId,
        cityName: cityName
      });
      return app.screens.back();
    }
  });
});
