var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/inventory/use-blueprint.tmpl'], function(app, ItemView, _, template) {
  var UseBlueprintView;
  UseBlueprintView = (function(superClass) {
    extend(UseBlueprintView, superClass);

    function UseBlueprintView() {
      return UseBlueprintView.__super__.constructor.apply(this, arguments);
    }

    UseBlueprintView.prototype.template = template;

    UseBlueprintView.prototype.required = ['itemTypeId', 'productionItem', 'companies'];

    UseBlueprintView.prototype.events = {
      'click .js-select-company': 'onSelectClick',
      'click .js-use': 'onUseClick'
    };

    UseBlueprintView.prototype.initialize = function(options1) {
      this.options = options1;
      UseBlueprintView.__super__.initialize.call(this, this.options);
      return this._selectedCompanyId = null;
    };

    UseBlueprintView.prototype.onSelectClick = function() {
      var company, i, len, name, options, ref;
      options = {};
      ref = this.options.companies;
      for (i = 0, len = ref.length; i < len; i++) {
        company = ref[i];
        name = company.Company.name + ' (' + company.City.name;
        if (company.Corporation) {
          name += ', ' + company.Corporation.name + ')';
        } else {
          name += ')';
        }
        options[company.Company.id] = name;
      }
      return app.screens.modal('common/simple-select-dialog', {
        values: options,
        selected: this._selectedCompanyId,
        callback: (function(_this) {
          return function(id) {
            _this._selectedCompanyId = Number(id);
            return _this.render();
          };
        })(this)
      });
    };

    UseBlueprintView.prototype.onUseClick = function() {
      if (!this._selectedCompanyId) {
        app.screens.modal('common/info-popup', {
          msg: app.tr('Select company')
        });
        return;
      }
      return app.server.business.addBlueprintToProduction({
        userItemId: this.options.itemId,
        companyId: this._selectedCompanyId,
        success: function() {
          return app.screens.close(function() {
            return app.screens.modal('common/success-popup', {
              msg: app.tr("Blueprint used")
            });
          });
        },
        error: function(data) {
          return app.screens.close(function() {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong!")
            });
          });
        }
      });
    };

    UseBlueprintView.prototype.serializeData = function() {
      var company, data, i, len, ref;
      data = UseBlueprintView.__super__.serializeData.call(this);
      data.item = this.options.productionItem;
      data.selectedCompanyName = null;
      if (this._selectedCompanyId) {
        ref = this.options.companies;
        for (i = 0, len = ref.length; i < len; i++) {
          company = ref[i];
          if (company.Company.id === this._selectedCompanyId) {
            data.selectedCompanyName = company.Company.name;
            break;
          }
        }
      }
      return data;
    };

    return UseBlueprintView;

  })(ItemView);
  return UseBlueprintView;
});
