var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['underscore', 'jquery', 'marionette', 'app', 'moment', 'views/components/vertical-swipe', 'views/components/strings-helper', 'views/components/currency', 'views/components/number-helper', 'views/components/tabs-scroller', 'bounce'], function(_, $, Marionette, app, moment, VerticalSwipe, StringsHelper, formatCurrency, NumberHelper, TabsScroller, Bounce) {
  var VCItemView;
  VCItemView = (function(superClass) {
    extend(VCItemView, superClass);

    function VCItemView() {
      this.resetContentScrollPosition = bind(this.resetContentScrollPosition, this);
      this.saveContentScrollPosition = bind(this.saveContentScrollPosition, this);
      this.onDataLoaded = bind(this.onDataLoaded, this);
      this.setContentHeight = bind(this.setContentHeight, this);
      this.render = bind(this.render, this);
      this.initialize = bind(this.initialize, this);
      this.templateHelpers = bind(this.templateHelpers, this);
      return VCItemView.__super__.constructor.apply(this, arguments);
    }

    VCItemView.prototype.lockedUI = false;

    VCItemView.prototype._isReady = false;

    VCItemView.prototype._isLoadCompleted = false;

    VCItemView.prototype.showOnlyAfterLoadData = false;

    VCItemView.prototype.contentLastScrollPosition = null;

    VCItemView.prototype.templateHelpers = function() {
      return {
        moment: moment,
        tr: StringsHelper.tr,
        minAvatar: StringsHelper.minAvatar,
        media: StringsHelper.media,
        avatar: StringsHelper.avatar,
        truncate: StringsHelper.truncate,
        numberHelper: NumberHelper,
        formatCurrency: formatCurrency,
        formatNumber: StringsHelper.formatNumber,
        stringReplace: StringsHelper.stringReplace,
        declOfNum: StringsHelper.declOfNum
      };
    };

    VCItemView.prototype.initialize = function(options1) {
      var currentTabInfo, err, oldOnDomRefresh;
      this.options = options1;
      this.app = app;
      if (this.options.id != null) {
        this.id = this.options.id;
      }
      if (this.options.type != null) {
        this.type = this.options.type;
      }
      this.onBack = this.options.onBack;
      this.onClose = this.options.onClose;
      if (typeof this.template !== 'function') {
        if (this.app.config.debug) {
          try {
            this.template = _.template(this.template);
          } catch (_error) {
            err = _error;
            if (app.config.debug) {
              console.error("Error: template initialization error in " + this.id + " screen");
              console.error(err);
            }
          }
        } else {
          this.template = _.template(this.template);
        }
      }
      this.events = _.extend(this.events, VCItemView.prototype.events);
      this.addListeners();
      if (typeof this.required === "function" ? this.required(this.app.config.debug) : void 0) {
        this.checkRequired();
      }
      if (this.data != null) {
        this.loadData();
      }
      oldOnDomRefresh = this.onDomRefresh;
      this.on('render', (function(_this) {
        return function() {
          _this._triggerReady();
          return _this.app.chat.updateMsgCounter();
        };
      })(this));
      this.on('screens:back', this.setContentHeight);
      this.on('dom:refresh', (function(_this) {
        return function() {
          _this.setContentHeight();
          return _this.app.chat.updateMsgCounter();
        };
      })(this));
      this.listenTo(app.vent, 'layout:resize', this.setContentHeight);
      this.on('before:render', this.saveContentScrollPosition);
      this.on('dom:refresh', (function(_this) {
        return function() {
          _this.resetContentScrollPosition();
          return _this.app.chat.updateMsgCounter();
        };
      })(this));
      this.on('screens:back', (function(_this) {
        return function() {
          _this.resetContentScrollPosition();
          return _this.app.chat.updateMsgCounter();
        };
      })(this));
      this.listenTo(app.vent, 'swipe:reload', (function(_this) {
        return function() {
          if (app.screens.current.cid === _this.cid) {
            return _this.reload();
          }
        };
      })(this));
      this.sendGAView();
      if (typeof this.id === 'string') {
        this.parentId = this.id.split('/')[0];
        this.scrollPositionTabs = window.localStorage.getItem('scrollPositionTabs');
        this.scrollPositionTabs = JSON.parse(this.scrollPositionTabs || '{}');
        currentTabInfo = this.scrollPositionTabs[this.parentId];
        this.scrollPositionTabs = {};
        this.scrollPositionTabs[this.parentId] = currentTabInfo || 0;
        window.localStorage.setItem('scrollPositionTabs', JSON.stringify(this.scrollPositionTabs));
      }
    };

    VCItemView.prototype.render = function() {
      if (this.showOnlyAfterLoadData && (this.data != null)) {
        if (this._isLoadCompleted) {
          return VCItemView.__super__.render.apply(this, arguments);
        }
      } else {
        return VCItemView.__super__.render.apply(this, arguments);
      }
    };

    VCItemView.prototype._triggerReady = function() {
      if (!this._isReady && (!this.data || this._isLoadCompleted)) {
        return this.trigger('ready', this);
      }
    };

    VCItemView.prototype.addListeners = function() {
      return this.on('render', this.unlockUI);
    };

    VCItemView.prototype.showDataLoadProgressBar = function() {
      return app.showLoader();
    };

    VCItemView.prototype.hideDataLoadProgressBar = function() {
      return app.hideLoader();
    };

    VCItemView.prototype.reload = function(callback, showLoader) {
      if (showLoader == null) {
        showLoader = true;
      }
      if (this.app.config.debug) {
        console.log("Info: reload " + this.id + " screen due to files change");
      }
      if (this.data != null) {
        return this.loadData(showLoader);
      } else {
        return this.render();
      }
    };

    VCItemView.prototype.checkDataCacheAndReload = function(showLoader) {
      var key, pointer, ref, ref1, value;
      if (showLoader == null) {
        showLoader = true;
      }
      if (this.data != null) {
        ref = this.data;
        for (key in ref) {
          value = ref[key];
          pointer = (ref1 = value.pointer) != null ? ref1 : value;
          if ((this.app.server[pointer] != null) && (this.app.server.cachePointerToUrl[pointer] != null) && !this.app.server.cache[this.app.server.cachePointerToUrl[pointer]].isValid()) {
            this.saveContentScrollPosition();
            this.loadData(showLoader);
            if (this.app.config.debug) {
              console.log("Info: reload screen " + this.id + " due to data invalidation");
            }
            return;
          }
        }
      }
    };

    VCItemView.prototype.invalidateCacheAndReload = function() {
      var key, pointer, ref, ref1, value;
      if (this.data != null) {
        ref = this.data;
        for (key in ref) {
          value = ref[key];
          pointer = (ref1 = value.pointer) != null ? ref1 : value;
          this.app.server.cache[this.app.server.cachePointerToUrl[pointer]].invalidate();
        }
        this.saveContentScrollPosition();
        this.loadData();
        if (this.app.config.debug) {
          console.log("Info: invalidate data and reload screen " + this.id);
        }
      }
    };

    VCItemView.prototype.events = {

      /*
      				Used to open screens/dialogs without arguments, just add .js-goto-main/dialog/modal/tab class to element
      				and specify data-screen-id attribute. Usefull for tabs.
       */
      'click .js-goto-main': function(event) {
        var screenId;
        app.showLoader();
        this.lockUI();
        screenId = event.currentTarget.getAttribute('data-screen-id');
        return app.screens.main(screenId);
      },
      'click .js-goto-screen': function(event) {
        var options, screenId;
        if (this.app.config.debug) {
          console.error("Error: .js-goto-screen is deprecated, use .js-goto-main or .js-goto-tab instead");
        }
        screenId = event.currentTarget.getAttribute('data-screen-id');
        options = event.currentTarget.getAttribute('data-screen-options');
        if (options != null) {
          return app.screens.main(screenId, {
            screen_options: options
          });
        } else {
          return app.screens.main(screenId);
        }
      },
      'click .js-goto-tab': function(event) {
        var options, screenId;
        this.lockUI();
        screenId = event.currentTarget.getAttribute('data-screen-id');
        options = event.currentTarget.getAttribute('data-screen-options');
        if (options != null) {
          return app.screens.tab(screenId, {
            screen_options: options
          });
        } else {
          return app.screens.tab(screenId);
        }
      },
      'click .js-goto-dialog': function(event) {
        var options, screenId;
        this.lockUI();
        screenId = event.currentTarget.getAttribute('data-screen-id');
        options = event.currentTarget.getAttribute('data-screen-options');
        if (options != null) {
          return app.screens.dialog(screenId, {
            screen_options: options
          });
        } else {
          return app.screens.dialog(screenId);
        }
      },
      'click .js-goto-modal': function(event) {
        var options, screenId;
        this.lockUI();
        screenId = event.currentTarget.getAttribute('data-screen-id');
        options = event.currentTarget.getAttribute('data-screen-options');
        if (options != null) {
          return app.screens.modal(screenId, {
            screen_options: options
          });
        } else {
          return app.screens.modal(screenId);
        }
      },

      /*
      				Used for back buttons in screens to go back or open menu.
      				If screen is dialog(opened with app.screens.dialog()) - it opens previous screens in screens stack.
      				If screen is main(opened with app.screens.main()) - it opens menu.
       */
      'click .js-close': function(event) {
        this.lockUI();
        if (this.type === 'dialog' || this.type === 'modal') {
          app.screens.close();
          if (this.options.onClose != null) {
            return this.options.onClose();
          }
        }
      },
      'click .js-back': 'jsBack',
      'click .js-repeat': function(event) {
        this.jsBack(event);
        this.lockUI();
        return this.options.repeat.method.call(this.options.repeat.context, this.options.repeat.event);
      },
      'click .js-open-menu': function() {
        if (this.app.config.debug) {
          console.log("Warning: .js-open-menu is deprecated, use .js-back instead in " + this.id + " template");
        }
        return app.menu.open();
      },
      'click .js-profile': function(event) {
        var userId;
        this.lockUI();
        userId = event.currentTarget.getAttribute('data-user-id');
        return app.screens.dialog('users/profile', {
          userId: userId
        });
      },
      'click .js-company-overview': function(event) {
        var companyId;
        this.lockUI();
        companyId = event.currentTarget.getAttribute('data-company-id');
        return app.screens.dialog('business/company-overview', {
          companyId: companyId
        });
      },
      'click .js-corporation-overview': function(event) {
        var corporationId;
        this.lockUI();
        corporationId = event.currentTarget.getAttribute('data-corporation-id');
        return app.screens.dialog('business/corporation-overview', {
          corporationId: corporationId
        });
      },
      'click .js-chat': function(event) {
        this.lockUI();
        app.chat.show();
        return setTimeout(this.unlockUI(), 2000);
      },
      'touchend .c-tabs': function(event) {
        this.scrollPositionTabs[this.parentId] = $('.c-tabs > ul').scrollLeft();
        return window.localStorage.setItem('scrollPositionTabs', JSON.stringify(this.scrollPositionTabs));
      }
    };

    VCItemView.prototype.hideElement = function($scrollContainer, $element, className) {
      return $('.js-current-screen').addClass(className);
    };

    VCItemView.prototype.showElement = function($scrollContainer, $element, className) {
      if ($scrollContainer.scrollTop() < 50) {
        return $('.js-current-screen').removeClass(className);
      }
    };


    /*
    			Hide and show element with soecific class on swipe
     */

    VCItemView.prototype.smartHideElement = function() {
      var $element, $scrollContainer, className;
      $scrollContainer = $('.js-current-screen > div');
      $element = $('.c-smart-hide');
      className = 'c-scrolled';
      if (this.vs != null) {
        this.vs.undelegate();
        return this.vs = new VerticalSwipe($scrollContainer[0], {
          onSwipeTop: (function(_this) {
            return function() {
              if (window.innerHeight < 667) {
                return _this.hideElement($scrollContainer, $element, className);
              }
            };
          })(this),
          onSwipeBottom: (function(_this) {
            return function() {
              return _this.showElement($scrollContainer, $element, className);
            };
          })(this)
        });
      }
    };

    VCItemView.prototype.setContentHeight = function() {
      var content, currentScreen, header;
      currentScreen = this.el.parentNode;
      if (currentScreen && currentScreen.classList.contains('js-current-screen')) {
        header = this.el.querySelector('.c-header-wrapper');
        content = this.el.querySelector('.c-content-wrapper');
        if (content) {
          return content.style.height = (currentScreen.offsetHeight - (header ? header.offsetHeight : 0)) + 'px';
        }
      }
    };


    /*
    			You can specify required fields for options if .required hash of view,
    			nesting is available, for example:
    				required: {
    					'item' # @options.item
    					'rightAction.label' # @options.rightAction.label
    				}
     */

    VCItemView.prototype.checkRequired = function() {
      var j, key, keys, len, property, ref, results, root;
      ref = this.required;
      results = [];
      for (j = 0, len = ref.length; j < len; j++) {
        property = ref[j];
        keys = property.split('.');
        root = this.options;
        results.push((function() {
          var k, len1, results1;
          results1 = [];
          for (k = 0, len1 = keys.length; k < len1; k++) {
            key = keys[k];
            if (root[key] == null) {
              throw "Error: property " + property + " should be specified in options for " + this.id + " view";
            }
            results1.push(root = root[key]);
          }
          return results1;
        }).call(this));
      }
      return results;
    };


    /*
    			loads data from .data hash of view and pass them to template
    			there are three ways to specify where to get the data:
    
    				...
    				data:
    					info: 'user.info', # this will be get from app.server.user.info()
    
    					posts: 'fetchPosts', # this will trigger own method
    
    					anyDataOrLibrary: {...} # the object will be passed as-is to templates,
    					 * it's convenient to pass libraries to template
    
    					messages:
    						pointer: 'messages.fromUser' # this will be get from app.server.messages.fromUser()
    						someOtherOption: 'some string' # this field will be passed in app.server.messages.fromUser() as is
    						userId: () -> @options.userId # function is evaluated with this == view
    
    				fetchPosts: ({ success, error }) ->
    				...
    
    			The actual data will be accessable by the variable named the same as the key in the data hash.
    
    			There are build-in variables presented for templating:
    				type - type of the screen, one of 'main'|'dialog'|'modal'
     */

    VCItemView.prototype.loadData = function(showLoader, selector) {
      var data, dataLoaded, err, errorCallback, fromCache, fun, key, onLoad, options, pointer, reauth, reauthCallback, ref, ref1, results, successCallback, value;
      if (showLoader == null) {
        showLoader = true;
      }
      if ((this.data.ignore != null) && this.data.ignore.call(this)) {
        return;
      }
      if (showLoader) {
        app.showLoader();
      }
      this._isLoadCompleted = false;
      this._dataLoaded = false;
      this._data = null;
      fromCache = true;
      data = {};
      dataLoaded = {};
      reauth = false;
      onLoad = (function(_this) {
        return function(key) {
          if (_.every(_.values(dataLoaded))) {
            if (reauth) {
              _this.app.server.invalidateAllCache();
              _this.loadData();
            } else {
              data.fromCache = fromCache;
              _this.trigger('data:loaded', data);
              _this.onDataLoaded(data, selector);
              if (_this.el.querySelector('.c-tabs') != null) {
                new TabsScroller(_this.el.querySelector('.c-tabs'));
              }
              _this.smartHideElement();
              $('.o-main').unbind('click');
              $('.o-main').click(function(event) {
                return event.preventDefault();
              });
            }
          }
        };
      })(this);
      if (this.data instanceof Function) {
        this.data = this.data();
      }
      ref = this.data;
      results = [];
      for (key in ref) {
        fun = ref[key];
        dataLoaded[key] = false;
        if (fun === 'undefined') {
          continue;
        }
        if (typeof fun === 'string' || (fun.pointer != null)) {
          pointer = (ref1 = fun.pointer) != null ? ref1 : fun;
          successCallback = (function(key) {
            return function(_data, _fromCache) {
              fromCache = fromCache && _fromCache;
              data[key] = _data;
              dataLoaded[key] = true;
              return onLoad();
            };
          })(key);
          errorCallback = ((function(_this) {
            return function(pointer) {
              return function(err) {
                _this._isLoadCompleted = true;
                if (showLoader) {
                  app.hideLoader();
                }
                if (_this.onDataLoadError != null) {
                  _this.onDataLoadError(err);
                }
                if (_this.app.config.debug) {
                  console.error("Error: during " + pointer + " load");
                  console.error(err);
                }
                _this._triggerReady();
              };
            };
          })(this))(pointer);
          reauthCallback = function() {
            return reauth = true;
          };
          options = {
            success: successCallback,
            error: errorCallback,
            reauth: reauthCallback
          };
        }
        if (typeof fun === 'string') {
          if (this[fun] != null) {
            if (this.app.config.debug) {
              try {
                results.push(this[fun](options));
              } catch (_error) {
                err = _error;
                if (app.config.debug) {
                  console.error("Error: exception in " + fun + " method of the " + this.id + " view while fetching data for template");
                }
                throw err;
              }
            } else {
              results.push(this[fun](options));
            }
          } else {
            results.push(this.use(fun, options));
          }
        } else if (fun.pointer != null) {
          for (key in fun) {
            value = fun[key];
            if (key !== 'pointer') {
              if (typeof value === 'function') {
                options[key] = value.call(this);
              } else {
                options[key] = value;
              }
            }
          }
          results.push(this.use(fun.pointer, options));
        } else {
          dataLoaded[key] = true;
          data[key] = fun;
          results.push(setTimeout(onLoad, 0));
        }
      }
      return results;
    };

    VCItemView.prototype.use = function(fun, options) {
      if (this.app.server[fun] == null) {
        if (app.config.debug) {
          return console.error("Error: No " + fun + " in app.server");
        }
      } else {
        return this.app.server[fun](options);
      }
    };

    VCItemView.prototype.onDataLoaded = function(data) {
      var err;
      this._isLoadCompleted = true;
      this._data = data;
      this._dataLoaded = true;
      app.vent.trigger(this.id + ":dataLoaded");
      try {
        if (this && !this.isDestroyed) {
          this.render();
        }
      } catch (_error) {
        err = _error;
        if (this.app.config.debug) {
          console.log("Error: Exception while rendering " + this.id + " template");
          setTimeout((function() {
            throw err;
          }), 0);
        }
      }
      if (this._data.fromCache) {
        setTimeout((function(_this) {
          return function() {
            return app.hideLoader();
          };
        })(this), 200);
      } else {
        app.hideLoader();
      }
    };

    VCItemView.prototype.serializeData = function() {
      if (this._data == null) {
        this._data = {};
      }

      /*
      				Build-in variables in templates
       */
      this._data.id = this.id;
      this._data.app = app;
      this._data.type = this.type;
      this._data.options = this.options;
      this._data.model = this.model != null ? this.serializeModel(this.model) : null;
      this._data.collection = this.collection != null ? this.serializeCollection(this.collection) : null;
      if (this._dataLoaded && (this.preprocessData != null)) {
        this._data = this.preprocessData(this._data);
      }
      return this._data;
    };

    VCItemView.prototype.onDataLoadError = function(err) {
      app.hideLoader();
      if (err.error === 1) {
        if (app.screens.hasConnectionErrorPopup) {
          return;
        }
        if (err.isConnectionError) {
          return this.showErrorPopup(err);
        } else {
          if (app.config.debug) {
            return console.log('Error: Unprocessed OnDataLoadError');
          }
        }
      }
    };


    /*
    			Move to previous screen
     */

    VCItemView.prototype.jsBack = function(event) {
      if (this.type === 'main') {
        app.menu.open();
      } else if (this.type === 'dialog' || this.type === 'modal') {
        if ((event != null) && event.currentTarget.getAttribute('data-reset-energy') === "1") {
          app.userEvents.trigger("popup:closed", {});
        }
        if ((event != null) && event.currentTarget.getAttribute('data-close-popup') === "1") {
          app.screens.close();
        } else {
          app.screens.back();
        }
      } else {
        if (app.config.debug) {
          console.log("Warning: probably incorrect use of .js-back in " + this.id + " template, the type of the screen isn't 'main', 'dialog' or 'modal'");
          if (this.id == null) {
            console.log(this);
          }
        }
      }
      if (this.options.onBack != null) {
        return this.options.onBack();
      }
    };

    VCItemView.prototype.onRender = function() {
      var tab;
      if (this.parentId) {
        tab = $('.c-tabs > ul')[0];
        if (tab) {
          tab.scrollLeft = this.scrollPositionTabs[this.parentId];
        }
      }
      this.windowAnimations();
      return this.app.chat.updateMsgCounter();
    };

    VCItemView.prototype.windowAnimations = function() {

      /*
      			if @type is 'modal'
      				popup = @el.querySelector('.c-popup')
      				if(popup)
      					popup.classList.add('c-popup--animate-start')
      					setTimeout(
      						() -> popup.classList.add('c-popup--animate-end')
      						50
      					)
       */
    };

    VCItemView.prototype.lockUI = function() {
      this.lockedUI = true;
      this.undelegateEvents();
      if (this.lockUItimer) {
        clearTimeout(this.lockUItimer);
        this.lockUItimer = null;
      }
      this.lockUItimer = setTimeout(((function(_this) {
        return function() {
          _this.unlockUI();
          if (_this.app.config.debug) {
            return console.log('App UI unlock by Timer ' + _this.id + " [" + _this.cid + "]");
          }
        };
      })(this)), 20000);
      if (this.app.config.debug) {
        return console.log('App UI locked:' + this.id + " [" + this.cid + "]");
      }
    };

    VCItemView.prototype.unlockUI = function() {
      if (this.lockedUI) {
        if (this.lockUItimer) {
          clearTimeout(this.lockUItimer);
        }
        this.delegateEvents();
        this.lockedUI = false;
        if (this.app.config.debug) {
          return console.log('App UI unlocked:' + this.id + " [" + this.cid + "]");
        }
      }
    };

    VCItemView.prototype.sendGAView = function() {
      if (this.app.config.googleAnalyticsEnabled && this.app.ga) {
        return this.app.ga('send', 'pageview', {
          page: '/scr/' + this.options.id,
          title: ''
        });
      }
    };

    VCItemView.prototype.saveContentScrollPosition = function() {
      var content, scroll;
      content = this.el.querySelector('.c-content-wrapper');
      if (!content) {
        this.contentLastScrollPosition = 0;
        return;
      }
      scroll = parseInt(content.scrollTop);
      return this.contentLastScrollPosition = scroll;
    };

    VCItemView.prototype.resetContentScrollPosition = function(reset) {
      var content;
      if (reset == null) {
        reset = true;
      }
      content = this.el.querySelector('.c-content-wrapper');
      if (!content) {
        if (reset) {
          this.contentLastScrollPosition = 0;
        }
        return;
      }
      if (!this.contentLastScrollPosition) {
        return;
      }
      app.scrollTop(content, this.contentLastScrollPosition);
      if (reset) {
        return this.contentLastScrollPosition = 0;
      }
    };

    VCItemView.prototype.tabletLayout = function() {};

    VCItemView.prototype.canvasInnerLayout = function() {};

    VCItemView.prototype.showErrorPopup = function(err) {
      app.screens.hasConnectionErrorPopup = true;
      app.vent.trigger('popup:connection_error:open');
      return app.screens.modal('common/info-popup', {
        msg: err.setFlash[0].msg || app.tr('Server connection error.'),
        needReload: false,
        callback: function() {
          app.screens.hasConnectionErrorPopup = false;
          return app.vent.trigger('popup:connection_error:close');
        }
      });
    };

    VCItemView.prototype.setLoaderOnElement = function(selector, message) {
      var $element, oldText;
      if (message == null) {
        message = 'Loading';
      }
      if (typeof selector === 'string') {
        console.log('el: ', this.$el);
        $element = this.$el.find(selector);
      } else {
        $element = $(selector);
      }
      oldText = $element.html();
      $element.addClass('c-btn--loading');
      if (message !== '') {
        $element.html(app.tr(message));
      }
      return {
        'remove': function() {
          $element.html(oldText);
          return $element.removeClass('c-btn--loading');
        }
      };
    };

    VCItemView.prototype.toggleView = function(toggleBtnSelector, viewSelector) {
      return $(toggleBtnSelector).on('click', function() {
        return $(viewSelector).toggle(400).removeClass('u-hide');
      });
    };

    VCItemView.prototype.numberFormat = function(amount) {
      var i, j, num, number, ref, remainder, sym, tmp;
      number = amount;
      if (number >= 1000) {
        sym = [
          {
            value: 1e18,
            symbol: "E"
          }, {
            value: 1e15,
            symbol: "P"
          }, {
            value: 1e12,
            symbol: "T"
          }, {
            value: 1e9,
            symbol: "G"
          }, {
            value: 1e6,
            symbol: "M"
          }, {
            value: 1e3,
            symbol: "K"
          }
        ];
        remainder = this.getDecimal(amount / 1000) * 1000;
        for (i = j = 0, ref = sym.length; 0 <= ref ? j <= ref : j >= ref; i = 0 <= ref ? ++j : --j) {
          if (number >= sym[i].value) {
            num = Math.floor(number / sym[i].value).toString().replace(/\.0+$|(\.[0-9]*[1-9])0+$/, "$1") + sym[i].symbol;
            if (number / 1000 > 1000) {
              number -= Math.floor(number / sym[i].value) * sym[i].value;
              num = num + ' ' + this.numberFormat(number);
            } else {
              if (remainder > 0) {
                tmp = this.getDecimal(remainder.toFixed(2));
                if (tmp > 0) {
                  num = num + ' ' + remainder.toFixed(2);
                } else {
                  num = num + ' ' + remainder;
                }
              }
            }
            return num;
          }
        }
      }
      return amount;
    };

    VCItemView.prototype.getDecimal = function(value) {
      var dotPos, str;
      str = '' + value;
      dotPos = str.indexOf('.');
      if (dotPos === -1) {
        return 0;
      }
      str = str.slice(dotPos);
      return +str;
    };

    return VCItemView;

  })(Marionette.ItemView);
  return VCItemView;
});
