var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['underscore', 'app', 'views/common/list-view', 'text!templates/lab.tmpl', 'text!templates/blueprints/blocks/blueprints-list.tmpl'], function(_, app, CommonListView, template, listTemplate) {
  var SelectLogoView;
  SelectLogoView = (function(superClass) {
    extend(SelectLogoView, superClass);

    function SelectLogoView() {
      return SelectLogoView.__super__.constructor.apply(this, arguments);
    }

    SelectLogoView.prototype.template = template;

    SelectLogoView.prototype.listTemplate = _.template(listTemplate);

    SelectLogoView.prototype.className = 'no-bg-image';

    SelectLogoView.prototype.events = {
      'click .js-list-element': 'onBlueprintClick',
      'click #js-main-list-load-more': 'onLoadMore'
    };

    SelectLogoView.prototype.initialize = function() {
      SelectLogoView.__super__.initialize.apply(this, arguments);
      this._elements = [];
      this.options.totalCount = 0;
      app.hideLoader();
      this._initialized = false;
      return this.on('dom:refresh', (function(_this) {
        return function() {
          if (!_this._initialized) {
            _this._initialized = true;
            return _this._reloadMainList({
              page: 1
            });
          }
        };
      })(this));
    };

    SelectLogoView.prototype.onBlueprintClick = function(event) {
      var element, i, id, len, ref, result;
      id = Number(event.currentTarget.dataset.id);
      result = null;
      ref = this._elements;
      for (i = 0, len = ref.length; i < len; i++) {
        element = ref[i];
        if (element.id === id) {
          result = element;
          break;
        }
      }
      if (result) {
        return app.screens.modal('blueprints/blueprint-popup', {
          blueprint: result
        });
      }
    };

    SelectLogoView.prototype.onLoadMore = function(event) {
      var page;
      page = Number(event.currentTarget.getAttribute('data-page'));
      return this._appendPageToMainList({
        group: this._group,
        page: page
      });
    };

    SelectLogoView.prototype._reloadMainList = function(options) {
      var container, self;
      container = this.el.querySelector('#js-main-list-content');
      self = this;
      self.lockUI();
      self._showListLoader(container);
      return $.when(self._clearAllLists(), self._loadElements(options)).then(function(ign, data) {
        self._elements = data.elements;
        self.options.totalCount = self._elements.length;
        self.unlockUI();
        self._hideListLoader(container);
        return self._renderList(container, data.elements, data.page, data.hasNext);
      });
    };

    SelectLogoView.prototype._appendPageToMainList = function(options) {
      var container, self;
      container = this.el.querySelector('#js-main-list-content');
      self = this;
      self.lockUI();
      self._showListLoader(container);
      return self._loadElements(options).then(function(data) {
        self._elements = self._elements.concat(data.elements);
        self.options.totalCount = self._elements.length;
        self.unlockUI();
        self._hideListLoader(container);
        return self._renderList(container, data.elements, data.page, data.hasNext);
      });
    };

    SelectLogoView.prototype._loadElements = function(options) {
      var deferred, self;
      deferred = $.Deferred();
      options = options || {};
      self = this;
      app.server.blueprints.list({
        page: options.page || 1,
        success: function(data) {
          var resultData;
          resultData = {
            elements: data.list || []
          };
          resultData.page = options.page || 1;
          resultData.hasNext = data.has_next || false;
          return deferred.resolve(resultData);
        },
        error: function() {
          return deferred.resolve({
            elements: [],
            page: 1,
            hasNext: false
          });
        }
      });
      return deferred;
    };

    return SelectLogoView;

  })(CommonListView);
  return SelectLogoView;
});
