define(['app', 'views/item-view', 'underscore', 'text!templates/login/password-recovery.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    className: 'sign-up-layout',
    template: template,
    events: {
      'click .js-sign-up-submit': 'signUpSubmit'
    },
    signUpSubmit: function(event) {
      var email, recovery;
      this.lockUI();
      event.preventDefault();
      app.server.invalidateAllCache();
      email = this.$el[0].querySelector('.js-user-email').value;
      if (email === "") {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("Email address cannot be empty")
        });
      } else {
        recovery = (function(_this) {
          return function() {
            return _this.app.server.user.passwordRecovery({
              email: email,
              success: function(data) {
                var ref;
                return app.screens.modal('common/info-popup', {
                  msg: ((ref = data.setFlash) != null ? ref[0].msg : void 0) || app.tr("Password was sent to your e-mail.")
                });
              },
              error: function(data) {
                var ref;
                if (app.config.debug) {
                  console.log('Error', data);
                }
                return app.screens.modal('common/info-popup', {
                  msg: ((ref = data.setFlash) != null ? ref[0].msg : void 0) || app.tr("Something went wrong.")
                });
              }
            });
          };
        })(this);
        return this.app.server.logout({
          success: recovery,
          error: recovery
        });
      }
    }
  });
});
