var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/login/sign-up.tmpl', 'md5'], function(app, ItemView, _, template, md5) {
  var SignUpView;
  SignUpView = (function(superClass) {
    extend(SignUpView, superClass);

    function SignUpView() {
      this._setCity = bind(this._setCity, this);
      this.onRender = bind(this.onRender, this);
      return SignUpView.__super__.constructor.apply(this, arguments);
    }

    SignUpView.prototype.className = 'sign-up-layout';

    SignUpView.prototype.template = template;

    SignUpView.prototype.data = {
      data: 'user.registrationInfo'
    };

    SignUpView.prototype.events = {
      'click .js-sign-up-submit': 'signUpSubmit',
      'click .js-select-picture': 'selectAvatar',
      'click .js-select-city': 'selectCity',
      'click .js-policy': 'policy'
    };

    SignUpView.prototype.citiesLocale = {};

    SignUpView.prototype._setCityByDefault = false;

    SignUpView.prototype._cityId = null;

    SignUpView.prototype.preprocessData = function(data) {
      var city, i, len, ref;
      this._cities = {};
      ref = data.data.cities;
      for (i = 0, len = ref.length; i < len; i++) {
        city = ref[i];
        this._cities[city.id] = city;
        this.citiesLocale[city.id] = city.localization;
      }
      return data;
    };

    SignUpView.prototype.onRender = function() {
      this._cityElement = this.el.querySelector('#js-city-title');
      if (this._cities && this._setCityByDefault) {
        return this._setCity(Object.keys(this._cities)[0]);
      }
    };

    SignUpView.prototype.selectAvatar = function(event) {
      this.$('.sign-up-persons__image-wrapper').removeClass('sign-up-persons__image-wrapper--active');
      return $(event.currentTarget).addClass('sign-up-persons__image-wrapper--active');
    };

    SignUpView.prototype.selectCity = function(event) {
      var current, newPos, range, step;
      this.$('.js-city-name').removeAttr('style');
      step = parseInt(event.currentTarget.getAttribute('data-step', 10));
      range = Object.keys(this._cities);
      current = range.indexOf(this._cityId);
      newPos = step + current;
      if (newPos >= range.length) {
        newPos = 0;
      }
      if (newPos < 0) {
        newPos = range.length - 1;
      }
      this._setCity(range[newPos]);
      this.$('#cityLang').html(app.tr(this.citiesLocale[this._cityId]));
      return this.$('.js-city-lang').show();
    };

    SignUpView.prototype._setCity = function(id) {
      var title;
      this._cityId = id;
      title = this._cities[id].title;
      return this._cityElement.value = title;
    };

    SignUpView.prototype.policy = function(event) {
      return app.screens.dialog("login/policy");
    };

    SignUpView.prototype.signUpSubmit = function(event) {
      var avatar, avatarId, cityId, email, hash, password, password_repeat, ref_id, sex, showValidationErrors, username;
      if ((this.processRequest != null) && this.processRequest) {
        return;
      }
      this.lockUI();
      event.preventDefault();
      username = this.$el[0].querySelector('.js-user-username').value;
      email = this.$el[0].querySelector('.js-user-email').value;
      password = this.$el[0].querySelector('.js-user-passwd').value;
      password_repeat = this.$el[0].querySelector('.js-user-passwd_confirm').value;
      avatarId = this.$('.sign-up-persons__image-wrapper--active').attr("data-avatar");
      cityId = this._cityId;
      avatar = this._data.data.avatars[avatarId].avatar_data;
      sex = this._data.data.avatars[avatarId].sex;
      ref_id = this.$el[0].querySelector('.js-user-ref_id').value;
      hash = md5((username + email + password).toLowerCase() + this.app.config.regSalt);
      this.$('.js-city-name').removeAttr('style');
      this.processRequest = true;
      ({
        restoreValue: (function(_this) {
          return function(elem) {
            console.log(elem);
            console.log(elem.getAttribute('value-storage'));
            elem.setAttribute('value', self.getAttribute('value-storage'));
            elem.removeAttribute('value-storage');
            return elem.removeEventListener('focus', _this.restoreValue);
          };
        })(this)
      });
      showValidationErrors = (function(_this) {
        return function(validationErrors) {
          var error, field, results;
          results = [];
          for (field in validationErrors) {
            error = validationErrors[field];
            _this.$(".js-user-" + field).attr('value-storage', _this.$(".js-user-" + field).val());
            document.querySelector(".js-user-" + field).onfocus = function() {
              if (this.hasAttribute('value-storage')) {
                this.value = this.getAttribute('value-storage');
                this.removeAttribute('value-storage');
              }
            };
            results.push(_this.$(".js-user-" + field).addClass("field-error").val("").attr('placeholder', error[0]));
          }
          return results;
        };
      })(this);
      return this.app.server.user.registration({
        hash: hash,
        username: username,
        email: email,
        passwd: password,
        passwd_confirm: password_repeat,
        avatar: avatar,
        sex: sex,
        city_id: cityId,
        ref_id: ref_id,
        success: (function(_this) {
          return function(data) {
            return _this.app.server.logout({
              success: function() {
                _this.processRequest = false;
                return _this.app.server.auth({
                  login: username,
                  password: password,
                  success: function(data) {
                    var adjustEvent, tutorialCb;
                    _this.app.ga('set', 'dimension', '2', data.level.toString());
                    _this.app.ga('set', 'dimension', '3', data.cityName);
                    if (_this.app.adjustEnabled) {
                      adjustEvent = new _this.app.adjust.AdjustEvent("zhgoe9");
                      adjustEvent.addPartnerParameter('event_key', 'zhgoe9');
                      _this.app.adjust.Adjust.trackEvent(adjustEvent);
                    }
                    _this.app.setUserId(data.userId);
                    tutorialCb = function() {
                      var androidTutorOn, browserTutorOn, iosTutorOn, mobileTutorOn, platform;
                      if ((data.trigger_tutorial != null) && data.trigger_tutorial) {
                        platform = app.detectPlatform();
                        iosTutorOn = data.ios_tutor != null ? data.ios_tutor : false;
                        androidTutorOn = data.android_tutor != null ? data.android_tutor : true;
                        mobileTutorOn = data.mobile_tutor != null ? data.mobile_tutor : true;
                        browserTutorOn = data.browser_tutor != null ? data.browser_tutor : true;
                        if (platform === 'ios' && iosTutorOn && mobileTutorOn) {
                          return _this.app.tutorial.start();
                        } else if (platform === 'android' && androidTutorOn && mobileTutorOn) {
                          return _this.app.tutorial.start();
                        } else if (platform === 'browser' && browserTutorOn) {
                          return _this.app.tutorial.start();
                        }
                      }
                    };
                    if ((data.registration_bonus != null) && data.registration_bonus) {
                      app.vent.listenToOnce(app.screens, 'view:ready:quests', function() {
                        return app.screens.modal('common/registration-bonus', {
                          backCallback: tutorialCb
                        });
                      });
                    } else {
                      app.vent.listenToOnce(app.screens, 'view:ready:quests', tutorialCb);
                    }
                    _this.app.screens.main('quests');
                    _this.app.menu.init();
                    _this.app.shortInfo.init();
                    _this.app.pushNotifications.init();
                    return _this.app.vent.trigger('auth:login', {
                      user_id: data.userId
                    });
                  },
                  error: function(data) {
                    var ref;
                    return app.screens.modal('common/info-popup', {
                      msg: ((ref = data.setFlash) != null ? ref[0].msg : void 0) || app.tr("Incorrect login or password")
                    });
                  }
                });
              },
              error: function(data) {
                var ref;
                return app.screens.modal('common/info-popup', {
                  msg: ((ref = data.setFlash) != null ? ref[0].msg : void 0) || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            _this.unlockUI();
            app.hideLoader();
            $(_this.el).find('.js-back').show();
            _this.processRequest = false;
            return showValidationErrors(data['validationErrors']);
          };
        })(this)
      });
    };

    return SignUpView;

  })(ItemView);
  return SignUpView;
});
