define(['app', 'views/item-view', 'underscore', 'text!templates/maria/cups.tmpl', 'views/components/clusterize-helper'], function(app, ItemView, _, template, ClusterizeHelper) {
  return ItemView.extend({
    template: template,
    data: {
      cups: 'cityHall.cups',
      cupsTypes: 'cityHall.cupsTypes',
      cityStatistics: 'cityHall.cityStatistics',
      userStatus: 'user.status'
    },
    onBeforeRender: function() {
      var key, property, resultCups, statistics;
      if (this._data) {
        statistics = {};
        for (key in this._data.cityStatistics) {
          if (typeof this._data.cityStatistics[key] === 'object') {
            for (property in this._data.cityStatistics[key]) {
              statistics[property] = +this._data.cityStatistics[key][property];
            }
          }
        }
        resultCups = [];
        _.forEach(this._data.cupsTypes, (function(_this) {
          return function(cupType) {
            var cup;
            cup = {};
            cup.amount = _this._data.cups[cupType.id] && _this._data.cups[cupType.id].amount || 0;
            cup.need = cupType[cupType.necessary_property].count;
            cup.current = Math.round(statistics[cupType.necessary_property] || 0);
            cup.name = cupType.name;
            cup.description = cupType.description;
            cup.image = cupType.image;
            return resultCups.push(cup);
          };
        })(this));
        return this._data.cups = resultCups;
      }
    },
    onDomRefresh: function() {
      return ClusterizeHelper(this.$el);
    }
  });
});
