var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/maria/districts.tmpl'], function(app, ItemView, _, template) {
  var DistrictsView;
  DistrictsView = (function(superClass) {
    extend(DistrictsView, superClass);

    function DistrictsView() {
      return DistrictsView.__super__.constructor.apply(this, arguments);
    }

    DistrictsView.prototype.template = template;

    DistrictsView.prototype.reloadOnScreensBack = true;

    DistrictsView.prototype.data = {
      userStatus: 'user.status',
      districts: 'military.districts.get',
      rebelWarsRaiseInfo: 'military.rebelWars.raiseInfo'
    };

    DistrictsView.prototype.events = {
      'click .js-finance-rebel': 'financeRebel',
      'click .js-start-rebel': 'startRebel',
      'click .js-select-payment': 'selectPayment',
      'click .js-rebel-control': 'rebelControl',
      'click .js-rebel-donate': 'rebelDonate'
    };

    DistrictsView.prototype.paymentType = {
      currency: 'vd',
      amount: 10000000
    };

    DistrictsView.prototype.chance = {
      vd: {
        value: {
          10000000: 25,
          15000000: 50,
          40000000: 99
        }
      },
      vg: {
        value: {
          5: 25,
          10: 50,
          25: 99
        }
      }
    };

    DistrictsView.prototype.rebelStatus = {
      AGITATION: 1,
      PREPARE_COMBAT: 2,
      COMBAT: 3,
      ENDED: 4
    };

    DistrictsView.prototype.preprocessData = function(data) {
      if (data != null) {
        data.rebelStatus = this.rebelStatus;
      }
      return data;
    };


    /*
    			Center cloud
     */

    DistrictsView.prototype.centerCloud = function() {};

    DistrictsView.prototype.onDomRefresh = function() {
      return this.centerCloud();
    };

    DistrictsView.prototype.financeRebel = function(event) {
      var areaId;
      areaId = parseInt(event.currentTarget.getAttribute('data-area-id'));
      $(".area_" + areaId + " .js-rebels").toggleClass('u-hide');
      return $(".area_" + areaId + " .js-select-payment").first().click();
    };

    DistrictsView.prototype.selectPayment = function(event) {
      var areaId, chance;
      areaId = parseInt(event.currentTarget.getAttribute('data-area-id'));
      $(".area_" + areaId + " .js-select-payment").removeClass('c-btn-group__button--active');
      $(event.currentTarget).addClass('c-btn-group__button--active');
      chance = parseInt(event.currentTarget.getAttribute('data-chance'));
      return $(".area_" + areaId + " .js-progress").width(chance + '%');
    };

    DistrictsView.prototype.startRebel = function(event) {
      var $el, areaId, currency, financialStrength;
      areaId = event.currentTarget.getAttribute('data-area-id');
      $el = $(".area_" + areaId + " .js-select-payment.c-btn-group__button--active");
      currency = $el.attr('data-currency');
      financialStrength = $el.attr('data-strength');
      return app.server.military.rebelWars.raise_uprising({
        areaId: areaId,
        financialStrength: financialStrength,
        currency: currency,
        success: function(data) {
          return app.screens.dialog('maria/rebel-war', {
            rebelWarId: data.rebelWarId
          });
        },
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    };

    DistrictsView.prototype.rebelControl = function(event) {
      var rebelWarId;
      this.lockUI();
      rebelWarId = event.currentTarget.getAttribute('data-rebel-war-id');
      return app.screens.dialog('maria/rebel-war', {
        rebelWarId: rebelWarId
      });
    };

    DistrictsView.prototype.rebelDonate = function(event) {
      var STATUS_AGITATION, STATUS_PREPARE_FOR_COMBAT, loader, rebelWarId, rebelWarStatus, vdAmount, vgAmount;
      STATUS_AGITATION = "1";
      STATUS_PREPARE_FOR_COMBAT = "2";
      rebelWarId = event.currentTarget.getAttribute('data-rebel-war-id');
      rebelWarStatus = $(".rebelWar_" + rebelWarId + " input[name=status]").val();
      vdAmount = $(".rebelWar_" + rebelWarId + " .js-amount-vd").val();
      vgAmount = $(".rebelWar_" + rebelWarId + " .js-amount-vg").val();
      if (vdAmount === "") {
        vdAmount = 0;
      } else {
        vdAmount = parseFloat(vdAmount);
        if (isNaN(vdAmount)) {
          return app.screens.modal('common/info-popup', {
            msg: app.tr("The amount can only consist of digits")
          });
        } else if (vdAmount < 0) {
          return app.screens.modal('common/info-popup', {
            msg: app.tr("The amount must be greater than zero")
          });
        }
      }
      if (vgAmount === "") {
        vgAmount = 0;
      } else {
        vgAmount = parseFloat(vgAmount);
        if (isNaN(vgAmount)) {
          return app.screens.modal('common/info-popup', {
            msg: app.tr("The amount can only consist of digits")
          });
        } else if (vgAmount < 0) {
          return app.screens.modal('common/info-popup', {
            msg: app.tr("The amount must be greater than zero")
          });
        }
      }
      if (vdAmount + vgAmount > 0) {
        this.lockUI();
        loader = this.setLoaderOnElement(event.currentTarget, app.tr('Donating'));
        if (rebelWarStatus === STATUS_AGITATION) {
          app.server.military.rebelWar.agitation_donate({
            rebelWarId: rebelWarId,
            vdAmount: vdAmount,
            vgAmount: vgAmount,
            success: function(data) {
              loader.remove();
              data.vdAmount = vdAmount;
              data.vgAmount = vgAmount;
              return app.screens.modal('maria/rebel_wars/agitation-popup', data);
            },
            error: function(data) {
              loader.remove();
              return app.screens.modal('common/info-popup', {
                msg: data.setFlash[0].msg || app.tr("Something went wrong")
              });
            }
          });
        }
        if (rebelWarStatus === STATUS_PREPARE_FOR_COMBAT) {
          return app.server.military.rebelWar.donate({
            rebelWarId: rebelWarId,
            vdAmount: vdAmount,
            vgAmount: vgAmount,
            success: function(data) {
              loader.remove();
              data.vdAmount = vdAmount;
              data.vgAmount = vgAmount;
              return app.screens.modal('maria/rebel_wars/donate-popup', data);
            },
            error: function(data) {
              loader.remove();
              return app.screens.modal('common/info-popup', {
                msg: data.setFlash[0].msg || app.tr("Something went wrong")
              });
            }
          });
        }
      } else {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("Specify the sum")
        });
      }
    };

    return DistrictsView;

  })(ItemView);
  return DistrictsView;
});
