var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/maria/donate.tmpl'], function(app, ItemView, _, template) {
  var CityHallDonateView;
  CityHallDonateView = (function(superClass) {
    extend(CityHallDonateView, superClass);

    function CityHallDonateView() {
      return CityHallDonateView.__super__.constructor.apply(this, arguments);
    }

    CityHallDonateView.prototype.template = template;

    CityHallDonateView.prototype.required = ['cityId', 'currency'];

    CityHallDonateView.prototype.events = {
      'click .js-apply': 'addFunds',
      'change .js-amount': 'changeAmount',
      'click .o-switcher': 'changeCurrency'
    };

    CityHallDonateView.prototype.changeCurrency = function(event) {
      $(event.currentTarget).toggleClass('o-switcher--active');
      this.$el.find('.js-currency').toggleClass('o-icon--vdollar o-icon--vgold');
      return this.$el.find('.js-apply').toggleClass('c-btn--green c-btn--yellow');
    };

    CityHallDonateView.prototype.changeAmount = function(event) {
      var amount;
      amount = parseFloat(this.$el.find('.js-amount').val());
      if (isNaN(amount) || amount < 0) {
        $(event.currentTarget).val("0.00");
        return this.$el.find('.saved-amount').html("0.00");
      } else {
        $(event.currentTarget).val(amount.toFixed(2));
        return this.$el.find('.saved-amount').html(amount.toFixed(2));
      }
    };

    CityHallDonateView.prototype.addFunds = function(event) {
      var amount, cityId, currency;
      this.lockUI();
      cityId = this.options.cityId;
      amount = parseFloat(this.$el.find('.js-amount').val());
      currency = this.$el.find('.o-switcher').hasClass('o-switcher--active') ? 'vg' : 'vd';
      if (amount === "") {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("Specify the sum")
        });
      } else if (isNaN(amount)) {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("The amount can only consist of digits")
        });
      } else if (amount <= 0) {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("The amount must be greater than zero")
        });
      } else {
        app.server.cityHall.donate({
          cityId: cityId,
          amount: amount.toFixed(2),
          currency: currency,
          success: (function(_this) {
            return function(data) {
              if (app.gaEnabled) {
                app.ga('send', 'event', "city hall", "donation", currency, amount);
              }
              return app.screens.modal('common/success-popup', {
                msg: data.setFlash[0].msg || app.tr("Account refilled")
              });
            };
          })(this)
        });
        return app.screens.back();
      }
    };

    return CityHallDonateView;

  })(ItemView);
  return CityHallDonateView;
});
