define(['app', 'views/item-view', 'underscore', 'text!templates/maria/government.tmpl', 'views/components/clusterize-helper'], function(app, ItemView, _, template, ClusterizeHelper) {
  return ItemView.extend({
    template: template,
    data: {
      government: 'cityHall.government',
      userStatus: 'user.status'
    },
    events: {
      'click .js-snap-election': 'snapElection'
    },
    onDomRefresh: function() {
      return ClusterizeHelper(this.$el);
    },
    snapElection: function(event) {
      var type;
      this.lockUI();
      type = event.currentTarget.getAttribute('data-type');
      return app.server.cityHall.snapElection.vote({
        type: type,
        success: (function(_this) {
          return function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          };
        })(this),
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    }
  });
});
