var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/maria/start-takeover.tmpl'], function(app, ItemView, _, template) {
  var StartTakeoverView;
  StartTakeoverView = (function(superClass) {
    extend(StartTakeoverView, superClass);

    function StartTakeoverView() {
      return StartTakeoverView.__super__.constructor.apply(this, arguments);
    }

    StartTakeoverView.prototype.template = template;

    StartTakeoverView.prototype.data = {
      availableDistricts: 'military.districts.available_for_takeover'
    };

    StartTakeoverView.prototype.events = {
      'click .js-select': 'selectDistrict',
      'click .js-create-takeover': 'createTakeover'
    };

    StartTakeoverView.prototype.preprocessData = function(data) {
      var arrId, item, ref;
      ref = data['availableDistricts']['available_areas'];
      for (arrId in ref) {
        item = ref[arrId];
        item.id = item.CitiesArea.id;
        item.title = item.City.admin_name + ": " + item.CitiesArea.name + app.tr(" (is under control: ") + item.OwnerCity.admin_name + ")";
      }
      this.availableDistrictsCollection = new Backbone.Collection(data['availableDistricts']['available_areas']);
      return data;
    };

    StartTakeoverView.prototype.selectDistrict = function(event) {
      this.lockUI();
      return app.screens.dialog('maria/select-area', {
        collection: this.availableDistrictsCollection,
        callback: (function(_this) {
          return function(itemId) {
            event.currentTarget.setAttribute('data-id', itemId);
            return _this.$('.js-select .js-district-name').html(_this.availableDistrictsCollection.get(itemId).get("title"));
          };
        })(this)
      });
    };

    StartTakeoverView.prototype.createTakeover = function(event) {
      var assailantsCityId, districtId;
      this.lockUI();
      districtId = this.$('.js-select').attr("data-id");
      assailantsCityId = this._data['availableDistricts']['city']['City']['id'];
      if (districtId === "") {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("Please select a quarter")
        });
      } else {
        return app.server.military.at.register({
          areaId: districtId,
          assailantsCityId: assailantsCityId,
          success: function(data) {
            if (app.gaEnabled) {
              app.ga('send', 'event', "city hall", "initiate district fight");
            }
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Areas Takeover has been initiated")
            }, app.screens.back());
          },
          error: function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            }, app.screens.back());
          }
        });
      }
    };

    return StartTakeoverView;

  })(ItemView);
  return StartTakeoverView;
});
