var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/maria/storage.tmpl', 'views/components/currency', 'views/components/clusterize-helper', 'views/components/item-type-comparator'], function(app, ItemView, _, template, formatCurrency, ClusterizeHelper, itemTypeComparatorComponent) {
  var Storage;
  Storage = (function(superClass) {
    extend(Storage, superClass);

    function Storage() {
      return Storage.__super__.constructor.apply(this, arguments);
    }

    Storage.prototype.template = template;

    Storage.prototype.data = {
      userStatus: 'user.status',
      cityItemProposals: 'cityHall.cityItemProposals',
      storage: 'cityHall.storage'
    };

    Storage.prototype.events = {
      'click .js-goto-buying': 'gotoBuying',
      'click .js-lost-settings': 'lotsSettings',
      'click .js-delete-lot': 'deleteLot',
      'click .js-pause-lot': 'pauseLot',
      'click .js-play-lot': 'playLot'
    };

    Storage.prototype.initialize = function() {
      Storage.__super__.initialize.apply(this, arguments);
      return this.itemTypeComparatorFactory = itemTypeComparatorComponent.itemTypeComparatorFactory;
    };

    Storage.prototype.gotoBuying = function(event) {
      this.lockUI();
      return app.quests.doIfCompleted('social_passport', function() {
        return app.screens.dialog('trade-center/trade-center-maria');
      });
    };

    Storage.prototype.lotsSettings = function(event) {
      var cityItemProposalId;
      return cityItemProposalId = event.currentTarget.getAttribute('data-lot-id');
    };

    Storage.prototype.deleteLot = function(event) {
      var cityItemProposalId;
      this.lockUI();
      cityItemProposalId = event.currentTarget.getAttribute('data-lot-id');
      return app.screens.modal('common/confirmation-popup', {
        msg: app.tr('Do you want to delete the purchase?'),
        callback: (function(_this) {
          return function(count) {
            return app.server.cityHall.deleteCityItemProposal({
              cityItemProposalId: cityItemProposalId,
              success: function(data) {
                return app.screens.modal('common/success-popup', {
                  msg: data.setFlash[0].msg || app.tr("Purchase has been deleted")
                });
              },
              error: function(data) {
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this)
      });
    };

    Storage.prototype.pauseLot = function(event) {
      var cityItemProposalId;
      this.lockUI();
      cityItemProposalId = event.currentTarget.getAttribute('data-lot-id');
      return app.screens.modal('common/confirmation-popup', {
        msg: app.tr('Are you sure you want to suspend the purchase?'),
        callback: (function(_this) {
          return function(count) {
            return app.server.cityHall.pauseCityItemProposal({
              cityItemProposalId: cityItemProposalId,
              success: function(data) {
                return app.screens.modal('common/success-popup', {
                  msg: data.setFlash[0].msg || app.tr("Purchase is paused")
                });
              },
              error: function(data) {
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this)
      });
    };

    Storage.prototype.playLot = function(event) {
      var cityItemProposalId;
      this.lockUI();
      cityItemProposalId = event.currentTarget.getAttribute('data-lot-id');
      return app.screens.modal('common/confirmation-popup', {
        msg: app.tr('D you want to launch the purchase?'),
        callback: (function(_this) {
          return function(count) {
            return app.server.cityHall.pauseCityItemProposal({
              cityItemProposalId: cityItemProposalId,
              success: function(data) {
                return app.screens.modal('common/success-popup', {
                  msg: data.setFlash[0].msg || app.tr("Purchase is active")
                });
              },
              error: function(data) {
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this)
      });
    };

    Storage.prototype.onDomRefresh = function() {
      [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
      return ClusterizeHelper(this.$el, 30, true);
    };

    Storage.prototype.serializeData = function() {
      var data, itemTypeComparator;
      data = Storage.__super__.serializeData.apply(this, arguments);
      if (data && (data.storage != null) && data.storage.storage.length !== 0) {
        itemTypeComparator = this.itemTypeComparatorFactory(data.storage.categorySortWeight);
        data.storage.storage = data.storage.storage.sort(itemTypeComparator);
      }
      return data;
    };

    return Storage;

  })(ItemView);
  return Storage;
});
