define(['app', 'views/item-view', 'underscore', 'text!templates/maria/technologies-step-3.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  return ItemView.extend({
    template: template,
    required: ['evolutionId'],
    data: {
      userStatus: 'user.status',
      info: {
        pointer: 'cityHall.evolutionInfo',
        evolutionId: function() {
          return this.options.evolutionId;
        }
      }
    },
    events: {
      'click .js-explore': 'startVoting'
    },
    onDomRefresh: function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    },
    startVoting: function(event) {
      this.lockUI();
      return app.server.cityHall.evolutionStartVoting({
        evolutionId: this.options.evolutionId,
        success: (function(_this) {
          return function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Technology studied")
            });
          };
        })(this)
      });
    }
  });
});
