var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/messages.tmpl', 'views/components/horizontal-swipe', 'jquery', 'velocity-ui'], function(app, ItemView, _, template, HorizontalSwipe, $) {
  var MessagesView;
  MessagesView = (function(superClass) {
    extend(MessagesView, superClass);

    function MessagesView() {
      return MessagesView.__super__.constructor.apply(this, arguments);
    }

    MessagesView.prototype.className = 'messages-layout';

    MessagesView.prototype.template = template;

    MessagesView.prototype.data = {
      messages: 'messages'
    };

    MessagesView.prototype.events = {
      'click .js-goto-conversations': 'gotoConversations',
      'click .js-delete-dialog': 'onDeleteBtnClick',
      'click .js-hide-dialog': 'onHideBtnClick',
      'click .js-goto-profile': 'gotoProfile'
    };

    MessagesView.prototype.addListeners = function() {
      MessagesView.__super__.addListeners.apply(this, arguments);
      return this.listenTo(app, 'User.messages.UnreadCount.update', (function(_this) {
        return function() {
          return _this.reload();
        };
      })(this));
    };

    MessagesView.prototype.gotoConversations = function(event) {
      var userId;
      this.lockUI();
      userId = event.currentTarget.getAttribute('data-user-id');
      return app.screens.dialog('messages/conversations', {
        userId: userId
      });
    };

    MessagesView.prototype.gotoProfile = function(event) {
      var hasProfile, userId;
      this.lockUI();
      event.stopPropagation();
      userId = event.currentTarget.getAttribute('data-user-id');
      hasProfile = event.currentTarget.getAttribute('data-user-has-profile') === 'true';
      if (hasProfile) {
        return app.screens.dialog('users/profile', {
          userId: userId
        });
      }
    };


    /*
    			Center cloud
     */

    MessagesView.prototype.centerCloud = function() {};

    MessagesView.prototype.onDomRefresh = function() {
      this.centerCloud();
      return this._bindSwipeEvents();
    };

    MessagesView.prototype._bindSwipeEvents = function() {
      var element, i, len, msgElements, results;
      msgElements = this.el.querySelectorAll('.js-message');
      if (msgElements && msgElements.length) {
        results = [];
        for (i = 0, len = msgElements.length; i < len; i++) {
          element = msgElements[i];
          if (!Number(element.getAttribute('data-has-swipe'))) {
            element.__swipe = new HorizontalSwipe(element, {
              onSwipeLeft: this._onSwipeLeft,
              onSwipeRight: this._onSwipeRight
            });
            results.push(element.setAttribute('data-has-swipe', 1));
          } else {
            results.push(void 0);
          }
        }
        return results;
      }
    };

    MessagesView.prototype._onSwipeLeft = function(event) {
      var btns, el, parent;
      $('.c-message-wrapper').css('margin-left', '0px').css('width', '100%');
      $('.c-message-btns').addClass('hidden');
      this.lockUI;
      el = event.currentTarget;
      parent = el.parentNode;
      btns = parent.querySelector('.c-message-btns');
      parent.style.width = (parent.parentNode.offsetWidth + 105) + 'px';
      btns.classList.remove('hidden');
      return $.Velocity(parent, {
        'margin-left': '-100px'
      }, {
        easing: 'easeInSine'
      }, (function(_this) {
        return function() {
          return _this.unlockUI;
        };
      })(this));
    };

    MessagesView.prototype._onSwipeRight = function(event) {
      var btns, el, parent;
      this.lockUI;
      el = event.currentTarget;
      parent = el.parentNode;
      btns = parent.querySelector('.c-message-btns');
      return $.Velocity(parent, {
        'margin-left': '0px'
      }, {
        easing: 'easeInSine'
      }, (function(_this) {
        return function() {
          _this.unlockUI;
          $('.c-message-wrapper').css('margin-left', '0px').css('width', '100%');
          return btns.classList.add('hidden');
        };
      })(this));
    };

    MessagesView.prototype.onHideBtnClick = function(e) {
      var receiverId;
      receiverId = Number(e.currentTarget.dataset.userId);
      if (!receiverId) {
        return;
      }
      return app.screens.modal('common/confirmation-popup', {
        msg: app.tr('Are you sure you want to hide dialog?'),
        callback: (function(_this) {
          return function() {
            return _this.hide(receiverId);
          };
        })(this)
      });
    };

    MessagesView.prototype.hide = function(receiverId) {
      return app.server.messages.hideDialog({
        userId: receiverId,
        success: function(data) {
          return app.screens.modal('common/success-popup', {
            msg: data.setFlash[0].msg
          });
        },
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    };

    MessagesView.prototype.onDeleteBtnClick = function(e) {
      var receiverId;
      receiverId = Number(e.currentTarget.dataset.userId);
      if (!receiverId) {
        return;
      }
      return app.screens.modal('common/confirmation-popup', {
        msg: app.tr('Are you sure you want to delete dialog?'),
        callback: (function(_this) {
          return function() {
            return _this["delete"](receiverId);
          };
        })(this)
      });
    };

    MessagesView.prototype["delete"] = function(receiverId) {
      return app.server.messages.deleteDialog({
        userId: receiverId,
        success: function(data) {
          return app.screens.modal('common/success-popup', {
            msg: data.setFlash[0].msg
          });
        },
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    };

    return MessagesView;

  })(ItemView);
  return MessagesView;
});
