define(['app', 'views/item-view', 'underscore', 'text!templates/military-base/at-post-log-popup.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      cities: 'cities',
      result: {
        pointer: 'military.at.postResult',
        roundId: function() {
          return this.options.roundId;
        },
        postId: function() {
          return this.options.postId;
        }
      }
    },
    events: {
      'click .js-select-filter': 'selectFilter',
      'click .js-goto-result': 'goToRoundResult'
    },
    selectFilter: function(event) {
      var currentFilter, filter, logEl;
      filter = event.currentTarget.getAttribute('data-type');
      logEl = this.el.querySelector('.js-log');
      currentFilter = logEl.getAttribute('data-show');
      if (currentFilter === filter) {
        return logEl.setAttribute('data-show', 'all');
      } else {
        return logEl.setAttribute('data-show', filter);
      }
    },
    goToRoundResult: function() {
      var roundId;
      this.lockUI();
      roundId = this.options.roundId;
      return this.app.screens.modal('military-base/at-round-result-popup', {
        roundId: roundId
      }, app.screens.back());
    },
    onDomRefresh: function() {
      return this.$el.find('.c-popup__height').css('max-height', $(document).height() - 300);
    }
  });
});
