define(['app', 'views/item-view', 'underscore', 'text!templates/military-base/at-round-result-popup.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      cities: 'cities',
      result: {
        pointer: 'military.at.roundResult',
        roundId: function() {
          return this.options.roundId;
        }
      }
    },
    events: {
      'click .js-goto-post': 'gotoPost',
      'click .js-close-popup': 'jsClose'
    },
    gotoPost: function(event) {
      var postId;
      this.lockUI();
      postId = event.currentTarget.getAttribute('data-post-id');
      return app.screens.modal('military-base/at-post-log-popup', {
        roundId: this.options.roundId,
        postId: postId
      }, app.screens.back());
    },
    jsClose: function(event) {
      return app.screens.back(function() {
        return app.screens.current.reload();
      });
    }
  });
});
