var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/military-base/fight-pvp-details-popup.tmpl'], function(app, ItemView, _, template) {
  var PvPDetails;
  PvPDetails = (function(superClass) {
    extend(PvPDetails, superClass);

    function PvPDetails() {
      return PvPDetails.__super__.constructor.apply(this, arguments);
    }

    PvPDetails.prototype.template = template;

    PvPDetails.prototype.events = {
      'click .js-pvp-results': 'gotoPvPResult',
      'click .js-show-log': 'showLog'
    };

    PvPDetails.prototype.initialize = function(options) {
      console.log('1');
      console.log(options);
      this.prepareData();
      return PvPDetails.__super__.initialize.apply(this, arguments);
    };

    PvPDetails.prototype.prepareData = function() {
      var def, item, j, len, lost, ref, showData;
      if (this.options.to_show) {
        showData = this.options[this.options['to_show']];
      } else {
        showData = this.options['win'];
      }
      def = [];
      ref = showData.armor;
      for (j = 0, len = ref.length; j < len; j++) {
        item = ref[j];
        switch (item.type) {
          case 'armorHead':
            def[0] = item;
            break;
          case 'armorBody':
            def[1] = item;
            break;
          case 'armorLegs':
            def[2] = item;
            break;
          case 'armorBoots':
            def[3] = item;
            break;
          default:
            console.log(item);
        }
      }
      showData.def = def;
      if (!showData.itemsLeft) {
        showData.itemsLeft = [];
      }
      if (!showData.itemsLost) {
        showData.itemsLost = [];
      }
      if (!showData.brokenItems) {
        showData.brokenItems = [];
      }
      if (!showData.itemsEarned) {
        showData.itemsEarned = [];
      }
      lost = showData.itemsLost.concat(showData.brokenItems);
      this.checkBrokenItems(showData.def, lost);
      this.checkBrokenItems(showData.weapons, lost);
      this.checkBrokenItems(showData.gadgets, lost);
      return this.options.showData = showData;
    };

    PvPDetails.prototype.checkBrokenItems = function(itemType, lost) {
      var i, item, j, len, results;
      results = [];
      for (j = 0, len = itemType.length; j < len; j++) {
        item = itemType[j];
        if (!item) {
          continue;
        }
        if (!lost.length) {
          break;
        }
        if (item.broken === void 0) {
          item.broken = false;
        }
        results.push((function() {
          var k, ref, results1;
          results1 = [];
          for (i = k = 0, ref = lost.length - 1; 0 <= ref ? k <= ref : k >= ref; i = 0 <= ref ? ++k : --k) {
            if (lost[i]['id'] === item['id']) {
              lost.splice(i, 1);
              item.broken = true;
              break;
            } else {
              results1.push(void 0);
            }
          }
          return results1;
        })());
      }
      return results;
    };

    PvPDetails.prototype.gotoPvPResult = function() {
      this.lockUI();
      return app.screens.tab('military-base/fight-pvp-result-popup', this.options);
    };

    PvPDetails.prototype.showLog = function() {
      this.lockUI();
      return app.screens.tab('military-base/fight-pvp-log-popup', this.options);
    };

    PvPDetails.prototype.onDomRefresh = function() {
      return this.$el.find('.c-popup__height').css('max-height', $(window).height() - 300);
    };

    return PvPDetails;

  })(ItemView);
  return PvPDetails;
});
