var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/military-base/fight-log-popup.tmpl'], function(app, ItemView, _, template) {
  var FightLogPopup;
  FightLogPopup = (function(superClass) {
    extend(FightLogPopup, superClass);

    function FightLogPopup() {
      return FightLogPopup.__super__.constructor.apply(this, arguments);
    }

    FightLogPopup.prototype.template = template;

    FightLogPopup.prototype.events = {
      'click .js-goto-pve-result': 'gotoPvPResult',
      'click .js-select-filter': 'selectFilter'
    };

    FightLogPopup.prototype.initialize = function(options) {
      this.processClones();
      return FightLogPopup.__super__.initialize.apply(this, arguments);
    };

    FightLogPopup.prototype.processClones = function() {
      var clone, enemy, helpers;
      helpers = this.mixinTemplateHelpers();
      clone = {
        name: this.options.clone.name,
        avatar: helpers.minAvatar(this.options.clone.avatar)
      };
      if (this.options.fightType === 'pve') {
        enemy = {
          avatar: "http://" + app.config.serverURL + "/img/bands/" + this.options.enemies[0].avatar
        };
        if (this.options.enemies.length === 1) {
          enemy.name = this.options.enemies[0].name;
        } else {
          enemy.name = app.tr('Group of bandits');
        }
      } else {
        enemy = {
          name: this.options.enemy.name,
          avatar: "./images/avatars/" + (this.options.enemy.avatar.replace('.png', '')) + "_avatar.png"
        };
      }
      if (this.options.userWin) {
        this.options.winner = clone;
        return this.options.looser = enemy;
      } else {
        this.options.winner = enemy;
        return this.options.looser = clone;
      }
    };

    FightLogPopup.prototype.gotoPvPResult = function() {
      this.lockUI();
      return app.screens.tab('military-base/fight-pvp-details-popup', this.options);
    };

    FightLogPopup.prototype.selectFilter = function(event) {
      var currentFilter, filter, logEl;
      filter = event.currentTarget.getAttribute('data-type');
      logEl = this.el.querySelector('.js-log');
      currentFilter = logEl.getAttribute('data-show');
      if (currentFilter === filter) {
        return logEl.setAttribute('data-show', 'all');
      } else {
        return logEl.setAttribute('data-show', filter);
      }
    };

    FightLogPopup.prototype.onDomRefresh = function() {
      return this.$el.find('.c-popup__height').css('max-height', $(window).height() - 300);
    };

    return FightLogPopup;

  })(ItemView);
  return FightLogPopup;
});
