var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/military-base/fight-pvp-result-popup.tmpl'], function(app, ItemView, _, template) {
  var FightResultPopup;
  FightResultPopup = (function(superClass) {
    extend(FightResultPopup, superClass);

    function FightResultPopup() {
      return FightResultPopup.__super__.constructor.apply(this, arguments);
    }

    FightResultPopup.prototype.template = template;

    FightResultPopup.prototype.events = {
      'click .js-goto-pvp-details': 'gotoPvPdetails',
      'click .js-toggle-accordeon': 'toggleAccordeon'
    };

    FightResultPopup.prototype.initialize = function(options) {
      this.processClones();
      return FightResultPopup.__super__.initialize.apply(this, arguments);
    };

    FightResultPopup.prototype.processClones = function() {
      var i, item, j, k, ref, ref1;
      console.log('income ->');
      console.log(this.options);
      if (this.options.userWin) {
        this.options.win = this.options.result.clone;
        this.options.win.brokenItems = this.options.result.brokenItems;
        if (this.options.result.itemsLost) {
          this.options.win.itemsLost = this.options.result.itemsLost;
        }
        this.options.loose = this.options.result.enemyClone;
      } else {
        this.options.win = this.options.result.enemyClone;
        this.options.loose = this.options.result.clone;
        this.options.loose.brokenItems = this.options.result.brokenItems;
        if (this.options.result.itemsLost) {
          this.options.loose.itemsLost = this.options.result.itemsLost;
        }
      }
      for (i = j = 0, ref = this.options.win.armor.length; 0 <= ref ? j <= ref : j >= ref; i = 0 <= ref ? ++j : --j) {
        if ((this.options.win.armor[i] != null) && this.options.win.armor[i].type === "armorBody") {
          item = this.options.win.armor.splice(i, 1);
          this.options.win.armor = item.concat(this.options.win.armor);
          break;
        }
      }
      for (i = k = 0, ref1 = this.options.loose.armor.length; 0 <= ref1 ? k <= ref1 : k >= ref1; i = 0 <= ref1 ? ++k : --k) {
        if ((this.options.loose.armor[i] != null) && this.options.loose.armor[i].type === "armorBody") {
          item = this.options.loose.armor.splice(i, 1);
          this.options.loose.armor = item.concat(this.options.loose.armor);
          break;
        }
      }
      return console.log(this.$el);
    };

    FightResultPopup.prototype.toggleAccordeon = function(event) {
      var arrowEl, blockEl, blockId, expanded;
      arrowEl = event.currentTarget.getElementsByTagName('i')[0];
      blockId = arrowEl.getAttribute('data-block-id');
      blockEl = this.el.querySelector(".js-block[data-block-id=\"" + blockId + "\"]");
      expanded = arrowEl.getAttribute('data-expanded') === 'true';
      if (expanded) {
        arrowEl.setAttribute('data-expanded', 'false');
        arrowEl.classList.add('c-icon-arrow-down-4');
        arrowEl.classList.remove('c-icon-arrow-up-4');
        return blockEl.classList.add('hidden');
      } else {
        arrowEl.setAttribute('data-expanded', 'true');
        arrowEl.classList.remove('c-icon-arrow-down-4');
        arrowEl.classList.add('c-icon-arrow-up-4');
        return blockEl.classList.remove('hidden');
      }
    };

    FightResultPopup.prototype.gotoPvPdetails = function(event) {
      this.options.to_show = event.currentTarget.getAttribute('data-id-sender');
      this.lockUI();
      return app.screens.tab('military-base/fight-pvp-details-popup', this.options);
    };

    FightResultPopup.prototype.onDomRefresh = function() {
      return this.$el.find('.c-popup__height').css('max-height', $(window).height() - 300);
    };

    return FightResultPopup;

  })(ItemView);
  return FightResultPopup;
});
