var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/military-base/store.tmpl'], function(app, ItemView, _, template) {
  var MilitaryBaseStoreView;
  MilitaryBaseStoreView = (function(superClass) {
    extend(MilitaryBaseStoreView, superClass);

    function MilitaryBaseStoreView() {
      this.onBeforeDestroy = bind(this.onBeforeDestroy, this);
      this._updateTimer = bind(this._updateTimer, this);
      this._updateTimers = bind(this._updateTimers, this);
      this.onItemBuy = bind(this.onItemBuy, this);
      this.preprocessData = bind(this.preprocessData, this);
      return MilitaryBaseStoreView.__super__.constructor.apply(this, arguments);
    }

    MilitaryBaseStoreView.prototype.template = template;

    MilitaryBaseStoreView.prototype.className = 'military-layout';

    MilitaryBaseStoreView.prototype.data = {
      info: 'military.info',
      shop: {
        pointer: 'shop.militarylist'
      }
    };

    MilitaryBaseStoreView.prototype.events = {
      'click .js-buy': 'onItemBuy'
    };

    MilitaryBaseStoreView.prototype._timerIntervalId = 0;

    MilitaryBaseStoreView.prototype._goods = {};

    MilitaryBaseStoreView.prototype.preprocessData = function(data) {
      var goods, i, len, ref, ref1, timer;
      if ((data != null ? (ref = data.shop) != null ? ref.goods : void 0 : void 0)) {
        timer = false;
        ref1 = data.shop.goods;
        for (i = 0, len = ref1.length; i < len; i++) {
          goods = ref1[i];
          if (goods.discount) {
            goods.color = 'red';
          } else {
            goods.color = 'yellow';
          }
          if (goods.is_special) {
            goods.color = 'blue';
          }
          if (goods.published_end) {
            goods.time_left = this._intervalStringFromTimestamp(goods.published_end);
            timer = true;
          }
          this._goods[goods.id] = goods;
        }
        if (timer) {
          this._timerIntervalId = setInterval(this._updateTimers, 1000);
        }
      }
      return data;
    };

    MilitaryBaseStoreView.prototype.onItemBuy = function(event) {
      var itemId;
      itemId = event.currentTarget.getAttribute('data-item-id');
      app.server.cache[app.server.cachePointerToUrl['military.info']].invalidate();
      return this.app.screens.modal('shop/purchase-popup', {
        item: this._goods[itemId],
        currency: 3,
        closeOnBack: true
      });
    };

    MilitaryBaseStoreView.prototype._updateTimers = function() {
      var element, elements, i, len, results;
      elements = this.el.querySelectorAll('.js-shop-timer');
      results = [];
      for (i = 0, len = elements.length; i < len; i++) {
        element = elements[i];
        results.push(this._updateTimer(element));
      }
      return results;
    };

    MilitaryBaseStoreView.prototype._updateTimer = function(el) {
      var end, id, item, str;
      end = parseInt(el.getAttribute('data-timestamp')) || 0;
      str = this._intervalStringFromTimestamp(end);
      if (str) {
        return el.innerHTML = str;
      } else {
        id = el.getAttribute('data-item-id');
        item = this.el.querySelector('#js-shop-item-' + id);
        return item.parentNode.removeChild(item);
      }
    };

    MilitaryBaseStoreView.prototype._intervalStringFromTimestamp = function(timestamp) {
      var diff, div, key, now, part, parts, strParts, strTime;
      now = Math.floor((new Date()).getTime() / 1000);
      diff = timestamp - now;
      if (diff <= 0) {
        return null;
      }
      parts = {
        'days': 3600 * 24,
        'hours': 3600,
        'minutes': 60
      };
      strParts = {};
      for (key in parts) {
        div = parts[key];
        strParts[key] = Math.floor(diff / div);
        diff = diff - strParts[key] * div;
      }
      strParts['seconds'] = diff;
      for (key in strParts) {
        part = strParts[key];
        part = part.toString();
        strParts[key] = part.length < 2 ? '0' + part : part;
      }
      strTime = '';
      if (strParts['days'] !== '00') {
        strTime = strTime + strParts['days'] + ' ';
      }
      strTime = strTime + ' ' + strParts['hours'] + ':' + strParts['minutes'] + ':' + strParts['seconds'];
      return strTime;
    };

    MilitaryBaseStoreView.prototype.onBeforeDestroy = function() {
      if (this._timerIntervalId) {
        return clearInterval(this._timerIntervalId);
      }
    };


    /*
    			Center cloud
     */

    MilitaryBaseStoreView.prototype.centerCloud = function() {};

    MilitaryBaseStoreView.prototype.onDomRefresh = function() {
      return this.centerCloud();
    };

    return MilitaryBaseStoreView;

  })(ItemView);
  return MilitaryBaseStoreView;
});
