var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/news/all-news.tmpl', 'text!templates/news/blocks/newspapers-list.tmpl', 'views/components/lazy-loading', 'views/common/lazy-loading-view'], function(app, ItemView, _, template, listTemplate, LazyLoading, CommonLazyView) {
  var AllNews;
  AllNews = (function(superClass) {
    extend(AllNews, superClass);

    function AllNews() {
      this._loadData = bind(this._loadData, this);
      this.loadData = bind(this.loadData, this);
      return AllNews.__super__.constructor.apply(this, arguments);
    }

    AllNews.prototype.template = template;

    AllNews.prototype.listTemplate = _.template(listTemplate);

    AllNews.prototype.pointer = 'newspaper';

    AllNews.prototype.data = {
      newspaper: {
        pointer: 'news.recommendations',
        page: 1
      }
    };

    AllNews.prototype.events = {
      'click .js-newspaper': 'goToNewspaper',
      'click .js-post': 'goToPost'
    };

    AllNews.prototype.goToNewspaper = function(event) {
      var newspaperSlug;
      this.lockUI();
      newspaperSlug = event.currentTarget.getAttribute('data-newspaper-slug');
      return app.screens.dialog('news/newspaper', {
        newspaperSlug: newspaperSlug
      }, (function(_this) {
        return function() {
          return _this.unlockUI();
        };
      })(this));
    };

    AllNews.prototype.goToPost = function(event) {
      var newspaperSlug, postId;
      this.lockUI();
      postId = event.currentTarget.getAttribute('data-post-id');
      newspaperSlug = event.currentTarget.getAttribute('data-newspaper-slug');
      return app.screens.dialog('news/article', {
        newspaperSlug: newspaperSlug,
        postId: postId
      }, (function(_this) {
        return function() {
          return _this.unlockUI();
        };
      })(this));
    };

    AllNews.prototype.loadData = function() {
      this.data.newspaper.page = 1;
      return AllNews.__super__.loadData.call(this);
    };

    AllNews.prototype._loadData = function(page) {
      var deferred, self;
      deferred = $.Deferred();
      self = this;
      app.server.news.recommendations({
        page: page || 1,
        success: (function(_this) {
          return function(data) {
            var resultData;
            resultData = data;
            resultData.page = page;
            resultData.hasNext = data.has_next || false;
            _this.hasNext = data.paging.NewspaperPost.nextPage || false;
            _this.data.newspaper.page++;
            return deferred.resolve(resultData);
          };
        })(this),
        error: function() {
          return deferred.resolve({
            users: [],
            page: 1,
            hasNext: false
          });
        }
      });
      return deferred;
    };


    /*
    			Center cloud
     */

    AllNews.prototype.centerCloud = function() {};

    AllNews.prototype.onDomRefresh = function() {
      return this.centerCloud();
    };

    return AllNews;

  })(CommonLazyView);
  return AllNews;
});
