var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/news/create-article.tmpl'], function(app, ItemView, _, template) {
  var CreateArticle;
  CreateArticle = (function(superClass) {
    extend(CreateArticle, superClass);

    function CreateArticle() {
      this._triggerKeyboardHide = bind(this._triggerKeyboardHide, this);
      this._triggerKeyboardShow = bind(this._triggerKeyboardShow, this);
      this.initialize = bind(this.initialize, this);
      return CreateArticle.__super__.constructor.apply(this, arguments);
    }

    CreateArticle.prototype.template = template;

    CreateArticle.prototype.className = 'no-bg-image dont-reload';

    CreateArticle.prototype.data = {
      blocks: 'user.blocks'
    };

    CreateArticle.prototype.events = {
      'click .js-create-article': 'createArticle',
      'input .js-textarea': 'resizeArea'
    };

    CreateArticle.prototype.initialize = function(options) {
      this.options = options;
      CreateArticle.__super__.initialize.call(this, this.options);
      this.listenTo(app, "keyboard:show", this._triggerKeyboardShow);
      return this.listenTo(app, "keyboard:hide", this._triggerKeyboardHide);
    };

    CreateArticle.prototype._triggerKeyboardShow = function(keyboardHeight) {
      return this.$el.find('.js-textarea').css('max-height', $(window).height() - keyboardHeight - 250 + 'px');
    };

    CreateArticle.prototype._triggerKeyboardHide = function() {
      return this.$el.find('.js-textarea').css('max-height', $(window).height() - 250 + 'px');
    };

    CreateArticle.prototype.resizeArea = function() {
      var text;
      text = this.el.querySelector('.js-textarea');
      if (text != null) {
        text.style.height = 'auto';
        return text.style.height = text.scrollHeight + 'px';
      }
    };

    CreateArticle.prototype.createArticle = function(event) {
      var body, tags, title;
      this.lockUI();
      title = this.$el.find('.js-title').val();
      body = this.$el.find('.js-body').val();
      tags = document.querySelector('.js-tags').value;
      tags = tags.replace(/[^A-Za-z0-9,А-Яа-я]/igm, '');
      tags = tags.replace(/,{2,}/igm, ',');
      if (title === "") {
        this.app.screens.modal('common/info-popup', {
          msg: app.tr("The title can't be blank")
        });
        return;
      }
      if (body.length < 52) {
        this.app.screens.modal('common/info-popup', {
          msg: app.tr("Article may not be shorter than 52 characters")
        });
        return;
      }
      return app.server.news.createArticle({
        title: title,
        tags: tags,
        shortBody: "",
        mainQuote: "",
        body: body,
        success: function(data) {
          if (!data.error) {
            return app.screens.back();
          }
        },
        error: (function(_this) {
          return function(data) {
            app.hideLoader();
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong"),
              needReload: false
            });
          };
        })(this)
      });
    };


    /*
    			Center cloud
     */

    CreateArticle.prototype.centerCloud = function() {};

    CreateArticle.prototype.onDomRefresh = function() {
      this.centerCloud();
      this.resizeArea();
      return this.$el.find('.js-textarea').css('max-height', $(window).height() - 250 + 'px');
    };

    return CreateArticle;

  })(ItemView);
  return CreateArticle;
});
