var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/news/donate-popup.tmpl'], function(app, ItemView, _, template) {
  var DonatePopup;
  DonatePopup = (function(superClass) {
    extend(DonatePopup, superClass);

    function DonatePopup() {
      return DonatePopup.__super__.constructor.apply(this, arguments);
    }

    DonatePopup.prototype.template = template;

    DonatePopup.prototype.minDonateTax = 0.01;

    DonatePopup.prototype.minDonateValue = 1;

    DonatePopup.prototype.events = {
      'click .js-confirm': 'sendMoney',
      'change .js-currency-number': 'recalcAmount'
    };

    DonatePopup.prototype.sendMoney = function(event) {
      var valVd, valVg, vdollarCount, vgoldCount;
      valVg = this.$el.find('#input-vgold').val();
      valVd = this.$el.find('#input-vdollar').val();
      vgoldCount = valVg ? valVg : 0;
      vdollarCount = valVd ? valVd : 0;
      if (vgoldCount > 0 && vdollarCount >= 0 || vdollarCount > 0 && vgoldCount >= 0) {
        if (vgoldCount < this.minDonateValue && vgoldCount > 0 || vdollarCount < this.minDonateValue && vdollarCount > 0) {
          return this.$el.find('.js-error').show();
        } else {
          this.lockUI();
          return app.server.news.donate({
            user_id: this.options.newspaper_user_id,
            vgold: vgoldCount,
            vdollar: vdollarCount,
            success: function(data) {
              app.screens.back();
              return app.screens.modal('common/success-popup', {
                msg: data.setFlash[0].msg || app.tr("Well done")
              });
            },
            error: function(data) {
              app.screens.back();
              return app.screens.modal('common/info-popup', {
                msg: data.setFlash[0].msg || app.tr("Something went wrong")
              });
            }
          });
        }
      } else {
        return this.$el.find('.js-error').show();
      }
    };

    DonatePopup.prototype.recalcAmount = function(event) {
      var amountCount, comission, currency, toCity, toUser;
      currency = event.currentTarget.getAttribute('data-currency');
      amountCount = parseFloat(event.currentTarget.value).toFixed(2);
      if (amountCount >= this.minDonateValue) {
        this.$el.find('.js-error').hide();
        toCity = amountCount * (this.options.donate_tax['city_tax'] / 100);
        comission = amountCount * (this.options.donate_tax['comission'] / 100);
        if (comission < this.minDonateTax) {
          comission = this.minDonateTax;
        }
        toUser = amountCount - (toCity + comission);
        this.$el.find('#' + currency + '-tax').html(this.numberFormat(Math.round(toCity * 100) / 100));
        this.$el.find('#' + currency + '-user').html(this.numberFormat(Math.round(toUser * 100) / 100));
        return this.$el.find('#' + currency + '-comission').html(this.numberFormat(Math.round(comission * 100) / 100));
      } else {
        this.$el.find('.js-error').hide();
        this.$el.find('#' + currency + '-tax').html(0);
        this.$el.find('#' + currency + '-user').html(0);
        return this.$el.find('#' + currency + '-comission').html(0);
      }
    };

    return DonatePopup;

  })(ItemView);
  return DonatePopup;
});
