var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/news/edit-comment.tmpl'], function(app, ItemView, _, template) {
  var EditComment;
  EditComment = (function(superClass) {
    extend(EditComment, superClass);

    function EditComment() {
      return EditComment.__super__.constructor.apply(this, arguments);
    }

    EditComment.prototype.template = template;

    EditComment.prototype.data = {
      comment: {
        pointer: 'news.comment.edit',
        commentId: function() {
          return this.options.commentId;
        }
      }
    };

    EditComment.prototype.className = 'no-bg-image dont-reload';

    EditComment.prototype.events = {
      'click .js-save': 'saveChanges',
      'click .js-delete': 'deleteComment'
    };

    EditComment.prototype.saveChanges = function(event) {
      var body;
      this.lockUI();
      body = this.$el.find('.js-body').val();
      return app.server.news.comment.update({
        body: body,
        commentId: this.options.commentId,
        success: (function(_this) {
          return function(data) {
            return app.screens.modal('common/success-popup', {
              msg: data.setFlash[0].msg || app.tr("Well done")
            }, app.screens.back());
          };
        })(this),
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          }, app.screens.back());
        }
      });
    };

    EditComment.prototype.deleteComment = function(event) {
      this.lockUI();
      return app.server.news.comment["delete"]({
        commentId: this.options.commentId,
        success: (function(_this) {
          return function(data) {
            return app.screens.modal('common/success-popup', {
              msg: data.setFlash[0].msg || app.tr("Well done")
            }, app.screens.back());
          };
        })(this),
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          }, app.screens.back());
        }
      });
    };

    return EditComment;

  })(ItemView);
  return EditComment;
});
