var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/news/my-newspaper.tmpl', 'views/components/clusterize-helper', 'text!templates/news/blocks/newspapers-list.tmpl', 'views/components/lazy-loading', 'views/common/list-view'], function(app, ItemView, _, template, ClusterizeHelper, listTemplate, LazyLoading, CommonListView) {
  var MyNewspaper;
  MyNewspaper = (function(superClass) {
    extend(MyNewspaper, superClass);

    function MyNewspaper() {
      this._loadNews = bind(this._loadNews, this);
      this._appendPageToMainList = bind(this._appendPageToMainList, this);
      this.onDataLoaded = bind(this.onDataLoaded, this);
      this.loadData = bind(this.loadData, this);
      return MyNewspaper.__super__.constructor.apply(this, arguments);
    }

    MyNewspaper.prototype.template = template;

    MyNewspaper.prototype.listTemplate = _.template(listTemplate);

    MyNewspaper.prototype.data = {
      newspaper: {
        pointer: 'news.userNewspaper',
        page: 1
      }
    };

    MyNewspaper.prototype.events = {
      'click .js-manage-newspaper': 'manageNewspaper',
      'click .js-post': 'goToPost',
      'click .js-edit-post': 'goToEditPost'
    };

    MyNewspaper.prototype.preprocessData = function(data) {
      data.isMyNewspaper = true;
      return data;
    };

    MyNewspaper.prototype.goToPost = function(event) {
      var newspaperSlug, postId;
      this.lockUI();
      postId = event.currentTarget.getAttribute('data-post-id');
      newspaperSlug = event.currentTarget.getAttribute('data-newspaper-slug');
      return app.screens.dialog('news/article', {
        newspaperSlug: newspaperSlug,
        postId: postId
      }, (function(_this) {
        return function() {
          return _this.unlockUI();
        };
      })(this));
    };

    MyNewspaper.prototype.goToEditPost = function(event) {
      var newspaperSlug, postId;
      this.lockUI();
      postId = event.currentTarget.getAttribute('data-post-id');
      newspaperSlug = event.currentTarget.getAttribute('data-newspaper-slug');
      return app.screens.dialog('news/edit-article', {
        newspaperSlug: newspaperSlug,
        postId: postId
      });
    };

    MyNewspaper.prototype.manageNewspaper = function(event) {
      if (app.config.debug) {
        return console.log("manage newspaper");
      }
    };

    MyNewspaper.prototype.loadData = function() {
      this.data.newspaper.page = 1;
      return MyNewspaper.__super__.loadData.call(this);
    };

    MyNewspaper.prototype.onDataLoaded = function(data) {
      var container, ref, ref1, ref2;
      MyNewspaper.__super__.onDataLoaded.call(this, data);
      container = this.el.querySelector('#js-main-list-content');
      this._renderList(container, data.newspaper, data.page, data.hasNext);
      this.tabletLayout();
      this.canvasInnerLayout();
      this.data.newspaper.page++;
      this.hasNext = ((ref = data.elements) != null ? (ref1 = ref.paging) != null ? (ref2 = ref1.NewspaperPost) != null ? ref2.nextPage : void 0 : void 0 : void 0) || false;
      return LazyLoading((function(_this) {
        return function() {
          return _this._appendPageToMainList(_this.data.newspaper.page);
        };
      })(this));
    };

    MyNewspaper.prototype._appendPageToMainList = function(page) {
      var container, self;
      if (this.hasNext === false) {
        return;
      }
      container = this.el.querySelector('#js-main-list-content');
      self = this;
      self.lockUI();
      self._showListLoader(container);
      return self._loadNews(page).then(function(data) {
        self.unlockUI();
        self._hideListLoader(container);
        return self._renderList(container, data, data.page, data.hasNext);
      });
    };

    MyNewspaper.prototype._loadNews = function(page) {
      var deferred, self;
      deferred = $.Deferred();
      self = this;
      app.server.news.userNewspaper({
        page: page || 1,
        success: (function(_this) {
          return function(data) {
            var resultData;
            resultData = data;
            resultData.page = page;
            resultData.hasNext = data.has_next || false;
            _this.hasNext = data.paging.NewspaperPost.nextPage || false;
            _this.data.newspaper.page++;
            return deferred.resolve(resultData);
          };
        })(this),
        error: function() {
          return deferred.resolve({
            users: [],
            page: 1,
            hasNext: false
          });
        }
      });
      return deferred;
    };


    /*
    			Center cloud
     */

    MyNewspaper.prototype.centerCloud = function() {};

    MyNewspaper.prototype.onDomRefresh = function() {
      this.centerCloud();
      return ClusterizeHelper(this.$el);
    };

    return MyNewspaper;

  })(CommonListView);
  return MyNewspaper;
});
