var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/news/search-article.tmpl'], function(app, ItemView, _, template) {
  var SearchArticle;
  SearchArticle = (function(superClass) {
    extend(SearchArticle, superClass);

    function SearchArticle() {
      return SearchArticle.__super__.constructor.apply(this, arguments);
    }

    SearchArticle.prototype.template = template;

    SearchArticle.prototype.events = {
      'submit .js-search-bar form': 'articleSearch',
      'click .js-newspaper': 'goToNewspaper',
      'click .js-post': 'goToPost'
    };


    /*
    			Center cloud
     */

    SearchArticle.prototype.centerCloud = function() {};

    SearchArticle.prototype.onDomRefresh = function() {
      return this.centerCloud();
    };

    SearchArticle.prototype.goToNewspaper = function(event) {
      var newspaperSlug;
      this.lockUI();
      newspaperSlug = event.currentTarget.getAttribute('data-newspaper-slug');
      return app.screens.dialog('news/newspaper', {
        newspaperSlug: newspaperSlug
      });
    };

    SearchArticle.prototype.goToPost = function(event) {
      var newspaperSlug, postId;
      this.lockUI();
      postId = event.currentTarget.getAttribute('data-post-id');
      newspaperSlug = event.currentTarget.getAttribute('data-newspaper-slug');
      return app.screens.dialog('news/article', {
        newspaperSlug: newspaperSlug,
        postId: postId
      });
    };

    SearchArticle.prototype.articleSearch = function(event) {
      this.lockUI();
      event.preventDefault();
      return app.server.news.postSearch({
        title: this.$el.find('.c-input').val(),
        success: (function(_this) {
          return function(data) {
            _this.options.allNews = data.newspaperPosts;
            return _this.reload();
          };
        })(this),
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data || app.tr("Something went wrong")
          });
        }
      });
    };

    return SearchArticle;

  })(ItemView);
  return SearchArticle;
});
