var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/parties.tmpl', 'views/components/strings-helper'], function(app, ItemView, _, template, Strings) {
  var Parties;
  Parties = (function(superClass) {
    var _name;

    extend(Parties, superClass);

    function Parties() {
      return Parties.__super__.constructor.apply(this, arguments);
    }

    Parties.prototype.template = template;

    _name = null;

    Parties.prototype.data = {
      info: 'party.list'
    };

    Parties.prototype.events = {
      'click .js-show-info': 'showPartyInfo',
      'click .js-create-party': 'createParty',
      'change .c-input': 'itemSearch'
    };

    Parties.prototype.initialize = function() {
      Parties.__super__.initialize.apply(this, arguments);
      return this.on('render', function() {
        return this._renderList();
      });
    };

    Parties.prototype.preprocessData = function(data) {
      var id, item, ref;
      data.info.filteredData = {};
      ref = data.info.parties;
      for (id in ref) {
        item = ref[id];
        if (this._name && this._name.length > 2) {
          if (!Strings.matchName(item.Party.name, this._name, 1)) {
            continue;
          }
        }
        data.info.filteredData[id] = item;
      }
      return data;
    };

    Parties.prototype.itemSearch = function(event) {
      var name;
      name = event.currentTarget.value;
      event.currentTarget.value = name;
      this._name = name;
      this.options._name = name;
      return this._renderList();
    };

    Parties.prototype._renderList = function() {
      var data, listContainer;
      listContainer = this.el;
      if (!listContainer) {
        return;
      }
      data = this.mixinTemplateHelpers(this.serializeData({}));
      return listContainer.innerHTML = Marionette.Renderer.render(this.template, data);
    };

    Parties.prototype.showPartyInfo = function(event) {
      var partyId;
      this.lockUI();
      partyId = event.currentTarget.getAttribute('data-party-id');
      return app.screens.dialog('parties/common', {
        screen_options: partyId,
        partyId: partyId
      });
    };

    Parties.prototype.createParty = function(event) {
      this.lockUI();
      return app.screens.dialog('parties/create-party');
    };

    return Parties;

  })(ItemView);
  return Parties;
});
