define(['app', 'views/item-view', 'underscore', 'text!templates/parties/members.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      members: {
        pointer: 'party.members',
        partyId: function() {
          if (this.options.screen_options != null) {
            return this.options.screen_options;
          } else {
            return null;
          }
        },
        userName: function() {
          if (this.options.userName != null) {
            return this.options.userName;
          } else {
            return null;
          }
        }
      },
      request_count: 'party.requests.count'
    },
    events: {
      'click .js-member-settings': 'memberSettings',
      'change .c-input': 'memberSearch'
    },
    memberSettings: function(event) {
      this.lockUI();
      app.quests.doIfCompleted('social_passport', function() {
        var memberId;
        memberId = event.currentTarget.getAttribute('data-member-id');
        return app.screens.modal('parties/member-settings', {
          memberId: memberId
        });
      });
      return event.stopImmediatePropagation();
    },
    onDomRefresh: function() {
      if (this.options.members == null) {
        return this.options.members = this._data.members;
      }
    },
    memberSearch: function(event) {
      this.lockUI();
      event.preventDefault();
      this.options.userName = this.$el.find('.c-input').val();
      return this.reload();
    }
  });
});
