var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/parties/parlament-results.tmpl'], function(app, ItemView, _, template) {
  var ParliamentResult;
  ParliamentResult = (function(superClass) {
    extend(ParliamentResult, superClass);

    function ParliamentResult() {
      return ParliamentResult.__super__.constructor.apply(this, arguments);
    }

    ParliamentResult.prototype.template = template;

    ParliamentResult.prototype.data = {
      parliament: {
        pointer: 'parliament.election.result',
        direction: function() {
          return this.options.sortDirection;
        }
      }
    };

    ParliamentResult.prototype.events = {
      'click @ui.close': 'dropdownBehaviour',
      'click .js-goto-party': 'openParty',
      'click .js-sort-lots': 'showSort',
      'click .js-sort-lots li': 'sortLots'
    };

    ParliamentResult.prototype.ui = {
      close: '.dropdown__title'
    };

    ParliamentResult.prototype.initialize = function(options) {
      options.sortDirection = "desc";
      return ParliamentResult.__super__.initialize.call(this, options);
    };

    ParliamentResult.prototype.showSort = function(event) {
      return $('.js-sort-lots ul').toggle();
    };

    ParliamentResult.prototype.sortLots = function(event) {
      this.lockUI();
      event.preventDefault();
      this.options.sortDirection = event.currentTarget.getAttribute('data-sort-direction');
      return this.reload();
    };

    ParliamentResult.prototype.openParty = function(event) {
      var partyId;
      partyId = event.currentTarget.getAttribute('data-party-id');
      return app.screens.dialog('parties/common', {
        screen_options: partyId
      });
    };

    ParliamentResult.prototype.dropdownBehaviour = function(e) {
      var dropdown;
      dropdown = $(e.currentTarget).closest('.dropdown');
      dropdown.toggleClass('is-active');
      dropdown.find('.dropdown__title icon').toggleClass('o-icon--down-arrow o-icon--up-arrow');
      return dropdown.find('.dropdown__details').toggle();
    };

    ParliamentResult.prototype.onDomRefresh = function() {
      var currentSortText;
      currentSortText = this.el.querySelector('.js-sort-' + this.options.sortDirection);
      if (currentSortText) {
        return this.el.querySelector('.current-sort').innerHTML = currentSortText.innerHTML;
      }
    };

    return ParliamentResult;

  })(ItemView);
  return ParliamentResult;
});
