define(['app', 'views/item-view', 'underscore', 'text!templates/port/rename-yacht.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      port: 'port'
    },
    events: {
      'click .js-save-changes': 'saveChanges'
    },
    saveChanges: function(event) {
      var name, shipId;
      this.lockUI();
      shipId = event.currentTarget.getAttribute('data-ship-id');
      name = this.el.querySelector('.js-name').value;
      return this.app.server.port.ship.rename({
        shipId: shipId,
        name: name,
        success: (function(_this) {
          return function(data) {
            var ref, ref1;
            if (data.error === 0) {
              return _this.app.screens.modal('common/info-popup', {
                msg: (ref = data.setFlash) != null ? ref[0].msg : void 0
              }, app.screens.back());
            } else {
              return _this.app.screens.modal('common/info-popup', {
                msg: (ref1 = data.setFlash) != null ? ref1[0].msg : void 0
              });
            }
          };
        })(this),
        error: (function(_this) {
          return function(err) {
            var ref;
            return _this.app.screens.modal('common/info-popup', {
              msg: (ref = data.setFlash) != null ? ref[0].msg : void 0
            });
          };
        })(this)
      });
    }
  });
});
