var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/profile/fortune.tmpl', 'views/components/clusterize-helper'], function(app, ItemView, _, template, ClusterizeHelper) {
  var FortuneView;
  FortuneView = (function(superClass) {
    extend(FortuneView, superClass);

    function FortuneView() {
      return FortuneView.__super__.constructor.apply(this, arguments);
    }

    FortuneView.prototype.template = template;

    FortuneView.prototype.data = {
      infos: 'user.info',
      info: 'user.info.short',
      business: 'business.companyListShort',
      userCorporations: 'business.corporationList'
    };

    FortuneView.prototype.events = {
      'click .js-goto-company': 'gotoCompany',
      'click .js-goto-corporation': 'gotoCorporation',
      'click .js-goto-house': 'gotoHouse',
      'click .js-goto-port': 'gotoPort'
    };

    FortuneView.prototype.gotoCompany = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/common', {
        companyId: companyId
      });
    };

    FortuneView.prototype.gotoCorporation = function(event) {
      var corporationId;
      this.lockUI();
      corporationId = event.currentTarget.getAttribute('data-corporation-id');
      return app.screens.dialog('business/capital', {
        corporationId: corporationId
      });
    };

    FortuneView.prototype.gotoHouse = function() {
      this.lockUI();
      return app.screens.dialog('house');
    };

    FortuneView.prototype.gotoPort = function() {
      this.lockUI();
      return app.screens.dialog('port');
    };

    FortuneView.prototype.onDomRefresh = function() {
      return ClusterizeHelper(this.$el);
    };

    return FortuneView;

  })(ItemView);
  return FortuneView;
});
