var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['../../bower_components/underscore/underscore', 'views/item-view', 'text!templates/quick_reg_lock.tmpl'], function(_, ItemView, template) {
  var QuickRegLockView;
  QuickRegLockView = (function(superClass) {
    extend(QuickRegLockView, superClass);

    function QuickRegLockView() {
      this._linkAccount = bind(this._linkAccount, this);
      return QuickRegLockView.__super__.constructor.apply(this, arguments);
    }

    QuickRegLockView.prototype.className = 'l-gap';

    QuickRegLockView.prototype.template = template;

    QuickRegLockView.prototype.events = {
      'click .js-provider': 'linkAccount',
      'click .js-quick-reg-unlock': 'quickRegUnlock'
    };

    QuickRegLockView.prototype.data = {
      info: 'user.info.short'
    };

    QuickRegLockView.prototype.socialProviders = {
      'vk': {
        type: 'vk',
        'name': 'Vkontakte'
      },
      'fb': {
        type: 'fb',
        'name': 'Facebook'
      },
      'google': {
        type: 'google',
        'name': 'Google+'
      }
    };

    QuickRegLockView.prototype.initialize = function(options) {
      QuickRegLockView.__super__.initialize.call(this, options);
      return $('#startup-loader').hide();
    };

    QuickRegLockView.prototype.reauth = function(event) {
      return app.screens.main('auto_login');
    };

    QuickRegLockView.prototype.quickRegUnlock = function(event) {
      return app.server.quick_reg_unlock({
        success: (function(_this) {
          return function() {
            return app.screens.main('quests');
          };
        })(this),
        error: function() {}
      });
    };

    QuickRegLockView.prototype.linkAccount = function(event) {
      var provider, type;
      this.lockUI();
      type = event.currentTarget.getAttribute('data-type');
      if (!this.socialProviders.hasOwnProperty(type)) {
        app.screens.modal('common/info-popup', {
          msg: app.tr('Invalid social network')
        });
        return;
      }
      provider = app.socialService.getProvider(type);
      if (!provider) {
        app.screens.modal('common/info-popup', {
          msg: app.tr('Invalid social network')
        });
        return;
      }
      return provider.reauth(true).then((function(_this) {
        return function(data) {
          return _this._linkAccount(data.user, provider);
        };
      })(this), (function(_this) {
        return function() {
          return app.screens.modal('common/info-popup', {
            msg: app.tr('Authentication failed')
          });
        };
      })(this));
    };

    QuickRegLockView.prototype._linkAccount = function(userData, provider) {
      return this.app.server.social.linkAccount({
        provider: provider.getType(),
        socialUser: userData,
        token: provider.getCurrentToken(),
        success: (function(_this) {
          return function(data) {
            if (data && (data != null ? data.user_id : void 0)) {
              app.screens.main('quests');
              _this.$el.closest('body').removeClass('hide-short-info');
              app.server.quests.takeQuest({
                questId: 100,
                skipAfter: true,
                success: function(data) {
                  return app.server.quests.completeQuest({
                    skipAfter: true,
                    questId: 100,
                    success: function() {
                      return app.shortInfo.view.reload();
                    },
                    error: function() {}
                  });
                },
                error: function(data) {
                  return app.server.quests.completeQuest({
                    questId: 100,
                    skipAfter: false,
                    success: function() {
                      return app.shortInfo.view.reload();
                    },
                    error: function() {}
                  });
                }
              });
              return _this.app.screens.modal('common/info-popup', {
                msg: app.tr('You get password')
              });
            } else {
              return _this.app.screens.modal('common/info-popup', {
                msg: app.tr('Authentication failed')
              });
            }
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            if (data && data.error_code === 'ACCOUNT_LINKED') {
              _this.app.screens.modal('common/info-popup', {
                msg: data.error_message
              });
              return;
            }
            return _this.app.screens.modal('common/info-popup', {
              msg: app.tr('Authentication failed')
            });
          };
        })(this)
      });
    };

    QuickRegLockView.prototype.onDomRefresh = function(options) {
      var $cloud, $container;
      app.hideLoader();
      this.$el.closest('body').addClass('hide-short-info');
      $cloud = $('.c-content');
      $container = $('.js-current-screen');
      return $cloud.css('margin-top', ($container.height() / 2 - $cloud.height() / 2) / 2);
    };

    return QuickRegLockView;

  })(ItemView);
  return QuickRegLockView;
});
