var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/ratings/filter_city.tmpl'], function(app, ItemView, _, template, EnergySlider) {
  var FilterView;
  FilterView = (function(superClass) {
    extend(FilterView, superClass);

    function FilterView() {
      this.onDataLoaded = bind(this.onDataLoaded, this);
      this.initialize = bind(this.initialize, this);
      return FilterView.__super__.constructor.apply(this, arguments);
    }

    FilterView.prototype.template = template;

    FilterView.prototype.data = {
      cities: 'cities'
    };

    FilterView.prototype.initialize = function(options) {
      var screen_options_obj;
      this.options = options;
      screen_options_obj = JSON.parse(this.options.screen_options);
      this.options.screenId = (function() {
        switch (screen_options_obj.activeTab) {
          case 0:
            return 'ratings/players';
          case 1:
            return 'ratings/companies';
          case 2:
            return 'ratings/corporations';
          case 3:
            return 'ratings/cities';
        }
      })();
      return FilterView.__super__.initialize.call(this, this.options);
    };

    FilterView.prototype.onDataLoaded = function(data) {
      app.cities = data.cities.cities;
      return FilterView.__super__.onDataLoaded.call(this, data);
    };

    return FilterView;

  })(ItemView);
  return FilterView;
});
