var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/ratings/filter_users.tmpl'], function(app, ItemView, _, template, EnergySlider) {
  var FilterView;
  FilterView = (function(superClass) {
    extend(FilterView, superClass);

    function FilterView() {
      this.initialize = bind(this.initialize, this);
      return FilterView.__super__.constructor.apply(this, arguments);
    }

    FilterView.prototype.template = template;

    FilterView.prototype.initialize = function(options) {
      var filter1, filter2, filter3, screen_options_obj;
      this.options = options;
      screen_options_obj = JSON.parse(this.options.screen_options);
      filter1 = _.clone(screen_options_obj);
      filter1.usersFilter = 0;
      filter2 = _.clone(screen_options_obj);
      filter2.usersFilter = 1;
      filter3 = _.clone(screen_options_obj);
      filter3.usersFilter = 2;
      this.options.screenId = (function() {
        switch (screen_options_obj.activeTab) {
          case 0:
            return 'ratings/players';
          case 1:
            return 'ratings/companies';
          case 2:
            return 'ratings/corporations';
          case 3:
            return 'ratings/cities';
        }
      })();
      this.options.filters = [JSON.stringify(filter1), JSON.stringify(filter2), JSON.stringify(filter3)];
      return FilterView.__super__.initialize.call(this, this.options);
    };

    return FilterView;

  })(ItemView);
  return FilterView;
});
