var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/ratings/players.tmpl'], function(app, ItemView, _, template, EnergySlider) {
  var RatingView;
  RatingView = (function(superClass) {
    extend(RatingView, superClass);

    function RatingView() {
      this.initialize = bind(this.initialize, this);
      return RatingView.__super__.constructor.apply(this, arguments);
    }

    RatingView.prototype.template = template;

    RatingView.prototype.data = {
      ratings: {
        pointer: 'ratings.pvp',
        ligue_level: function() {
          return this.options.screen_options;
        }
      }
    };

    RatingView.prototype.events = {
      'click .js-expand-pvp-rating': 'expandRating',
      'click .expand-text': 'expandRating',
      'click .js-back': 'jsBack'
    };

    RatingView.prototype.jsBack = function() {
      return app.menu.open();
    };

    RatingView.prototype.initialize = function(options) {
      this.options = options;
      this.options.activeTab = 4;
      return RatingView.__super__.initialize.call(this, this.options);
    };

    RatingView.prototype.expandRating = function(event) {
      ($('.js-expand-pvp-rating')).toggleClass('down');
      return ($('.pvp-rating-me')).toggleClass('u-hide');
    };

    return RatingView;

  })(ItemView);
  return RatingView;
});
