var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/referrals.tmpl'], function(app, ItemView, _, template) {
  var Referrals;
  Referrals = (function(superClass) {
    extend(Referrals, superClass);

    function Referrals() {
      this._onShareBtnClick = bind(this._onShareBtnClick, this);
      this.onRender = bind(this.onRender, this);
      this.preprocessData = bind(this.preprocessData, this);
      return Referrals.__super__.constructor.apply(this, arguments);
    }

    Referrals.prototype.template = template;

    Referrals.prototype.className = '';

    Referrals.prototype.data = {
      ref_data: 'user.get_referrals_share_data'
    };

    Referrals.prototype.events = {
      'click .js-share': '_onShareBtnClick',
      'click .js-open-reflink': 'openReflink',
      'click .js-copy-code': 'copyReflink'
    };

    Referrals.prototype._shareData = {};

    Referrals.prototype.socialProviders = {
      'vk': {
        type: 'vk',
        'name': 'Vkontakte'
      },
      'fb': {
        type: 'fb',
        'name': 'Facebook'
      },
      'google': {
        type: 'google',
        'name': 'Google+'
      }
    };

    Referrals.prototype.preprocessData = function(data) {
      var ref, shareUrl;
      shareUrl = this.app.config.serverURL.replace('api.', '').replace('api2.', '').replace('api3.', '') + '/social/referrals/code/' + this.app.userId;
      if ((data != null ? (ref = data.ref_data) != null ? ref.share : void 0 : void 0)) {
        this._shareData = data.ref_data.share;
      } else {
        data = {
          url: shareUrl
        };
        this._shareData = data;
      }
      return data;
    };

    Referrals.prototype.onRender = function() {
      return this.shareUrl = this.app.config.serverURL.replace('api.', '').replace('api2.', '').replace('api3.', '') + '/social/referrals/code/' + this.app.userId;
    };

    Referrals.prototype.openReflink = function(event) {
      if (window.idCordova) {
        return window.open(event.currentTarget.href, '_system');
      } else {
        return window.open(event.currentTarget.href, '_blank');
      }
    };

    Referrals.prototype._onShareBtnClick = function(event) {
      var $lang, data, provider, ref, ref1, ref2;
      $lang = app.translations.getLn();
      provider = this.app.socialService.getProvider(event.currentTarget.getAttribute('data-type'));
      data = {
        'title': ((ref = this._shareData) != null ? ref.title : void 0) || null,
        'description': ((ref1 = this._shareData) != null ? ref1.description : void 0) || null,
        'url': this._shareData.url + '?ln=' + $lang,
        'image': ((ref2 = this._shareData) != null ? ref2.image : void 0) || null
      };
      return provider.share(data);
    };

    Referrals.prototype.copyReflink = function(event) {
      return window.cordova.plugins.clipboard.copy(this._data.ref_data.share.url, function() {
        return $('#js-message').html(app.tr('Link copied'));
      });
    };

    Referrals.prototype.onDomRefresh = function() {
      var height;
      height = this.$el.find('.referrals-wrapper').height();
      return this.$el.find('.referrals-wrapper').css('margin-top', height / 2);
    };

    return Referrals;

  })(ItemView);
  return Referrals;
});
