var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/referrals/referrals-list.tmpl'], function(app, ItemView, _, template) {
  var ReferralsList;
  ReferralsList = (function(superClass) {
    extend(ReferralsList, superClass);

    function ReferralsList() {
      this.preprocessData = bind(this.preprocessData, this);
      return ReferralsList.__super__.constructor.apply(this, arguments);
    }

    ReferralsList.prototype.template = template;

    ReferralsList.prototype.className = '';

    ReferralsList.prototype.data = {
      referrals: 'user.get_referrals'
    };

    ReferralsList.prototype.providers = {
      '1': {
        type: 'vk',
        'name': 'Vkontakte'
      },
      '2': {
        type: 'fb',
        'name': 'Facebook'
      },
      '3': {
        type: 'google',
        'name': 'Google+'
      }
    };

    ReferralsList.prototype.events = {
      'click .chosen-single': 'openSort',
      'click .js-sort': 'sort',
      'click .js-profile': 'onProfileClick'
    };

    ReferralsList.prototype.preprocessData = function(data) {
      data.providers = this.providers;
      if (!this.options.sortFieldText) {
        this.options.sortFieldText = app.tr('Registration date');
      }
      if (!this.options.sortField) {
        this.options.sortField = 'id';
      }
      return data;
    };

    ReferralsList.prototype.openSort = function(event) {
      return this.$el.find('.chosen-container').addClass('chosen-with-drop');
    };

    ReferralsList.prototype.closeSort = function(event) {
      return this.$el.find('.chosen-container').removeClass('chosen-with-drop');
    };

    ReferralsList.prototype.sort = function(event) {
      var sortType;
      event.preventDefault();
      sortType = event.currentTarget.getAttribute('data-sort-type');
      if (sortType === 'registration') {
        this.options.sortFieldText = app.tr('Registration date');
        this.options.sortField = 'id';
        this.options.sortOrder = 'asc';
      }
      if (sortType === 'source') {
        this.options.sortFieldText = app.tr('Registration Source');
        this.options.sortField = 'provider';
        this.options.sortOrder = 'acs';
      }
      if (sortType === 'level') {
        this.options.sortFieldText = app.tr('Levels');
        this.options.sortField = 'level';
        this.options.sortOrder = 'desc';
      }
      if (sortType === 'last_activity') {
        this.options.sortFieldText = app.tr('Last activity');
        this.options.sortField = 'updated';
        this.options.sortOrder = 'desc';
      }
      this.closeSort();
      return this.render();
    };

    ReferralsList.prototype.onProfileClick = function(event) {
      var userId;
      this.lockUI();
      userId = event.currentTarget.getAttribute('data-id');
      return app.screens.dialog('users/profile', {
        userId: userId
      });
    };

    return ReferralsList;

  })(ItemView);
  return ReferralsList;
});
