var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/settings/avatar.tmpl'], function(app, ItemView, _, template) {
  var ChangeAvatarView;
  ChangeAvatarView = (function(superClass) {
    extend(ChangeAvatarView, superClass);

    function ChangeAvatarView() {
      return ChangeAvatarView.__super__.constructor.apply(this, arguments);
    }

    ChangeAvatarView.prototype.template = template;

    ChangeAvatarView.prototype.className = 'settings';

    ChangeAvatarView.prototype.data = {
      data: 'user.registrationInfo',
      info: 'user.info.short',
      price_info: 'user.changeAvatarPrice'
    };

    ChangeAvatarView.prototype.events = {
      'click .js-select-picture': 'selectAvatar',
      'click .js-buy-avatar': 'buyAvatar'
    };

    ChangeAvatarView.prototype.selectAvatar = function(event) {
      this.$('.js-select-picture').removeClass('active');
      return $(event.currentTarget).addClass('active');
    };

    ChangeAvatarView.prototype.buyAvatar = function(event) {
      var avatarId, avatarPic, loader, sex;
      this.lockUI();
      avatarId = this.$('.js-select-picture.active').attr("data-avatar");
      avatarPic = this._data.data.avatars[avatarId].avatar_data;
      sex = this._data.data.avatars[avatarId].sex;
      loader = this.setLoaderOnElement(event.currentTarget, app.tr('Changing'));
      return app.server.user.changeAvatar({
        avatar: avatarPic,
        sex: sex,
        success: (function(_this) {
          return function(data) {
            return _this.listenToOnce(app.vent, 'short-info:dataLoaded', function() {
              this.unlockUI();
              return loader.remove();
            });
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            var options;
            loader.remove();
            options = {
              msg: data.setFlash[0].msg || app.tr("Something went wrong"),
              onBack: function() {
                return _this.delegateEvents();
              }
            };
            return app.screens.modal('common/info-popup', options);
          };
        })(this)
      });
    };

    return ChangeAvatarView;

  })(ItemView);
  return ChangeAvatarView;
});
