var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/settings/notifications.tmpl'], function(app, ItemView, _, template) {
  var NotificationsView;
  NotificationsView = (function(superClass) {
    extend(NotificationsView, superClass);

    function NotificationsView() {
      return NotificationsView.__super__.constructor.apply(this, arguments);
    }

    NotificationsView.prototype.template = template;

    NotificationsView.prototype.className = 'no-bg-image';

    NotificationsView.prototype.data = {
      settings: 'user.notificationSettings'
    };

    NotificationsView.prototype.events = {
      'click .js-settings-toggle': 'toggle'
    };

    NotificationsView.prototype.toggle = function(event) {
      var isActive, parent, settings, type;
      this.lockUI();
      app.showLoader();
      type = event.currentTarget.dataset.type;
      parent = event.currentTarget.parentNode;
      isActive = !parent.classList.contains('o-switcher-small--active');
      settings = {};
      settings[type] = (isActive ? 1 : 0);
      return app.server.user.setNotificationSettings({
        settings: settings,
        success: (function(_this) {
          return function(data) {
            app.hideLoader();
            _this.unlockUI();
            parent.classList.toggle('o-switcher-small--active');
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Notification settings updated")
            });
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            app.hideLoader();
            _this.unlockUI();
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          };
        })(this)
      });
    };

    return NotificationsView;

  })(ItemView);
  return NotificationsView;
});
