var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'underscore', 'text!templates/suggestions.tmpl', 'views/components/clusterize-helper', 'text!templates/suggestions/blocks/suggestions-list.tmpl', 'views/components/lazy-loading', 'views/common/lazy-loading-view'], function(app, _, template, ClusterizeHelper, listTemplate, LazyLoading, CommonLazyView) {
  var SuggestionsView;
  SuggestionsView = (function(superClass) {
    extend(SuggestionsView, superClass);

    function SuggestionsView() {
      this._loadData = bind(this._loadData, this);
      this.loadData = bind(this.loadData, this);
      return SuggestionsView.__super__.constructor.apply(this, arguments);
    }

    SuggestionsView.prototype.template = template;

    SuggestionsView.prototype.listTemplate = _.template(listTemplate);

    SuggestionsView.prototype.pointer = 'suggestions';

    SuggestionsView.prototype.data = {
      suggestions: {
        pointer: 'suggestions.newSuggestions',
        page: 1
      }
    };

    SuggestionsView.prototype.events = {
      'click .js-suggestion': 'goToSuggestion'
    };

    SuggestionsView.prototype.loadData = function() {
      this.data.suggestions.page = 1;
      return SuggestionsView.__super__.loadData.call(this);
    };

    SuggestionsView.prototype.goToSuggestion = function(event) {
      var suggestionId;
      this.lockUI();
      suggestionId = event.currentTarget.getAttribute('data-post-id');
      return app.screens.dialog('suggestions/suggestion', {
        suggestionId: suggestionId
      });
    };

    SuggestionsView.prototype._loadData = function(page) {
      var deferred, self;
      deferred = $.Deferred();
      self = this;
      app.server.suggestions.newSuggestions({
        page: page || 1,
        success: (function(_this) {
          return function(data) {
            var resultData;
            resultData = data;
            resultData.page = page;
            resultData.hasNext = data.has_next || false;
            _this.hasNext = data.paging.Suggestion.nextPage || false;
            console.log('data in load data', _this.data);
            _this.data.suggestions.page++;
            return deferred.resolve(resultData);
          };
        })(this),
        error: function() {
          return deferred.resolve({
            users: [],
            page: 1,
            hasNext: false
          });
        }
      });
      return deferred;
    };


    /*
    			Center cloud
     */

    SuggestionsView.prototype.centerCloud = function() {};

    SuggestionsView.prototype.onDomRefresh = function() {
      this.centerCloud();
      return ClusterizeHelper(this.$el);
    };

    return SuggestionsView;

  })(CommonLazyView);
  return SuggestionsView;
});
