var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/suggestions/create-suggestion.tmpl'], function(app, ItemView, _, template) {
  var createSuggestionView;
  createSuggestionView = (function(superClass) {
    extend(createSuggestionView, superClass);

    function createSuggestionView() {
      return createSuggestionView.__super__.constructor.apply(this, arguments);
    }

    createSuggestionView.prototype.template = template;

    createSuggestionView.prototype.className = 'no-bg-image';

    createSuggestionView.prototype.events = {
      'click .js-create-suggestion': 'createSuggestion'
    };

    createSuggestionView.prototype.createSuggestion = function(event) {
      var description, title;
      this.lockUI();
      title = this.$el.find('.js-title').val();
      description = this.$el.find('.js-description').val();
      return app.server.suggestions.createSuggestion({
        title: title,
        description: description,
        success: function(data) {
          if (!data.error) {
            if (app.gaEnabled) {
              app.ga('send', 'event', "suggestion:added", app.userId, data.newSuggestionId);
            }
            app.screens.back();
            return app.screens.modal('common/success-popup', {
              msg: data.setFlash[0].msg || app.tr("Proposal created!")
            });
          }
        },
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    };

    return createSuggestionView;

  })(ItemView);
  return createSuggestionView;
});
