var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'underscore', 'text!templates/suggestions/popular-suggestions.tmpl', 'views/components/clusterize-helper', 'text!templates/suggestions/blocks/suggestions-list.tmpl', 'views/components/lazy-loading', 'views/common/lazy-loading-view'], function(app, _, template, ClusterizeHelper, listTemplate, LazyLoading, CommonLazyView) {
  var PopularSuggestionsView;
  PopularSuggestionsView = (function(superClass) {
    extend(PopularSuggestionsView, superClass);

    function PopularSuggestionsView() {
      this._loadData = bind(this._loadData, this);
      this.loadData = bind(this.loadData, this);
      return PopularSuggestionsView.__super__.constructor.apply(this, arguments);
    }

    PopularSuggestionsView.prototype.template = template;

    PopularSuggestionsView.prototype.listTemplate = _.template(listTemplate);

    PopularSuggestionsView.prototype.pointer = 'suggestions';

    PopularSuggestionsView.prototype.data = {
      suggestions: {
        pointer: 'suggestions.popularSuggestions',
        page: 1
      }
    };

    PopularSuggestionsView.prototype.events = {
      'click .js-suggestion': 'goToSuggestion'
    };

    PopularSuggestionsView.prototype.goToSuggestion = function(event) {
      var suggestionId;
      this.lockUI();
      suggestionId = event.currentTarget.getAttribute('data-post-id');
      return app.screens.dialog('suggestions/suggestion', {
        suggestionId: suggestionId
      });
    };

    PopularSuggestionsView.prototype.loadData = function() {
      this.data.suggestions.page = 1;
      return PopularSuggestionsView.__super__.loadData.call(this);
    };

    PopularSuggestionsView.prototype._loadData = function(page) {
      var deferred, self;
      deferred = $.Deferred();
      self = this;
      app.server.suggestions.popularSuggestions({
        page: page || 1,
        success: (function(_this) {
          return function(data) {
            var resultData;
            resultData = data;
            resultData.page = page;
            resultData.hasNext = data.has_next || false;
            _this.hasNext = data.paging.Suggestion.nextPage || false;
            _this.data.suggestions.page++;
            return deferred.resolve(resultData);
          };
        })(this),
        error: function() {
          return deferred.resolve({
            users: [],
            page: 1,
            hasNext: false
          });
        }
      });
      return deferred;
    };


    /*
    			Center cloud
     */

    PopularSuggestionsView.prototype.centerCloud = function() {};

    PopularSuggestionsView.prototype.onDomRefresh = function() {
      this.centerCloud();
      return ClusterizeHelper(this.$el);
    };

    return PopularSuggestionsView;

  })(CommonLazyView);
  return PopularSuggestionsView;
});
