var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/items-buy-rebel.tmpl', 'views/components/currency', 'views/components/strings-helper'], function(app, ItemView, _, template, formatCurrency, Strings) {
  var ItemsBuyView;
  ItemsBuyView = (function(superClass) {
    var _name;

    extend(ItemsBuyView, superClass);

    function ItemsBuyView() {
      this.buyLot = bind(this.buyLot, this);
      return ItemsBuyView.__super__.constructor.apply(this, arguments);
    }

    ItemsBuyView.prototype.template = template;

    _name = null;

    ItemsBuyView.prototype.minPriceForLots = 0;

    ItemsBuyView.prototype.data = {
      'items': {
        pointer: 'rebel.lotsList',
        categoryId: function() {
          return this.options.category;
        }
      }
    };

    ItemsBuyView.prototype.events = {
      'click .js-items-lot': 'buyLot'
    };

    ItemsBuyView.prototype.initialize = function() {
      ItemsBuyView.__super__.initialize.apply(this, arguments);
      return this.on('render', function() {
        return this._renderList();
      });
    };

    ItemsBuyView.prototype.buyLot = function(event) {
      var currency, itemTypeId, self;
      currency = event.currentTarget.getAttribute('data-currency');
      itemTypeId = event.currentTarget.getAttribute('data-item-id');
      console.log('options in last', this.options);
      this.lockUI();
      self = this;
      return app.server.rebel.buyLot({
        itemId: itemTypeId,
        rebelWarId: this.options.rebelWarId,
        success: (function(_this) {
          return function(data) {
            return app.screens.modal('common/info-popup', {
              msg: app.tr("Items purchased")
            }, app.screens.dialog('maria/rebel-war', {
              rebelWarId: _this.options.rebelWarId
            }));
          };
        })(this),
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    };

    ItemsBuyView.prototype.onDomRefresh = function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        if (el.dataset.precision) {
          return el.innerHTML = formatCurrency(el.innerHTML, void 0, el.dataset.precision);
        } else {
          return el.innerHTML = formatCurrency(el.innerHTML);
        }
      });
    };

    ItemsBuyView.prototype._renderList = function() {
      var data, listContainer;
      listContainer = this.el;
      if (!listContainer) {
        return;
      }
      data = this.mixinTemplateHelpers(this.serializeData({}));
      return listContainer.innerHTML = Marionette.Renderer.render(this.template, data);
    };

    ItemsBuyView.prototype.sendGAView = function() {
      if (this.app.config.googleAnalyticsEnabled && this.app.ga) {
        return this.app.ga('send', 'pageview', {
          page: '/scr/' + this.options.id + '/' + this.options.category,
          title: ''
        });
      }
    };

    return ItemsBuyView;

  })(ItemView);
  return ItemsBuyView;
});
