var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/lots-cityHall-company.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  var cityHallCompany;
  cityHallCompany = (function(superClass) {
    extend(cityHallCompany, superClass);

    function cityHallCompany() {
      return cityHallCompany.__super__.constructor.apply(this, arguments);
    }

    cityHallCompany.prototype.template = template;

    cityHallCompany.prototype.data = {
      items: {
        pointer: 'tradeCenter.lotsListCityHallCompany',
        companyId: function() {
          return this.options.companyId;
        }
      }
    };

    cityHallCompany.prototype.events = {
      'click .js-lot-sell': 'buyLot'
    };

    cityHallCompany.prototype.initialize = function(options) {
      return cityHallCompany.__super__.initialize.apply(this, arguments);
    };

    cityHallCompany.prototype.buyLot = function(event) {
      var data, lotId, lotInfo, offersCollection;
      this.lockUI();
      data = this.serializeData();
      lotId = event.currentTarget.getAttribute('data-lot-id');
      offersCollection = new Backbone.Collection(data.items.exchanges);
      lotInfo = offersCollection.get(lotId);
      lotInfo.seller = data.items.seller.Company.id;
      if (lotInfo.get('user_count') < 1) {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("You do not have") + ("" + (lotInfo.get('name'))) + app.tr(" for sale")
        });
      } else {
        return app.screens.modal('trade-center/sell-item-maria-company', {
          model: lotInfo
        });
      }
    };

    cityHallCompany.prototype.onDomRefresh = function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        if (el.dataset.precision) {
          return el.innerHTML = formatCurrency(el.innerHTML, void 0, el.dataset.precision);
        } else {
          return el.innerHTML = formatCurrency(el.innerHTML);
        }
      });
    };

    return cityHallCompany;

  })(ItemView);
  return cityHallCompany;
});
