define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/lots.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    className: 'trade-center-layout bgc-grey-5',
    data: {
      lots: {
        pointer: 'tradeCenter.lotsOfferCompany',
        itemTypeId: function() {
          return this.options.itemTypeId;
        },
        companyId: function() {
          return this.options.companyId;
        },
        currency: function() {
          return this.options.currency;
        }
      }
    },
    events: {
      'click .js-buy-lot': 'buyLot'
    },
    buyLot: function(event) {
      var data, lotId, lotInfo, offersCollection;
      this.lockUI();
      data = this.serializeData();
      lotId = event.currentTarget.getAttribute('data-lot-id');
      offersCollection = new Backbone.Collection(data.lots.offers);
      lotInfo = offersCollection.get(lotId);
      lotInfo.set('item_info', data.lots.item_info);
      lotInfo.set('buyer', data.lots.buyer);
      return app.screens.modal('trade-center/purchase-item-company', {
        model: lotInfo,
        companyId: this.options.companyId
      });
    }
  });
});
