var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/purchase-item.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  var PurchaseItemPopup;
  PurchaseItemPopup = (function(superClass) {
    extend(PurchaseItemPopup, superClass);

    function PurchaseItemPopup() {
      return PurchaseItemPopup.__super__.constructor.apply(this, arguments);
    }

    PurchaseItemPopup.prototype.template = template;

    PurchaseItemPopup.prototype.events = {
      'click .js-confirm': 'purchaseItem',
      'click .js-choose-all-items': 'chooseAllItems',
      'change .js-items-number': 'onRender'
    };

    PurchaseItemPopup.prototype.onDomRefresh = function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    };

    PurchaseItemPopup.prototype.onRender = function() {
      return this.$('.js-items-number').change((function(_this) {
        return function(event) {
          var itemsAmount;
          itemsAmount = parseInt($(event.currentTarget).val());
          if (itemsAmount <= 0) {
            itemsAmount = 1;
          }
          $(event.currentTarget).val(itemsAmount);
          if (itemsAmount > _this.model.get('number')) {
            $(event.currentTarget).val(_this.model.get('number'));
            itemsAmount = _this.model.get('number');
          }
          return _this.$('.js-payment-amount').html((itemsAmount * parseFloat(_this.model.get('price'))).toFixed(2));
        };
      })(this));
    };

    PurchaseItemPopup.prototype.purchaseItem = function(event) {
      var corporationId, number, numberHelper, self;
      this.lockUI();
      self = this;
      number = this.$('.js-items-number').val();
      numberHelper = this.templateHelpers().numberHelper;
      if (numberHelper.isInteger(parseFloat(number))) {
        this.jsBack();
        corporationId = this.options.corporationId || 0;
        return app.server.tradeCenter.buyLot({
          exchangeId: this.model.get('id'),
          number: number,
          corporationId: corporationId,
          success: function(data) {
            app.vent.trigger('trade-center:item_purchased', {
              data: self.model.get('item_info')
            });
            if (app.gaEnabled) {
              app.ga('send', 'event', (self.model.get('currency')) + "buy", self.model.get('item_info').type_alias, self.model.get('item_type_id') + ": " + number, Number(self.model.get('price')));
            }
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Items purchased")
            });
          },
          error: function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          }
        });
      } else {
        this.unlockUI();
        return $('.js-int-error').removeClass('u-hide');
      }
    };

    PurchaseItemPopup.prototype.chooseAllItems = function() {
      console.log(123123, this._data.model.number);
      this.$('.js-items-number').val(this._data.model.number);
      return this.$('.js-items-number').trigger('change');
    };

    return PurchaseItemPopup;

  })(ItemView);
  return PurchaseItemPopup;
});
