define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/purchase-item.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    events: {
      'click .js-confirm': 'purchaseItem',
      'click .js-choose-all-items': 'chooseAllItems'
    },
    onRender: function() {
      return this.$('.js-items-number').change((function(_this) {
        return function(event) {
          var itemsAmount;
          itemsAmount = parseInt($(event.currentTarget).val());
          if (itemsAmount <= 0) {
            itemsAmount = 1;
          }
          $(event.currentTarget).val(itemsAmount);
          if (itemsAmount > _this.model.get('number')) {
            $(event.currentTarget).val(_this.model.get('number'));
            itemsAmount = _this.model.get('number');
          }
          return _this.$('.js-payment-amount').html(itemsAmount * _this.model.get('price'));
        };
      })(this));
    },
    purchaseItem: function() {
      var number, numberHelper;
      this.lockUI();
      number = this.$('.js-items-number').val();
      numberHelper = this.templateHelpers().numberHelper;
      if (numberHelper.isInteger(parseFloat(number))) {
        this.jsBack();
        return app.server.tradeCenter.buySharesLot({
          exchangeId: this.model.get('id'),
          number: number,
          success: function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Items purchased")
            });
          },
          error: function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          }
        });
      } else {
        this.unlockUI();
        return $('.js-int-error').removeClass('u-hide');
      }
    },
    chooseAllItems: function() {
      this.$('.js-items-number').val(this._data.model.number);
      return this.$('.js-items-number').trigger('change');
    }
  });
});
