var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/sell-item-maria.tmpl'], function(app, ItemView, _, template) {
  var SellItemMaria;
  SellItemMaria = (function(superClass) {
    extend(SellItemMaria, superClass);

    function SellItemMaria() {
      return SellItemMaria.__super__.constructor.apply(this, arguments);
    }

    SellItemMaria.prototype.template = template;

    SellItemMaria.prototype.events = {
      'click .js-confirm': 'purchaseItem'
    };

    SellItemMaria.prototype.onRender = function() {
      return this.$('.js-items-number').change((function(_this) {
        return function(event) {
          var itemsAmount, mariaBuying;
          itemsAmount = $(event.currentTarget).val();
          if (itemsAmount <= 0) {
            itemsAmount = 1;
          }
          $(event.currentTarget).val(itemsAmount);
          if (itemsAmount > _this.model.get('user_count')) {
            $(event.currentTarget).val(_this.model.get('number'));
            itemsAmount = _this.model.get('number');
          }
          mariaBuying = _this.model.get('need') - _this.model.get('quantity');
          if (itemsAmount > mariaBuying) {
            $(event.currentTarget).val(mariaBuying);
            itemsAmount = mariaBuying;
          }
          return _this.$('.js-payment-amount').html((itemsAmount * _this.model.get('price')).toFixed(2));
        };
      })(this));
    };

    SellItemMaria.prototype.purchaseItem = function(event) {
      var loader, number;
      this.lockUI();
      number = this.$('.js-items-number').val();
      if (!number) {
        number = 0;
      }
      loader = this.setLoaderOnElement(event.currentTarget, app.tr('Selling'));
      return app.server.tradeCenter.sellToCity({
        cityLotId: this.model.get('id'),
        number: number,
        success: (function(_this) {
          return function(data) {
            loader.remove();
            return _this.unlockUI();
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            loader.remove();
            _this.unlockUI();
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          };
        })(this)
      });
    };

    return SellItemMaria;

  })(ItemView);
  return SellItemMaria;
});
