var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/sell-item.tmpl', 'views/common/precision-check'], function(app, ItemView, _, template, precisionCheck) {
  var SellItemView;
  SellItemView = (function(superClass) {
    extend(SellItemView, superClass);

    function SellItemView() {
      return SellItemView.__super__.constructor.apply(this, arguments);
    }

    SellItemView.prototype.template = template;

    SellItemView.prototype.events = {
      'click .js-create-lot': 'createLot',
      'click .o-switcher': 'changeCurrency',
      'click .js-choose-all-items': 'chooseAllItems',
      'keyup .js-items-amount': function() {
        this.calcCommission();
        return this.calcPrice();
      },
      'keyup .js-items-price': function() {
        this.calcCommission();
        return this.calcPrice();
      }
    };

    SellItemView.prototype.changeCurrency = function(event) {
      $(event.currentTarget).toggleClass('o-switcher--active');
      if (this.$el.find('.o-switcher').hasClass('o-switcher--active')) {
        this.$('.js-commission-currency').addClass('o-icon--vgold');
        return this.$('.js-commission-currency').removeClass('o-icon--vdollar');
      } else {
        this.$('.js-commission-currency').addClass('o-icon--vdollar');
        return this.$('.js-commission-currency').removeClass('o-icon--vgold');
      }
    };

    SellItemView.prototype.createLot = function(event) {
      var amount, currency, loader, price;
      this.lockUI();
      amount = this.$('.js-items-amount').val();
      if (!amount) {
        amount = 0;
      }
      price = this.$('.js-items-price').val();
      if (!price) {
        price = 0;
      }
      currency = this.$el.find('.o-switcher').hasClass('o-switcher--active') ? 'vgold' : 'vdollars';
      if (precisionCheck(price)) {
        this.undelegateEvents();
        loader = this.setLoaderOnElement(event.currentTarget, app.tr('Selling'));
        return app.server.tradeCenter.createLot({
          itemTypeId: this.options.itemTypeId,
          amount: amount,
          price: price,
          currency: currency,
          success: (function(_this) {
            return function(data) {
              var adjustEvent;
              if (app.adjustEnabled) {
                adjustEvent = new app.adjust.AdjustEvent("nkgvi9");
                adjustEvent.addPartnerParameter('event_key', 'nkgvi9');
                app.adjust.Adjust.trackEvent(adjustEvent);
              }
              if (app.gaEnabled) {
                app.ga('send', 'event', "sell", _this.options.itemCategoryId, _this.options.itemTypeId + ": " + amount, parseInt(price));
              }
              loader.remove();
              _this.unlockUI();
              return app.screens.back();
            };
          })(this),
          error: (function(_this) {
            return function(data) {
              var options;
              loader.remove();
              _this.unlockUI();
              options = {
                msg: data.setFlash[0].msg || app.tr("Something went wrong"),
                onBack: function() {
                  return _this.delegateEvents();
                }
              };
              return app.screens.modal('common/info-popup', options);
            };
          })(this)
        });
      }
    };

    SellItemView.prototype.calcCommission = function() {
      var commissionPercent, commissionValue, formattedCommissionValue, itemsCount, pricePerItem, userHave;
      itemsCount = parseInt(this.$el.find('.js-items-amount').val());
      pricePerItem = parseFloat(this.$el.find('.js-items-price').val());
      userHave = parseInt(this.options.itemAmount);
      commissionPercent = this.options.lotCommission;
      if (isNaN(itemsCount)) {
        itemsCount = 0;
      }
      if (itemsCount > userHave) {
        itemsCount = userHave;
      }
      this.$el.find('.js-items-amount').val(itemsCount);
      if (isNaN(pricePerItem)) {
        pricePerItem = 0;
        this.$el.find('.js-items-price').val('');
      }
      commissionValue = parseFloat(itemsCount * pricePerItem * commissionPercent / 100);
      formattedCommissionValue = this.templateHelpers().formatNumber(commissionValue);
      return this.$el.find('.js-commission').html(formattedCommissionValue);
    };

    SellItemView.prototype.chooseAllItems = function() {
      this.$('.js-items-amount').val(this._data.options.itemAmount);
      return this.$('.js-items-amount').trigger('keyup');
    };

    SellItemView.prototype.calcPrice = function() {
      var formattedLotPrice, itemsCount, lotPrice, pricePerItem, userHave;
      itemsCount = parseInt(this.$el.find('.js-items-amount').val());
      pricePerItem = parseFloat(this.$el.find('.js-items-price').val());
      userHave = parseInt(this.options.itemAmount);
      if (isNaN(itemsCount)) {
        itemsCount = 0;
      }
      if (itemsCount > userHave) {
        itemsCount = userHave;
      }
      if (isNaN(pricePerItem)) {
        pricePerItem = 0;
      }
      lotPrice = parseFloat(itemsCount * pricePerItem);
      formattedLotPrice = this.templateHelpers().formatNumber(lotPrice);
      return this.$el.find('.js-lot-price').html(formattedLotPrice);
    };

    return SellItemView;

  })(ItemView);
  return SellItemView;
});
