var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/sell-stock.tmpl', 'views/common/precision-check'], function(app, ItemView, _, template, precisionCheck) {
  var SellStockView;
  SellStockView = (function(superClass) {
    extend(SellStockView, superClass);

    function SellStockView() {
      return SellStockView.__super__.constructor.apply(this, arguments);
    }

    SellStockView.prototype.template = template;

    SellStockView.prototype.events = {
      'click .js-create-lot': 'createLot',
      'click .o-switcher': 'changeCurrency',
      'click .js-choose-all-items': 'chooseAllItems',
      'keyup .js-items-amount': 'calcPrice',
      'keyup .js-items-price': 'calcPrice'
    };

    SellStockView.prototype.changeCurrency = function(event) {
      $(event.currentTarget).toggleClass('o-switcher--active');
      if (this.$el.find('.o-switcher').hasClass('o-switcher--active')) {
        this.$('.js-commission-currency').addClass('o-icon--vgold');
        this.$('.js-commission-currency').removeClass('o-icon--vdollar');
        this.$('.js-lot-currency').addClass('o-icon--vgold');
        return this.$('.js-lot-currency').removeClass('o-icon--vdollar');
      } else {
        this.$('.js-commission-currency').addClass('o-icon--vdollar');
        this.$('.js-commission-currency').removeClass('o-icon--vgold');
        this.$('.js-lot-currency').addClass('o-icon--vdollar');
        return this.$('.js-lot-currency').removeClass('o-icon--vgold');
      }
    };

    SellStockView.prototype.calcPrice = function() {
      var formattedLotPrice, itemsCount, lotPrice, pricePerItem, userHave;
      itemsCount = parseInt(this.$el.find('.js-items-amount').val());
      pricePerItem = parseFloat(this.$el.find('.js-items-price').val());
      userHave = parseInt(this.options.itemAmount);
      if (isNaN(itemsCount)) {
        itemsCount = 0;
      }
      if (itemsCount > userHave) {
        itemsCount = userHave;
      }
      if (isNaN(pricePerItem)) {
        pricePerItem = 0;
      }
      lotPrice = parseFloat(itemsCount * pricePerItem);
      formattedLotPrice = this.templateHelpers().formatNumber(lotPrice);
      return this.$el.find('.js-lot-price').html(formattedLotPrice);
    };

    SellStockView.prototype.createLot = function(event) {
      var amount, currency, loader, numberHelper, price;
      this.lockUI();
      amount = this.$('.js-items-amount').val();
      numberHelper = this.templateHelpers().numberHelper;
      if (numberHelper.isInteger(parseFloat(amount))) {
        if (!amount) {
          amount = 0;
        }
        price = this.$('.js-items-price').val();
        if (!price) {
          price = 0;
        }
        currency = this.$el.find('.o-switcher').hasClass('o-switcher--active') ? 'vgold' : 'vdollars';
        if (precisionCheck(price)) {
          loader = this.setLoaderOnElement(event.currentTarget, app.tr('Selling'));
          return app.server.tradeCenter.createStockLot({
            corporationId: this.options.corporationId,
            amount: amount,
            price: price,
            currency: currency,
            success: (function(_this) {
              return function(data) {
                loader.remove();
                app.screens.back();
                return _this.unlockUI();
              };
            })(this),
            error: (function(_this) {
              return function(data) {
                loader.remove();
                _this.unlockUI();
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              };
            })(this)
          });
        }
      } else {
        this.unlockUI();
        return $('.js-int-error').removeClass('u-hide');
      }
    };

    SellStockView.prototype.onRender = function() {
      this.$('.js-items-amount').change((function(_this) {
        return function(event) {
          var amount, userHave;
          amount = parseInt($(event.currentTarget).val());
          if (amount <= 0) {
            amount = 1;
          }
          $(event.currentTarget).val(amount);
          userHave = parseInt(_this.options.amount);
          if (isNaN(amount)) {
            return $(event.currentTarget).val(0);
          } else if (amount > userHave) {
            $(event.currentTarget).val(userHave);
            return _this.$('.js-commission').html((userHave * parseFloat(_this.options.lotComission)).toFixed(2));
          } else {
            return _this.$('.js-commission').html((amount * parseFloat(_this.options.lotComission)).toFixed(2));
          }
        };
      })(this));
      return this.$('.js-items-price').change((function(_this) {
        return function(event) {
          var price;
          price = parseFloat($(event.currentTarget).val());
          if (!isNaN(price)) {
            return $(event.currentTarget).val(price.toFixed(2));
          } else {
            return $(event.currentTarget).val("0.00");
          }
        };
      })(this));
    };

    SellStockView.prototype.chooseAllItems = function() {
      this.$('.js-items-amount').val(this._data.options.amount);
      return this.$('.js-items-amount').trigger('change');
    };

    return SellStockView;

  })(ItemView);
  return SellStockView;
});
