var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/sell.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  var SellSection;
  SellSection = (function(superClass) {
    extend(SellSection, superClass);

    function SellSection() {
      return SellSection.__super__.constructor.apply(this, arguments);
    }

    SellSection.prototype.template = template;

    SellSection.prototype.data = {
      userLots: 'tradeCenter.userLots',
      userCurrencyLots: 'tradeCenter.userCurrencyLots',
      userStockLots: 'tradeCenter.userStockLots'
    };

    SellSection.prototype.events = {
      'click .js-lot-settings': 'lotSettings',
      'click .js-currency-lot-settings': 'currencyLotSettings',
      'click .js-stock-lot-settings': 'stockLotSettings',
      'click .js-select': 'cityBuyouts'
    };

    SellSection.prototype.lotSettings = function(event) {
      var lotId, lotInfo, lotsCollection;
      this.lockUI();
      lotId = event.currentTarget.getAttribute('data-lot-id');
      lotsCollection = new Backbone.Collection(this._data.userLots.exchanges);
      lotInfo = lotsCollection.get(lotId);
      return app.screens.dialog('trade-center/lot-settings', {
        model: lotInfo,
        commission: this._data.userLots.commission
      });
    };

    SellSection.prototype.currencyLotSettings = function(event) {
      var lotId, lotInfo, lotsCollection;
      this.lockUI();
      lotId = event.currentTarget.getAttribute('data-lot-id');
      lotsCollection = new Backbone.Collection(this._data.userCurrencyLots.offers);
      lotInfo = lotsCollection.get(lotId);
      return app.screens.dialog('trade-center/currency-lot-settings', {
        model: lotInfo
      });
    };

    SellSection.prototype.stockLotSettings = function(event) {
      var lotId, lotInfo, lotsCollection;
      this.lockUI();
      lotId = event.currentTarget.getAttribute('data-lot-id');
      lotsCollection = new Backbone.Collection(this._data.userStockLots.exchanges);
      lotInfo = lotsCollection.get(lotId);
      return app.screens.dialog('trade-center/stock-lot-settings', {
        model: lotInfo
      });
    };

    SellSection.prototype.cityBuyouts = function(event) {
      this.lockUI();
      return app.screens.dialog('trade-center/lots-cityHall');
    };

    SellSection.prototype.onDomRefresh = function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        if (el.dataset.precision) {
          return el.innerHTML = formatCurrency(el.innerHTML, void 0, el.dataset.precision);
        } else {
          return el.innerHTML = formatCurrency(el.innerHTML);
        }
      });
    };

    return SellSection;

  })(ItemView);
  return SellSection;
});
