define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/shares.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      'items': {
        pointer: 'tradeCenter.stocksByCorporation',
        itemName: function() {
          if (this.options.itemName != null) {
            return this.options.itemName;
          } else {
            return null;
          }
        }
      }
    },
    events: {
      'click .js-shares-lot': 'showLots',
      'change .c-input': 'itemSearch'
    },
    showLots: function(event) {
      var corporationId, currency;
      this.lockUI();
      currency = event.currentTarget.getAttribute('data-currency');
      corporationId = event.currentTarget.getAttribute('data-corporation-id');
      return app.screens.dialog('trade-center/shares-corporation', {
        currency: currency,
        corporationId: corporationId
      });
    },
    itemSearch: function(event) {
      this.lockUI();
      event.preventDefault();
      this.options.itemName = this.$el.find('.c-input').val();
      return this.reload();
    }
  });
});
