define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/stocks-sell-grouped.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  return ItemView.extend({
    template: template,
    data: {
      'stocks': {
        pointer: 'tradeCenter.availableStock'
      }
    },
    events: {
      'click .js-items-lot': 'sell'
    },
    sell: function(event) {
      var amount, corporationId, name;
      this.lockUI();
      corporationId = event.currentTarget.getAttribute('data-corporation-id');
      name = event.currentTarget.getAttribute('data-name');
      amount = event.currentTarget.getAttribute('data-amount');
      return app.screens.dialog('trade-center/sell-stock', {
        corporationId: corporationId,
        name: name,
        amount: amount
      });
    },
    onDomRefresh: function() {
      app.chat.updateMsgCounter();
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    }
  });
});
