define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/trade-center-business.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      items: {
        pointer: 'tradeCenter.companyItemGroups',
        companyId: function() {
          return this.options.companyId;
        }
      }
    },
    events: {
      'click .js-items-category': 'gotoCategory'
    },
    gotoCategory: function(event) {
      var category, companyId;
      this.lockUI();
      category = event.currentTarget.getAttribute('data-category-id');
      companyId = this.options.companyId;
      return app.screens.dialog('trade-center/items-buy-grouped-business', {
        category: category,
        companyId: companyId
      });
    }
  });
});
