define(['app', 'views/item-view', 'underscore', 'text!templates/tutor/entrance-2.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    tutor_message: app.tr('TUTOR_ENTRANCE_2_MSG'),
    events: {
      'click .js-next-screen': 'nextScreen'
    },
    nextScreen: function(event) {
      app.tutorial.saveStep(app.tutorial.TUTORIAL_INITIAL, 2);
      app.modalDialog.screen('tutor/entrance/entrance-3');
      return $('.c-header__menu-button').removeClass('c-pulsate js-next-screen');
    },
    onDomRefresh: function() {
      var $rect, cssObj, rect;
      $('.c-header__menu-button').addClass('c-pulsate');
      $rect = $('.c-header__menu-button');
      rect = $('.c-header__menu-button').get(0);
      cssObj = {
        width: $rect.outerWidth(),
        height: $rect.outerHeight(),
        left: rect.getBoundingClientRect().left,
        top: rect.getBoundingClientRect().top
      };
      return $('.js-next-screen').css(cssObj);
    }
  });
});
