var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['underscore', 'app', 'views/tutor/base-pulsate'], function(_, app, PulsateView) {
  var Tutorial;
  Tutorial = (function(superClass) {
    extend(Tutorial, superClass);

    function Tutorial() {
      return Tutorial.__super__.constructor.apply(this, arguments);
    }

    Tutorial.prototype.className = 'o-tutor quests-1';

    Tutorial.prototype._controlSelector = '.js-tutor-quests';

    Tutorial.prototype._wrapperSelector = '.js-menu';

    Tutorial.prototype.allow_html = true;

    Tutorial.prototype.tutor_message = app.tr('TUTOR_ENTRANCE_7_MSG');

    Tutorial.prototype.events = function() {
      return _.extend({}, PulsateView.prototype.events, {
        'click .js-goto-url-wiki': 'openWikiUrl'
      });
    };

    Tutorial.prototype.openWikiUrl = function() {
      var adjustEvent, key, url;
      if (app.adjustEnabled) {
        key = 'j29lsp';
        adjustEvent = new app.adjust.AdjustEvent(key);
        adjustEvent.addPartnerParameter('event_key', key);
        app.adjust.Adjust.trackEvent(adjustEvent);
      }
      url = app.config.wikiURL;
      url = url + (url.indexOf('?') === -1 ? '?' : '&') + 'setlang=' + app.translations.getLn();
      return window.open(url, '_system');
    };

    Tutorial.prototype.nextScreen = function(event) {
      app.tutorial.saveStep(app.tutorial.TUTORIAL_INITIAL, 7);
      app.tutorial.completeTutorial(app.tutorial.TUTORIAL_INITIAL);
      app.tutorial.startNextTutorial();
      $(this._controlSelector).removeClass('c-pulsate js-next-screen').click();
      return app.menu.closeGroup("information");
    };

    return Tutorial;

  })(PulsateView);
  return Tutorial;
});
