var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/tutor/base-pulsate'], function(app, PulsateView) {
  var TutorRankPointView;
  TutorRankPointView = (function(superClass) {
    extend(TutorRankPointView, superClass);

    function TutorRankPointView() {
      return TutorRankPointView.__super__.constructor.apply(this, arguments);
    }

    TutorRankPointView.prototype.tutor_message = app.tr('TUTOR_FIGHT_RANK_POINTS_POPUP_MSG');

    TutorRankPointView.prototype._controlSelector = '.js-tutor-rank-point';

    TutorRankPointView.prototype._wrapperSelector = '.js-tutor-combat-skills-wrapper';

    TutorRankPointView.prototype.initialize = function(options) {
      TutorRankPointView.__super__.initialize.call(this, options);
      return this.listenTo(app.screens.current, "points:left", function(points) {
        if (points > 0) {
          return app.modalDialog.screen('tutor/fight-tutor/fight-rank-points-popup-updated');
        } else {
          return app.modalDialog.screen('tutor/fight-tutor/fight-rank-points-popup-close');
        }
      });
    };

    TutorRankPointView.prototype.nextScreen = function(event) {
      var selectorId;
      if (app.config.googleAnalyticsEnabled && app.ga) {
        app.ga('send', 'tutorpageview', {
          page: '/scr/military-base/combat-skills-popup'
        });
      }
      app.tutorial.saveStep(app.tutorial.TUTORIAL_GANGFIGHT, 9);
      $(this._controlSelector).removeClass('c-pulsate js-next-screen');
      selectorId = $(event.currentTarget).attr('data-tutor-selector-id');
      return $(this._controlSelector + "[data-tutor-selector-id=" + selectorId + "]").click();
    };

    TutorRankPointView.prototype.onRender = function(event) {
      return $('.js-tutor-rank-point .c-icon-plus-squared').css("background-size", "75%");
    };

    return TutorRankPointView;

  })(PulsateView);
  return TutorRankPointView;
});
