define(['app', 'views/item-view', 'underscore', 'text!templates/tutor.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    events: {
      'click .o-click-area': 'nextScreen'
    },
    nextScreen: function(event) {
      return app.quests.whenQuestFinished('tutorial_trauma').then(function() {
        var adjustEvent;
        if (app.adjustEnabled) {
          adjustEvent = new app.adjust.AdjustEvent("fywykl");
          adjustEvent.addPartnerParameter('event_key', 'fywykl');
          app.adjust.Adjust.trackEvent(adjustEvent);
        }
        app.tutorial.saveStep(app.tutorial.TUTORIAL_TRAUMA, 9);
        app.screens.closeCurrentModals();
        return app.modalDialog.screen('tutor/injury-9');
      });
    },
    onBeforeRender: function(event) {
      return this.options.message = app.tr("You healthy! Don't forget to go to the hospital when injured.");
    }
  });
});
