var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/users/profile.tmpl', 'text!templates/inventory/item.tmpl'], function(app, ItemView, _, template, itemTemplate) {
  var PrifileView;
  PrifileView = (function(superClass) {
    extend(PrifileView, superClass);

    function PrifileView() {
      return PrifileView.__super__.constructor.apply(this, arguments);
    }

    PrifileView.prototype.template = template;

    PrifileView.prototype.itemTemplate = itemTemplate;

    PrifileView.prototype.events = {
      'click .js-goto-conversation': 'gotoConversation',
      'click .js-add-friend': 'onFriendAdd',
      'click @ui.close': 'dropdownBehaviour',
      'click .js-select-profstats': 'selectProfStats',
      'click .js-select-combatstats': 'selectCombatStats',
      'click .js-view-medals': 'onViewMedals'
    };

    PrifileView.prototype.data = {
      info: {
        pointer: 'user.profile',
        userId: function() {
          return this.options.userId;
        },
        locale: function() {
          return this.app.translations.getLocale();
        }
      }
    };

    PrifileView.prototype.ui = {
      close: '.dropdown__title'
    };

    PrifileView.prototype.initialize = function() {
      PrifileView.__super__.initialize.apply(this, arguments);
      return this.options.itemTemplate = _.template(this.itemTemplate);
    };

    PrifileView.prototype.preprocessData = function(data) {
      var equippedItemsBySlot;
      equippedItemsBySlot = {};
      if (data.info.wear.length !== 0) {
        data.info.wear.forEach(function(item) {
          return equippedItemsBySlot[item.equipped_slot] = item;
        });
      }
      data.equippedItems = equippedItemsBySlot;
      return data;
    };

    PrifileView.prototype.gotoConversation = function(event) {
      return app.screens.dialog('messages/conversations', {
        userId: this.options.userId
      });
    };

    PrifileView.prototype.onViewMedals = function(event) {
      var userId;
      event.stopPropagation();
      userId = event.currentTarget.getAttribute('data-id');
      return app.screens.dialog('profile/user_awards', {
        userId: userId
      });
    };

    PrifileView.prototype.onFriendAdd = function(event) {
      var friendId, self;
      event.stopPropagation();
      self = this;
      friendId = event.currentTarget.getAttribute('data-id');
      return app.server.friends.add_request({
        friendId: friendId,
        success: function(data) {
          var ref;
          if (!data.error) {
            app.vent.trigger('friends:friendship_requested', {
              user: self._data.info.user
            });
            event.currentTarget.classList.add('profile-invisible');
          }
          return app.screens.modal('common/info-popup', {
            msg: (data != null ? (ref = data.setFlash[0]) != null ? ref.msg : void 0 : void 0) || app.tr('Server error')
          });
        }
      });
    };

    PrifileView.prototype.dropdownBehaviour = function(e) {
      var dropdown;
      dropdown = $(e.currentTarget).closest('.dropdown');
      dropdown.toggleClass('is-active');
      dropdown.find('.dropdown__title icon').toggleClass('o-icon--right-arrow o-icon--down-arrow');
      return dropdown.find('.dropdown__details').toggle();
    };

    PrifileView.prototype.selectProfStats = function(event) {
      var isActive;
      isActive = event.currentTarget.getAttribute('active');
      if (isActive === 'true') {
        event.currentTarget.setAttribute('src', './images/profile/profile_profstats_1.png');
        event.currentTarget.setAttribute('active', 'false');
        return $('.js-profstats').hide();
      } else {
        event.currentTarget.setAttribute('src', './images/profile/profile_profstats_2.png');
        $('.js-select-combatstats').attr('src', './images/profile/profile_combatstats_1.png');
        $('.js-select-combatstats').attr('active', 'false');
        event.currentTarget.setAttribute('active', 'true');
        $('.js-profstats').show();
        return $('.js-combatstats').hide();
      }
    };

    PrifileView.prototype.selectCombatStats = function(event) {
      var isActive;
      isActive = event.currentTarget.getAttribute('active');
      if (isActive === 'true') {
        event.currentTarget.setAttribute('src', './images/profile/profile_combatstats_1.png');
        event.currentTarget.setAttribute('active', 'false');
        return $('.js-combatstats').hide();
      } else {
        event.currentTarget.setAttribute('src', './images/profile/profile_combatstats_2.png');
        $('.js-select-profstats').attr('src', './images/profile/profile_profstats_1.png');
        $('.js-select-profstats').attr('active', 'false');
        event.currentTarget.setAttribute('active', 'true');
        $('.js-combatstats').show();
        return $('.js-profstats').hide();
      }
    };

    return PrifileView;

  })(ItemView);
  return PrifileView;
});
